@make(text)
@device(postscript)
@style(spacing 1, spread 1, justification off, hyphenation on,
fontscale 12)
@begin(center)
@begin(heading,size 12.5,use b)
CONDITIONS FOR COMMERCIAL DISTRIBUTION OF KERMIT SOFTWARE
@end(heading)

Kermit Development and Distribution
Columbia University Academic Information Systems
New York, NY, USA

@i<January 1993>
@end<center>

Kermit software is not in the public domain.  It is copyright by the Trustees
of Columbia University in the City of New York.  Kermit software is
distributed and supported by Columbia University.  The Kermit development and
distribution effort is self-sustaining, funded by income from mail-order
software distribution and by sales of published documentation.

Kermit software may be distributed by commercial enterprises under the
conditions enumerated in this document.  Commercial distribution includes
bundling of Kermit software with hardware or software products; furnishing
Kermit software to institutions or corporations under contract; furnishing
Kermit software to government or military agencies through a government
contract, and similar arrangements.

The conditions are:

@begin(enumerate)
The supplier must furnish each end-user at the customer site with a copy
of the pertinent manual.  This helps make the end-users self sufficient,
thus reducing the burden on the supplier's (and Columbia University's)
help desk.  In the case of commercially published manuals (for which
quantity discounts are available), this arrangement helps to fund Columbia
University's Kermit support and development efforts.  "End-user" is
defined as the user of a workstation (e.g. a PC with MS-DOS or OS/2, a
UNIX or VMS workstation, etc) that is running Kermit software, including
users of PCs who run Kermit software from a LAN file server.  When Kermit
software is installed on a shared minicomputer or mainframe, then the
pertinent documentation should be supplied in sufficient quantity for the
user population, e.g. a book per department or floor or site, so that each
user has ready access to the documentation for the centrally-installed
Kermit software.

The supplier must not modify the Kermit software source code without
consent of Columbia University.  If changes are needed, they must be
coordinated through Columbia University so they can be supported and
carried forward in new releases.  The supplier can, of course, produce
tailored initialization files, command files, macros, scripts, tip sheets,
and similar material that does not involve changes to the Kermit software
source code.

The supplier must not modify, remove, or obscure any copyright notices
that appear in the software or documentation.

The supplier acknowledges that the Kermit software and documentation are
provided as is; no other warranty is provided, express or implied,
including without limitation, any implied warranty of merchantability or
implied warranty of fitness for a particular purpose.  Neither the
supplier nor the end-users shall hold liable the authors of any Kermit
software programs, publications or documentation nor Columbia University,
Digital Press, nor any other contributing institution or individual for
program or documentation errors.
@end(enumerate)

@begin(description,leftmargin +4, indent -4,need 4)
@b<MS-DOS Kermit> is the Kermit software for IBM PCs, PS/2s, and compatibles
running @w<MS-DOS> or Microsoft Windows.  The documentation is @i"Using MS-DOS
Kermit", Second Edition, by Christine M. Gianone, Digital Press, Burlington,
MA (1992).  German and French language editions are also available.

@b<C-Kermit> is the Kermit software for UNIX, VAX/VMS, OpenVMS, OS/2, AOS/VS,
OS-9, the Commodore Amiga, and the Atari ST.  The documentation is @i"Using
C-Kermit" by Frank @w<da Cruz> and Christine M. Gianone, Digital Press,
Burlington, MA (1993).  German and French editions are in preparation.
@end(description)

Other Kermit versions, for which commercially published documentation is not
yet available, may be distributed under the terms listed above.  In this case,
documentation is furnished online as part of the software distribution and may
be accessed online by the supplier and/or the end-user.  Should commercially
published documentation become available at a later date, the same terms will
apply as those that now apply to MS-DOS Kermit and C-Kermit.

To obtain permission to distribute Kermit software to its customers, the
supplier should write a letter describing its intentions and agreeing to the
terms listed in this document to:

@begin<format,above 1, below 1, leftmargin +4>
@tabclear()
Christine M. Gianone, Manager
Kermit Development and Distribution
Columbia University
612 West 115th Street
New York, NY  10025  USA
Telephone: @^+1 212 854-5126
Fax:@\+1 212 662-6442  @i<or>  (212) 663-8202
@end<format>

Use the same address for inquiries regarding ordering information, packaging
options, formats, quantity discount schedules, support options, training,
custom development, and similar information.
