@Make(text)
@device(PostScript)
@String<VersionDate="July 1993">
@Style<Justification On, Hyphenation On, WidestBlank 1.4, Spacing 1,
  Spread 0.5, Indent 0, HyphenBreak Off, SingleSided,
  WidowAction Force, OrphanAction Force>
@Modify<Format,Above 1,Below 1>
@Define<QQ,FaceCode R,AfterEntry=["],BeforeExit=["]>
@Define<bk,FaceCode R,AfterEntry=["],BeforeExit=["]>
@define(subx,use subheading,break off,justification off,spaces compact)
@textform{endash='-'}
@textform<pt="@hsp(1pt)">
@textform<jx="@hsp(-0.5pt)">
@textform<j="@hsp(-1.0pt)">
@textform<jj="@hsp(-1.7pt)">
@textform<dd="--">
@textform{chkbox="[ ]"}
@define{dq,AfterEntry=["],BeforeExit=["]}
@define<xx,use R>
@libraryfile<mathematics10>
@libraryfile<figures>
@libraryfile<stable>
@textform{taba="@case[device,file='@tabset(6,58)',
else='@tabset(0.25inch,4.0inch)']"}
@textform{tabb="@case[device,file='@tabset(60)',else='@tabset(4.75inch)']"}
@textform{tabc="@case[device,file='@tabset(6,12,58)',
else='@tabset(0.4inch,0.7inch,4.0inch)']"}
@textform{tabd="@case[device,file='@tabset(6,45)',
else='@tabset(0.25inch,3.75inch)']"}
@textform{tabe="@case[device,file='@tabset(6,22,58)',
else='@tabset(0.5inch,1.5inch,5.5inch)']"}
@textform{tabf="@case[device,file='@tabset(6,36,50,68)',
else='@tabset(0.5inch,2.5inch,3.5inch,5.5inch)']"}
@textform{tabg="@case[device,file='@tabset(8,14,68)',
else='@tabset(0.3inch,0.7inch,5.5inch)']"}
@textform{tabh="@case[device,file='@tabset(6,22,36,50,68)',
else='@tabset(0.5inch,1.5inch,2.5inch,3.5inch,5.5inch)']"}
@textform{tabi="@case[device,file='@tabset(67)',else='@tabset(4.6inch)']"}
@textform{tabj="@case[device,file='@tabset(67)',else='@tabset(4.5inch)']"}
@textform{tabk="@case[device,file='@tabset(6,24,68)',
else='@tabset(0.5inch,1.5inch,5.5inch)']"}
@Case<Device,
 File="@style(justification off, hyphenation off)
    @modify(format,longlines keep)
    @modify(insert,longlines keep)",
 Postscript="
    @libraryfile<accents>
    @style<fontscale 10,doublesided>
    @Style<BottomMargin 0.8inch>
    @Modify<Itemize,spread 0.4,leftmargin 12pts,indent -12pts,
      rightmargin +12pts,
      numberlocation LFL,rightmargin +0,justification off,hyphenation on>
    @define(QQ,AfterEntry=[@r<`@hsp{-1pt}`>],BeforeExit=[@r<'@hsp{-1pt}'>])
    @define(bk,use i)
    @define(xx,use b)
    @textform{endash='@y[N]'}
    @textform{dd='@hsp<1pt>@+[_@hsp<-2pts>_]@hsp<1pt>'}
    @textform{chkbox=[@begin(transparent,size 12)@zf(r)@end(transparent)]}
    @define(DQ,AfterEntry=[@r<`@hsp{-1pt}`>],BeforeExit=[@r<'@hsp{-1pt}'>])"
>
@Pageheading[immediate,
left="@i<Since 1981>",
center="@b<Columbia University Academic Information Systems>",
right="@i<@value(versiondate)>",line="@bar()"]
@begin(MajorHeading)
THE KERMIT COMMUNIC@j()A@j()TION SOFTW@jj()ARE C@jx()A@j()T@j()ALOG
@end(MajorHeading)
@case[device,file="@begin<center>
Columbia University Academic Information Systems
@value<versiondate>
@end<center>"]
@Pageheading(odd,
left="@i<@value(versiondate)>",
center="@xx<The Kermit Software Catalog>",
right="@i<Page @value(page)>",
line="@bar()")
@Pageheading(even,
right="@i<@value(versiondate)>",
center="@xx<The Kermit Software Catalog>",
left="@i<Page @value(page)>",
line="@bar()")

@i<Kermit> is the low-cost, high-quality alternative to expensive commercial
communication software.  Kermit software incorporates Columbia University's
error-correcting Kermit protocol for transferring text and binary files
between computers of all sizes.  It is well documented and in wide use; it is
available for about 400 different computers and operating systems, written in
a wide variety of programming languages.  Source code is available for all
versions.

Kermit software works over direct or dialed serial connections, and often
over local and wide area networks too.  For file transfer to take
place, a Kermit program runs on @i<each> end of the connection, one on each
computer.  The most popular Kermit software programs are described below.
The complete collection is listed on pages 2@endash()3.

@bar()
@subheading(MS-DOS Kermit 3.13)

MS-DOS Kermit @b<3.13> runs on the entire @b<IBM PC> and @b<PS/2> families and
compatibles under @b<MS-DOS> versions 2.0 through 6.0, directly under DOS or
in Microsoft @b<Windows>.  MS-DOS Kermit is packaged on diskette with the book
@bk<Using MS-DOS Kermit> by Christine M@. Gianone, Digital Press (1992).

MS-DOS Kermit's terminal emulations include DEC VT320 and VT220 (international
models), VT102, VT100, VT52, Data General @c<DASHER> D463 and D470,
Heath/@|Zenith-19, plus Tektronix 4014 and Sixel graphics.  Terminal emulation
features include screen rollback, capture, copy, and print; 132-column mode;
horizontal scrolling; key mapping and macros; comprehensive character-set
support; a compose key for entering accented letters; color text and graphics;
much more.

@b<File transfer> features include long packets, sliding windows, dynamic
packet length, locking shifts, con@_trol-@|character @dq<unprefixing,> and
international character-set conversion for Western and Eastern European
languages, Cyrillic, Hebrew, and Japanese.  @b<Automation features> include
command macros, command files, and a powerful, easy-@|to-@|use script
programming language.

Serial connections are supported for @c<COM1>@endash()@c<COM4> at speeds up to
at least 57,600 bps; RTS/CTS hardware flow control is available for use with
high-@|speed modems.  Automatic modem dialing scripts are included for Hayes,
Telebit, US Robotics, Practical Peripherals, and other modems, and there is an
easy-@|to-@|use dialing directory.  @b<Network support> includes TCP/IP
(built-in, with up to @i<six concurrent sessions>), AT&T StarLAN / StarGROUP,
DEC PATHWORKS, IBM NETBIOS, IBM LANACS, Novell NASI/@|NACS, Novell LWP TELAPI,
3COM BAPI, Beame & Whiteside TCP/IP, Intel OpenNET, Ungermann Bass Net/@|One,
Interconnections TES, as well as BIOS Interrupt 14 support for
externally-@|established network connections.  TCP/IP connections require a
@i<packet driver> (Ethernet or SLIP class) or an @i<ODI driver>, and can
coexist with Novell IPX connections.

@bar()
@subheading(C-Kermit 5A)

C-Kermit 5A(189) is the Kermit software for @b<UNIX>, @b<VAX/VMS>, @b<OpenVMS
VAX> and @b<AXP>, IBM @b<OS/2>, Data General @b<AOS/VS>, Microware @b<OS-9>,
Apollo @b<Aegis>, the Commodore @b<Amiga>, and the @b<Atari ST>.
C-Kermit supports
all the same advanced Kermit file transfer capabilities as MS-DOS Kermit 3.13.
Communications features include key mapping and keystroke macros, automatic
dialing, a dialing directory, terminal connection (the OS/2 version also
includes built-in VT102 emulation), TCP/IP and other network support in the
UNIX, VMS, OS/2, and AOS/VS versions, a powerful script programming
language, and international character-@|set conversion for both file transfer
and terminal connection.
C-Kermit software comes with the book @bk"Using
C-Kermit" by Frank @w<da Cruz> and Christine M@. Gianone, Digital Press
(1993), a step-@|by-@|step introduction and a comprehensive reference.

@bar()
@subheading(IBM Mainframe Kermit 4.2)

IBM mainframe Kermit Version 4.2 for @b<VM/CMS>, @b<MVS/TSO>, @b<CICS>, and
@b<MUSIC> supports advanced Kermit protocol features including long packets
and international character sets, and it works with a wide variety of
communication processors in linemode and protocol converters in 3270 fullscreen
mode.  The program is distributed in IBM 370 assembly language source-@|code
form with complete online instructions for building and using.
@bar()
@subheading<The Kermit Protocol Specification>
The Kermit protocol specification, complete with C-language programming
examples, is given in the book @bk<Kermit, A File Transfer Protocol> by Frank
@w<da Cruz>, Digital Press (1987), which also includes an overview of
what Kermit is for and how it works, with tutorials in computer file systems
and data communications.
@blankspace(0.5)
@bar()
@newpage()
@pagefooting(immediate,line="@bar<>")
@case[device,
  postscript="@include(aavsys.mss)",
  else="@begin(verbatim)
    @include(/pub/ftp/kermit/a/aavsys.hlp)
    @end(verbatim)"
]
@pagefooting(line="")
@modify(subheading,above 1.5)
@case[device,file='@blankspace(1lines)',else='@newpage()']
@subheading(KERMIT DISTRIBUTION MEDIA)

Kermit software is distributed by Columbia University on magnetic tape,
tape cartridges, and certain diskette formats.  Tapes and cartridges
include all source code and supporting files in machine-@|readable form for
each Kermit implementation, and in some cases also binaries (encoded in hex or
other printable format).  Diskettes have no source code except when noted on
the order form.

Kermit software programs are collected on six reel-@|to-@|reel 9-track tapes:
A, B, C, D, E, and F.  The programs are assigned to tapes A@endash()F as
shown in the second column of the Kermit version list as follows: Tape A has
the MS-DOS, CP/M-80, and Apple II versions.  Tape B has the IBM mainframe and
DEC PDP-11 versions.  Tape F has C-Kermit.  Tape C has other miscellaneous
microcomputer, PC, and workstation versions.  Tape D has other miscellaneous
minicomputer and mainframe versions.  Tape E contains machine-@|readable
copies of the Kermit protocol manual, various other manuals, articles, the
Info-Kermit Digest, newsletters, a character-set-aware text-to-PostScript
printing utility, and tape utilities.  Tapes and cartridges are available in
these formats:

@begin(description,leftmargin +8,indent -8,spread 0.35,above 0.8,below 0.8)
@b<ANSI:>@\ANSI labeled ASCII, format D (variable length records),
blocksize 8192.  9-track, half-@|inch, reel-@|to-@|reel, 1600 bpi.
Readable by many computer systems, including VAX/VMS. 

@b<TAR:>@\UNIX @c<TAR> format, blocksize 10240, 9-track, 1600 bpi.

@b<OS:>@\IBM OS standard labeled EBCDIC, format VB (variable length records),
blocksize 8192, 9-track, 1600 bpi, for MVS, CMS, and other mainframe systems.
IBM VM/CMS users should order the OS format and use one of the included
tape-@|reading programs to read the tape on a CMS system; printed instructions
are included with the OS tape.

@b<TK50:>@\TK50 tape cartridge for the DEC MicroVAX or VAXstation.
VMS @c<BACKUP> format.  Also readable by TZ30, TK70, and compatible drives.

@b<QIC:>@\UNIX @c<TAR>-format quarter-@|inch tape cartridge.  Readable on Sun
computers, IBM RS/6000, SCO systems, and other UNIX systems equipped with
QIC cartridge drives.


@b<8MM:>@\EXABYTE 8-millimeter cassette, UNIX @c<TAR> format.
@end(description)
Diskettes formats are 5.25-inch 360K and 3.5-inch 720K.

@subheading(NEWS AND UPDATES)

Our newsletter, @i<Kermit News>, is mailed periodically free of charge to all
our Kermit
customers to bring news of Kermit software releases and related developments.
Ordering any Kermit material from us automatically adds you to the subscriber
list.  We do not have the resources to send automatic software updates.  Use
the order form to obtain new versions of the Kermit software, or call +1 212
854-3703 for inquiries.

@subheading(TERMS AND CONDITIONS) 
@label<-terms>

The Kermit software@dd()including source code@dd()is furnished without
warranty of any kind, and neither Columbia University, nor the individual
authors or publishers, nor any institution that has contributed Kermit
material, acknowledge any liability for any claims arising from the use of
Kermit.  Since source code is available, users may fix
bugs and make improvements, and are encouraged to contribute their work back
to Columbia for further distribution.

Kermit software may be ordered by private individuals, corporations, academic
or government institutions, and other organizations for their own internal
use, but the software may not be resold or otherwise redistributed to external
clients, customers, or contractors without written permission of the Manager
of Kermit Development and Distribution at Columbia University.  Contact us for
further information.

@b<TO ORDER FROM COLUMBIA UNIVERSITY>, fill out and return the enclosed order
form.  PREPAYMENT by credit card or check is encouraged; an additional ORDER
PROCESSING FEE is required if we must send an invoice.  Orders are shipped by
delivery service or US mail, normally within 2@endash()4 weeks of receipt, but
firm delivery schedules or methods cannot be guaranteed.  Prices are in US
dollars and include shipping costs.  When two prices are shown (like $100 /
$135), the first price applies to the USA, Canada, and Mexico and the second
price is for shipments to other countries (exception: if you can supply with
your Federal Express account number, then pay the first price).  Rush
service is available for an extra fee.  Call +1 212 854-3703 for additional
ordering information.  Telephone and Fax orders are accepted if payment is by
Master Card or Visa.  Use the order form for Fax orders, and, for payment by
credit card, be sure to include your signature.

@blankspace(0.5)
@bar()
@newpage()
@modify(subheading,above 0.8)
@pageheading[Odd,
  left="(11.00, @value<versiondate>)",
  center="@b(KERMIT ORDER FORM, SIDE 1)",
  right="#@t<___________>",line="@bar()"
]
@pageheading[Even,
  right="(11.00, @value<versiondate>)",
  center="@b(KERMIT ORDER FORM, SIDE 2)",
  left="#@t<___________>",line="@bar()"
]
@pagefooting(odd,line="@bar()")
@pagefooting(even,center="")
@case<Device,File="@blankspace(1)KERMIT ORDER FORM:@blankspace(1)",
	else="@newpage()">
@begin<text,fill>
Prices, terms, and items are subject to change.  If this form is dated more
than 6 months prior, please contact us for new information.
Please order carefully since we CANNOT refund or exchange items.
Prices are in US dollars ($), first price for North America / second price for
shipping outside North America (unless you pay shipping).
@end<text>

@bar()
@b<9-TRACK MAGNETIC TAPE.>  Price: $100 / $135 @i<per tape:>
@tabclear()
@begin(format,tabexport false)
@case[device,file="
        ANSI TAR  OS            ANSI TAR  OS            ANSI TAR  OS 
Tape A: [ ]  [ ]  [ ]   Tape C: [ ]  [ ]  [ ]   Tape E: [ ]  [ ]  [ ]
Tape B: [ ]  [ ]  [ ]   Tape D: [ ]  [ ]  [ ]   (Order C-Kermit below)

",else="@tabset(0.6inch,1.0inch,1.4inch,2.0inch,2.6inch,3.0inch,3.4inch,
4.0inch,4.6inch,5.0inch,5.4inch)
@\ANSI@\TAR@\ OS@\@\ANSI@\TAR@\ OS@\@\ANSI@\TAR@\ OS
  Tape A:@\@t< >@chkbox()@\@t< >@chkbox()@\ @chkbox()@\@~
Tape C:@\@t< >@chkbox()@\@t< >@chkbox()@\ @chkbox()@\@~
Tape E:@\@t< >@chkbox()@\@t< >@chkbox()@\ @chkbox()
  Tape B:@\@t< >@chkbox()@\@t< >@chkbox()@\ @chkbox()@\@~
Tape D:@\@t< >@chkbox()@\@t< >@chkbox()@\ @chkbox()@\@~
@i(Order C-Kermit below . . .)"]
@tabclear()
@blankspace(.25)
@case[device,file="@tabset(68)",else="@tabset(5.5inch)"]
9-TRACK TAPE SUBTOTAL@ @). @\$@t<__________>
@tabclear()
@case[device, file="
@tabclear()
@bar()
TAPE CARTRIDGES.  Price: $150 / $185.  8MM     QIC     TK50
  Contents of Tapes A, B, and E:       [ ]     [ ]     [ ]
  Contents of Tapes C, D, and E:       [ ]     [ ]     [ ]
  (Order C-Kermit below...)

",else="@tabclear()@tabset(2.6inch,3.0inch,3.4inch,4.0inch)
@bar()
@b<TAPE CARTRIDGES.>  Price: $150 / $185.@\8MM@\QIC@\TK50
@blankspace(0.25)
  Contents of Tapes A, B, and E:@\@t< >@chkbox()@\ @chkbox()@~
@\@t< >@chkbox()
  Contents of Tapes C, D and E:@\@t< >@chkbox()@\ @chkbox()@~
@\@t< >@chkbox()@hsp<0.25inch>@i(Order C-Kermit below . . .)
"]
@tabclear()@case[device,file="@tabset(68)",else="@tabset(5.5inch)"]
@blankspace(.25)
TAPE CARTRIDGE SUBTOTAL@ @). @\$@t<__________>
@tabclear()
@bar()
@b<MS-DOS KERMIT>@tabe()
IBM PC/PS2 MS-DOS Kermit software@case[device,file='@*@ @ ',else='@ ']@~
with book @bk<Using MS-DOS Kermit>, $34.95 / $45:
@\@chkbox()@t< >5.25-inch @\@chkbox()@t< >3.5-inch:@ @~
@). @\$@t<__________>
IBM PC/PS2 MS-DOS Kermit utilities: $35 / $40:
@\@chkbox()@t< >5.25-inch @\@chkbox()@t< >3.5-inch:@ @~
@). @\$@t<__________>
MS-DOS IBM PC/PS2 Kermit source code,  $60 / $68:
@\@chkbox()@t< >5.25-inch @\@chkbox()@t< >3.5-inch:@ @~
@). @\$@t<__________>
@tabf()Crynwr (formerly Clarkson) packet drivers@case[device,file='@*']  for @~
the IBM PC family on DOS diskettes:
@\Binaries and Docs, $35 / $40:@\@chkbox()@t< >5.25-inch@\@~
@chkbox()@t< >3.5-inch@ @). @\$@t<__________>
@\Source Code, $60 / $68:@\@chkbox()@t< >5.25-inch@\@~
@chkbox()@t< >3.5-inch@ @). @\$@t<__________>
@bar()
@b<C-KERMIT 5A> (Tape F), includes book @bk<Using C-Kermit>:
@tabclear()@case[device,file="@tabset(68)",else="@tabset(5.5inch)"]
@chkbox()@t< >9-Track Tape, $135 / $170, Format: @ @~
@chkbox()@t< >ANSI,@t< >@chkbox()@t< >TAR@ @). @\$@t<__________>
@chkbox()@t< >@~
TK50 cartridge, DEC VMS / OpenVMS BACKUP format, $185 / $220@~
@ @). @\$@t<__________>
@chkbox()@t< >@~
Quarter-Inch Cartridge (QIC), UNIX tar format, $185 / $220@~
@ @). @\$@t<__________>
@chkbox()@t< >@~
8mm EXABYTE cartridge, UNIX tar format, $185 / $220@ @). @\$@t<__________>
@chkbox()@t< >@~
Source code on DOS-format diskettes, $100 / $115: @case[device,file='@* @ ']@~
@ @chkbox()@t< >3.5-inch,@t< >@chkbox()@t< >5.25-inch:@ @). @\$@t<__________>
@tabclear()@tabset(0.5inch,1.5inch,2.5inch,3.5inch,5.5inch)
@case[device,postscript='@blankspace(0.25)',else='@blankspace(1line)']
Binaries on DOS-format diskettes,@case[device,file='@*@ @ ',else=' ']@~
@bk<Using C-Kermit> book included, $45 / $50 each:@tabclear()@tabg()
@case[device,file='@ ']3.5"@\5.25"
 @chkbox()@\ @chkbox()@\C-Kermit for OS/2 1.xx, 16-bit@ @). @\$@t<__________>
 @chkbox()@\ @chkbox()@\C-Kermit for OS/2 2.00, 32-bit@ @). @\$@t<__________>
 @chkbox()@\ @chkbox()@\C-Kermit for OS-9/68000@ @). @\$@t<__________>
 @chkbox()@\ @chkbox()@\C-Kermit for Commodore Amiga@ @). @\$@t<__________>
 @chkbox()@\ @chkbox()@\C-Kermit for Atari ST@ @). @\$@t<__________>
@bar()
@tabclear()@case[device,file="@tabset(68)",else="@tabset(5.5inch)"]
@b<MACINTOSH KERMIT>
@chkbox()@t< >@i<Mac Kermit> 0.9(40) 1988 release, 3.5-inch, $25 / $30@~
@ @). @\$@t<__________>
@chkbox()@t< >@i<Mac Kermit> 0.99(???) latest prerelease, 3.5-inch, @~
$25 / $30@ @). @\$@t<__________>
@bar()
@b<LITERATURE>
@chkbox()@t< >Book: @bk<Kermit, A File Transfer Protocol:> $29.95 / $35@~
@ @). @\$@t<__________>
@chkbox()@t< >Book: @bk<Using C-Kermit> (without software): $34.95 / $45@~
@ @). @\$@t<__________>
@chkbox()@t< >Book: @bk<Using MS-DOS Kermit:> $34.95 / $45@~
@ @). @\$@t<__________>
@chkbox()@t< >Technical paper, Recent Kermit Protocol Extensions: $15 / $25@~
@ @). @\$@t<__________>
@tabk()Printed, paginated, indexed Kermit Digest volumes, $15 / $25 per year:
@\@chkbox()@t< >This year@\@chkbox()@t< >Last 2 years
@case[device,file='@*']@\@chkbox()@t< >Last 3 years@\@chkbox()@t< >@~
Last 4 years@). @\$@t<__________>
Manuals for Kermit programs: $10 / $13 each:
@tabh()@\@chkbox()@t< >IBM 370@\@chkbox()@t< >Apple II@\@chkbox()@t< >@~
PDP-11@\@chkbox()@t< >CP/M-80 @). @\$@t<__________>
@tabclear()@case[device,file="@tabset(68)",else="@tabset(5.5inch)"]
@blankspace(0.5)
@b<SIDE 1 SUBTOTAL> (please complete side 2 also)@ @). @\$@t<__________>
@end<format>
@case[device,file='@blankspace(1line)
@bar()
KERMIT ORDER FORM, SIDE 2
@blankspace(1line)',else='@newpage()']
@begin<text>
@tabb()
Shipping by UPS or post is included in the price.  Please do not add sales tax.
@begin<format,above 1,below 1,tabexport false>
@tabclear()@tabi()
@case[device,postscript='SUBTOTAL from Side 1: @ @). @\ $@t<__________>
']
@chkbox()@t< >Voluntary tax-deductible donation@case[device,
file='@*',
else='@ ']@i<(help support the Kermit effort) :> @ @). @\ $@t<__________>
@case<device,file='@blankspace[1line]'>@i<USA, CANADA, AND MEXICO ONLY:>
@chkbox()@t< >For PRIORITY HANDLING and NEXT-DAY SHIPMENT, add $30: @~
@ @). @\ $@t<__________>

@tabclear()@case[device,file="@tabset(67)",else="@tabset(5.5inch)"]
@b(A.)@ @ TOTAL MATERIALS, DONATION, AND SHIPPING: @ @). @\ $@t<__________>
@end<format>
@case[device,postscript="Please complete ONE of the numbered
sections@t< >@b<@zs(k)>@t< >@p<@ux[OR]>@t< >@b<@zs(l)>@t< >@p<@ux[OR]>@t< >@~
@b<@zs(m)>@pt<>, and then
fill in your shipping information.",else="Please complete ONE of the numbered
sections, 1, 2, OR 3, and then fill in your shipping information."]
@bar()
@begin(subheading,above 0.2line,below 0)
@case<device,postscript="@zs(k)",else="1."> @ PA@j()YMENT BY CREDIT CARD
@end(subheading)
@begin<format,tabexport false,above 0,below 0>
@tabclear()@tabd()
@chkbox()@t< >MasterCard@case<device,file='@ ',else='@hsp(0.4inch)'>@~
@chkbox()@t< >Visa@>AMOUNT OF YOUR PAYMENT @ (Line A above): @ $@t<__________ >

Card Number @&_@\ @ @ Expiration Date @&_

Signature @&_@\ @ @ Today's Date @&_
@end<format>
@bar()
@subheading[@case<device,postscript="@zs(l)",else="2."> @ PREPAYMENT BY CHECK]

Please enclose a check for the total amount, @i<payable in US dollars>.
PLEASE DO NOT MAKE ELECTRONIC BANK TRANSFERS OR SEND INTERNATIONAL POSTAL
COUPONS.  Make your check payable to:
@case[device,file="@begin(display)",else="@begin<display,use p,size +1>"]
Columbia University Kermit Distribution
@end<display>
@begin<format,tabexport false,below 0>
@tabclear()@tabj()
If your check is @i<not> drawn on a US bank,@case[device,file='@*',else=' ']@~
please add a $35 check-cashing fee:@\$@t<__________>

@tabclear()@case[device,file="@tabset(67)",else="@tabset(5.5inch)"]
TOTAL AMOUNT OF YOUR CHECK: @ @). @\ $@t<__________>
@end<format>
@bar()
@begin(subheading)
@case<device,
postscript="@zs(m)",
else="3."> @ PURCHASE ORDERS, NO CHECK, WE INVOICE YOU
@end(subheading)
@begin<format,above 0,below 0,tabexport false>
@tabclear()@tabset(4.5inch,5.5inch)
@b<B.> Amount from Line A above:@\$@t<__________>
@b<C.> Add $25 order processing (invoicing) fee:@\$@t<__________>
@b<D.> @~
If your check will @i<not> be drawn on a@case[device,file='@*@ @ @ ',
else='@ ']US bank, add $35 check-cashing fee:@\$@t<__________>
@tabclear()@case[device,file="@tabset(68)",else="@tabset(5.5inch)"]
@case[device,file='@blankspace<1line>']

TOTAL, Lines B, C, and D.@case[device,file='@*@ @ ',else='@ @ ']@~
  Please enclose your purchase order for this amount: @ @). @\$@t<__________>
@end<format>
@bar()
@begin(transparent,justification off,fill off,break after,below 1line)
@subx(SHIPPING INFORMATION) @ @ @~
(Do not use Post Office Box for UPS or Federal Express):
@end(transparent)
@tabclear()@case[device,file="
Name:__________________________________________________________________________

Organization:__________________________________________________________________

Address:_______________________________________________________________________

City:__________________________________ State/Province:________________________

ZIP or Postal Code: ___________________ Country: ______________________________

Telephone: ____________________________________________________________________
",else="
Name:_____________________________________ Organization:@)_

Address:@)_

City:_________________________State or Province:______________Zip or Postal Code:@)_

Country:__________________________________________________Phone:@)_
"]@blankspace(0.5)
@chkbox()@t< >To charge @i<your> Federal Express account, please provide
account number and authorized signature:
@tabclear()

Federal Express Account Number @&_

Signature @&_
@bar()
@subheading(MAIL YOUR COMPLETED ORDER FORM TO:)

@begin(format,leftmargin +6,below 1)
Kermit Distribution, Department OP
Columbia University Academic Information Systems
612 West 115th Street
New York, NY  10025-7721  USA
@end(format)
@begin<text,size -1>
Phone: +1 212 854-3703, FAX: +1 212 663-8202, @~
E-Mail: kermit@pt()@@columbia@pt()@b<.>@pt()edu. @~
Sorry, we can't respond by FAX.
@end<text>
@bar()
@>@i<Thank you!>
@end<text>
