$! VMSMAKHLP.COM - make help files for VMS Kermit-32
$!
$! Gary B. Stebbins - 30-Apr-1990
$!
$! This procedure creates the help files and library for VMS Kermit-32.
$! No error checking is done.  It assumes the file VMSMIT.RNH is in the
$! current directory when executed.
$!
$! If P1 is TRUE, attempt to copy the appropriate files to the system 
$! help library.  This assumes you have the appropriate privileges. 
$! No error checking is done.
$!
$
$!
$! Create the program help file
$!
$	runoff vmsmit.rnh /out=kermit
$!
$! Create the program help library
$!
$	library /help/create kermit kermit
$!
$! Create the system help file
$!
$	runoff vmsmit.rnh /variant=SYSTEM /out=kermit_sys
$!
$	Write sys$output "The Kermit-32 help files have been created."
$!
$	if .not. p1 then goto exit
$!
$! P1 is true - assume we have the correct privileges, and attempt to
$! add Kermit help to the system help directory and files
$!
$	copy kermit.hlb sys$help:*.* /log
$	library /help sys$help:helplib kermit_sys /replace/log
$!
$	write sys$output "The system help files have been updated."
$	write sys$output "No files have been purged - you may wish to do this."
$!
$exit:

