;;; -*- Mode:LISP; Package:USER; Base:10 -*-

;******************************************************************************
; Copyright (c) 1984, 1985 by Lisp Machine Inc.
; Symbolics-specific portions Copyright (c) 1985 by Honeywell, Inc.
; Permission to copy all or part of this material is granted, provided
; that the copies are not made or distributed for resale, and the 
; copyright notices and reference to the source file and the software
; distribution version appear, and that notice is given that copying is
; by permission of Lisp Machine Inc.  LMI reserves for itself the 
; sole commercial right to use any part of this KERMIT/H19-Emulator
; not covered by any Columbia University copyright.  Inquiries concerning
; copyright should be directed to Mr. Damon Lawrence at (213) 642-1116.
;
; Version Information:
;      LMKERMIT 1.0     --      Original LMI code, plus edit ;1; for 3600 port
;
; Authorship Information:
;      Mark David (LMI)           Original version, using KERMIT.C as a guide
;      George Carrette (LMI)      Various enhancements
;      Mark Ahlstrom (Honeywell)  Port to 3600 (edits marked with ";1;" comments)
;
; Author Addresses:
;      George Carrette     ARPANET: GJC at MIT-MC
;
;      Mark Ahlstrom       ARPANET: Ahlstrom at HI-Multics
;                          PHONE:   (612) 887-4006
;                          USMAIL:  Honeywell MN09-1400
;                                   Computer Sciences Center
;                                   10701 Lyndale Avenue South
;                                   Bloomington, MN  55420
;******************************************************************************


#|
To use this version of KERMIT on an LMI lispmachine:
[A] restore to a convenient directory, <X>.
[B] (load "<X>LMILOD")
[C] (make-system 'lmi-kermit :compile)		;1; I think you mean lmi-kermit, not kermit

For the 3600, we should probably break this up into the standard
sys:site;system-name.system and sys:site;logical-host.translations
and system-name.sysdcl files to make this even easier.  In fact,
it won't seem to work correctly on the 3600 unless we do so...

So for 3600, see the files lm3600.sys and lm3600.tra instead of lmilod.

|#

#-3600
(let ((p fs:fdefine-file-pathname))		;1; this gives the generic pathname of 
						;1; this file (the one being loaded)
  (if (send p :send-if-handles :translated-pathname)
      (setq p (send p :send-if-handles :translated-pathname)))
  (setq p (send p :new-pathname
                    :name :wild
                    :type :wild
                    :version :wild))
  (fs:set-logical-pathname-host "LMI-KERMIT"
                                        :physical-host (send p :host)
                                        :translations `(("SOURCE;" ,(send p :string-for-host))
							("PATCH;"  ,(send p :string-for-host)))))

(si:set-system-source-file "LMI-KERMIT" "LMI-KERMIT:SOURCE;LMISYS")
