IMPLEMENTATION MODULE KermShow;
(************************************************************************)
(*  Show local parameters                                               *)
(*  written:            08.10.85     Matthias Aebi                      *)
(*  last modification:  18.03.86     Matthias Aebi                      *)
(************************************************************************)

FROM Terminal    IMPORT WriteString, WriteLn;
FROM OutTerminal IMPORT WriteC;
FROM KermMisc    IMPORT WriteChar, ClrScr;
FROM KermParam   IMPORT LBaudRate, LCheckType, LCurrPort, LEcho, LEOLChar,
                        LEscChar, LFileType, LFilNamConv, LMaxRetries,
                        LNumOfPad, LPackSize, LPadChar, LParity,
                        LPrefChar, LQuoteChar, LStartChar, LTimeOut,
                        LTimer, LDebug, LWarning, ParityTyp, FileTyp;

(************************************************************************)
                           PROCEDURE Show;
(************************************************************************)
BEGIN
    ClrScr;
    WriteLn;
    WriteString("Current state of parameters are:");
    WriteLn;
    WriteLn;

    WriteString("    Baud rate:                  ");
    WriteC(LBaudRate,1);
    WriteLn;

    WriteString("    Check type:                 ");
    WriteC(LCheckType,1);
    WriteLn;

    WriteString("    Debugging:                  ");
    IF LDebug
    THEN
        WriteString("On");
    ELSE
        WriteString("Off");
    END;
    WriteLn;

    WriteString("    ENd of line character:      ");
    WriteChar(LEOLChar);
    WriteLn;

    WriteString("    EScape character:           ");
    WriteChar(LEscChar);
    WriteLn;

    WriteString("    Filetype:                   ");
    CASE LFileType OF
        text:
            WriteString("Text"); |

        binary:
            WriteString("Binary");

    END;
    WriteLn;

    WriteString("    Local echo:                 ");
    IF LEcho
    THEN
        WriteString("On");
    ELSE
        WriteString("Off");
    END;
    WriteLn;

    WriteString("    Name conversion:            ");
    IF LFilNamConv
    THEN
        WriteString("On");
    ELSE
        WriteString("Off");
    END;
    WriteLn;

    WriteString("    PACket length:              ");
    WriteC(LPackSize,1);
    WriteLn;

    WriteString("    PAD Character to send:      ");
    WriteChar(LPadChar);
    WriteLn;

    WriteString("    PADDing:                    ");
    WriteC(LNumOfPad,1);
    WriteLn;

    WriteString("    PARity:                     ");
    CASE LParity OF
        none:
            WriteString("None"); |

        even:
            WriteString("Even"); |

        odd:
            WriteString("Odd");  |

        mark:
            WriteString("Mark"); |

        space:
            WriteString("Space");

    END;
    WriteLn;

    WriteString("    POrt:                       ");
    WriteC(LCurrPort,1);
    WriteLn;

    WriteString("    PREfix character for 8-bit: ");
    WriteChar(LPrefChar);
    WriteLn;

    WriteString("    Retries:                    ");
    WriteC(LMaxRetries,1);
    WriteLn;

    WriteString("    Start of packet character:  ");
    WriteChar(LStartChar);
    WriteLn;

    WriteString("    TImer:                      ");
    IF LTimer
    THEN
        WriteString("On");
    ELSE
        WriteString("Off");
    END;
    WriteLn;

    WriteString("    Time Out in seconds:        ");
    WriteC(LTimeOut,1);
    WriteLn;

    WriteString("    Warning:                    ");
    IF LWarning
    THEN
        WriteString("On");
    ELSE
        WriteString("Off");
    END;
    WriteLn;

    WriteLn;
    WriteString("  To change a parameter, type: SET <parameter> <value>");
    WriteLn;
    WriteString("  Abbreviations are capitalized.");
    WriteLn;

END Show;

END KermShow.
