/*
    USR_H - header file for QL-Kermit user commands

    Based on ckuusr.h, (C) Columbia University
*/


/* Top-level commands */

#define XXCON      3                             /* CONNECT */
#define XXDOC      4                             /* DO */
#define XXFIN      12                            /* FINISH */
#define XXGET      13                            /* GET */
#define XXQUI      24                            /* QUIT or EXIT */
#define XXREC      25                            /* RECEIVE */
#define XXSEN      28                            /* SEND */
#define XXSET      30                            /* SET */
#define XXSHO      32                            /* SHOW */
#define XXTAK      36                            /* TAKE */
#define XXHELP     40                            /* HELP */


/* SET parameters */

#define XYDEB      1                             /* DEBUGGING */
#define XYLINE     15                            /* LINE */
#define XYPARI     20                            /* PARITY */
#define XYQCTL     24                            /* CONTROL-QUOTE */
#define XYRETR     26                            /* RETRIES */
#define XYSPEE     27                            /* SPEED or BAUD */
#define XYTIME     41                            /* TIMER */
#define XYECHO     43                            /* LOCAL-ECHO */
#define XYDEL      45                            /* DELAY */
#define XYPAD      46                            /* PADDING */
#define XYEBQ      47                            /* EIGHT-BIT-QUOTE */
#define XYENT      48                            /* ENTER */
#define XYTKEC     49                            /* TAKE-ECHO */
#define XYTKAB     50                            /* TAKE-ABORT */


/* SET sub-sections */

#define XYSEND     31                            /* SEND */
#define XYRECV     32                            /* RECEIVE */
#define XYFILE     42                            /* FILE */
#define XYDEV      44                            /* DEVICE */


/* Options for SET SEND & SET RECEIVE */

#define XYEOL      5                             /* END-OF-LINE */
#define XYLEN      14                            /* PACKET-LENGTH */
#define XYMARK     17                            /* START-OF-PACKET or MARKER */
#define XYTIMO     29                            /* TIMEOUT */


/* Options for SET FILE */

#define XZTYPE     1                             /* TYPE */
#define XZIFD      2                             /* INCOMPLETE */
#define XZNAME     3                             /* NAME */
#define XZSUFF     4                             /* SUFFIX */


/* Options for SET DEVICE */

#define XZSOUR     1                             /* SOURCE */
#define XZDEST     2                             /* DESTINATION */
#define XZTAKE     3                             /* TAKE */


/* Options for SHOW */

#define SHCOM      1                             /* COMMUNICATION */
#define SHXFER     2                             /* TRANSFER */
#define SHFILE     4                             /* FILE */
#define SHPRE      8                             /* PREFIX */
#define SHSYS      16                            /* SYSTEM */
#define SHDEV      32                            /* DEVICES */
#define SHVER      64                            /* VERSION */

#define SHALL      63                            /* ALL except VERSION */
