# H19 Windows Terminal Emulator with Kermit
# Written by:
# William S. Hall
# 3665 Benton St #66
# Santa Clara, CA 95051

# source directory macros
sd=.
kd=.

# compile command macro
cp=cl -c -AM -Gsw -Os -Zpe -W3 -I$(sd) -I$(kd) -DKERMIT

# make the lexer
wart.exe : winckw.c winckc.h
    cl -Fewart.exe winckw.c

# make the .RES file
winker.res : winker.rc $(sd)\winh19.h $(kd)\winkpr.h $(sd)\win19b.rc \
	      $(sd)\win19m.rc $(kd)\winkpm.rc $(kd)\winkpr.rc
    rc -r winker.rc

# make the def file
winker.def : $(sd)\winh19.def $(kd)\winkpr.def
    copy $(sd)\winh19.def+$(kd)\winkpr.def winker.def

# make the .OBJ files
winh19.obj : $(sd)\winh19.c $(sd)\winh19.h $(sd)\win19d.h \
	     $(sd)\winasc.h $(kd)\winkpf.h
    $(cp) -NT _WINH19RS $(sd)\winh19.c

win19f.obj : $(sd)\win19f.c $(sd)\winh19.h $(sd)\win19d.h \
	     $(sd)\winasc.h $(kd)\winkpf.h
    $(cp) -NT _WINH19RS $(sd)\win19f.c

win19n.obj : $(sd)\win19n.c $(sd)\winh19.h $(sd)\win19d.h \
	     $(sd)\winasc.h $(kd)\winkpf.h
    $(cp) -NT _WINH19NT $(sd)\win19n.c

win19t.obj : $(sd)\win19t.c $(sd)\winh19.h $(sd)\win19d.h $(sd)\winasc.h 
    $(cp) -NT _WINH19TM $(sd)\win19t.c

win19m.obj : $(sd)\win19m.c $(sd)\winh19.h $(sd)\win19d.h $(sd)\winasc.h 
    $(cp) -NT _WINH19NR $(sd)\win19m.c

winkpn.obj : $(kd)\winkpn.c $(kd)\winkpr.h $(kd)\winkpf.h $(sd)\winasc.h 
    $(cp) -NT _WINH19NT $(kd)\winkpn.c

winkpr.obj : $(kd)\winkpr.w $(kd)\winkpr.h $(kd)\winkpf.h $(sd)\winasc.h 
    wart $(kd)\winkpr.w winkpr.c
    $(cp) -NT _WINKRMKM winkpr.c

winkpx.obj : $(kd)\winkpx.c $(kd)\winkpr.h $(kd)\winkpf.h $(sd)\winasc.h 
    $(cp) -NT _WINKRMFX $(kd)\winkpx.c

winkpd.obj : $(kd)\winkpd.c $(kd)\winkpr.h $(kd)\winkpf.h $(sd)\winasc.h 
    $(cp) -NT _WINKRMDG $(kd)\winkpd.c

# create the .EXE file, add resources, and make a map file
winker.exe : winker.lnk winker.def winker.res \
    	     winh19.obj win19f.obj win19n.obj win19t.obj win19m.obj \
	     winkpn.obj winkpr.obj winkpx.obj winkpd.obj
    link4 @winker.lnk
    rc winker.res
    mapsym winker
