/*
  cp437.c.  Produce a table of IBM Code Page 437.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
    "C cedilla",
    "u diaeresis",
    "e acute",
    "a circumflex",
    "a diaeresis",
    "a grave",
    "a ring",
    "c cedilla",
    "e circumflex",
    "e diaeresis",
    "e grave",
    "i diaeresis",
    "i circumflex",
    "i grave",
    "A diaeresis",
    "A ring",
    "E acute",
    "ae diphthong",
    "AE diphthong",
    "o circumflex",
    "o diaeresis",
    "o grave",
    "u circumflex",
    "u grave",
    "y diaeresis",
    "O diaeresis",
    "U diaeresis",
    "Cent sign",
    "Pound Sterling sign",
    "Yen sign",
    "Peseta sign",
    "Florin sign",
    "a acute",
    "i acute",
    "o acute",
    "u acute",
    "n tilde",
    "N tilde",
    "Feminine ordinal",
    "Masculine ordinal",
    "Question mark inverted",
    "Start of line symbol",
    "Logical NOT / End of line symbol",
    "One half",
    "One quarter",
    "Exclamation inverted",
    "Left angle quotes",
    "Right angle quotes",
    "Fill character light",
    "Fill character medium",
    "Fill character heavy",
    "Center box bar vertical",
    "Right middle box side",
    "Right box side double to single",
    "Right box side single to double",
    "Upper right box corner single to double",
    "Upper right box corner double to single",
    "Right box side double",
    "Center box vertical double",
    "Upper right box corner double",
    "Lower right box corner double",
    "Lower right box corner single to double",
    "Lower right box corner double to single",
    "Upper right box corner",
    "Lower right box corner",
    "Middle box bottom",
    "Middle box top",
    "Left middle box side",
    "Center box bar horizontal",
    "Box intersection",
    "Left box side single to double",
    "Left box side double to single",
    "Lower left box corner double",
    "Upper left box corner double",
    "Middle box bottom double",
    "Middle box top double",
    "Left box side double",
    "Center box bar horizontal double",
    "Box intersection double",
    "Middle box bottom single to double",
    "Middle box bottom double to single",
    "Middle box top double to single",
    "Middle box top single to double",
    "Lower left box corner double to single",
    "Lower left box corner single to double",
    "Upper left box corner single to double",
    "Upper left box corner double to single",
    "Box intersection single to double",
    "Box intersection double to single",
    "Lower right box corner",
    "Upper left box corner",
    "Solid fill character",
    "Solid fill character bottom half",
    "Solid fill character left half",
    "Solid fill character right half",
    "Solid fill character upper half",
    "Greek alpha",
    "Greek beta, German sharp s",
    "Greek Gamma",
    "Greek pi",
    "Greek Sigma",
    "Greek sigma",
    "Greek mu",
    "Greek tau",
    "Greek Fi",
    "Greek Theta",
    "Greek Omega",
    "Greek delta",
    "Infinity",
    "Greek fi",
    "Greek epsilon",
    "Intersection symbol",
    "Identity symbol",
    "Plus or minus sign",
    "Greater than or equal sign",
    "Less than or equal sign",
    "Integral sign top half",
    "Integral sign bottom half",
    "Divide sign",
    "Nearly equals symbol",
    "Degree symbol",
    "Large center dot",
    "Small center dot",
    "Radical symbol",
    "Superscript n",
    "Superscript 2",
    "Solid square",
    "Required Space"
};

main() {
    int i;
    printf("IBM Code Page 437\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[i-128]);
    }
}

