/*
  cp852.c.  Produce a table of IBM Code Page 852.
  F. da Cruz, Columbia University, 1992.
*/
char *name[] = {
    "C cedilla",
    "u diaeresis",
    "e acute",
    "a circumflex",
    "a diaeresis",
    "u ring",
    "c acute",
    "c cedilla",
    "l with stroke",
    "e diaeresis",
    "O double acute accent",
    "o double acute accent",
    "i circumflex",
    "Z acute",
    "A diaeresis",
    "C acute",
    "E acute",
    "L acute",
    "l acute",
    "o circumflex",
    "o diaeresis",
    "l caron",
    "I caron",
    "S acute",
    "s acute",
    "O diaeresis",
    "U diaeresis",
    "T caron",
    "t caron",
    "L with stroke",
    "Multiplication sign",
    "c caron",
    "a acute",
    "i acute",
    "o acute",
    "u acute",
    "A ogonek",
    "a ogonek",
    "Z caron",
    "z caron",
    "E ogonek",
    "e ogonek",
    "UNDEFINED (SHY)",
    "z acute",
    "C caron",
    "s cedilla",
    "Left angle quotes",
    "Right angle quotes",
    "Fill character light",
    "Fill character medium",
    "Fill character heavy",
    "Center box bar vertical",
    "Right middle box side",
    "A acute",
    "A circumflex",
    "E caron",
    "S cedilla",
    "Right box side double",
    "Center box vertical double",
    "Upper right box corner double",
    "Lower right box corner double",
    "Z dot above",
    "z dot above",
    "Upper right box corner",
    "Lower right box corner",
    "Middle box bottom",
    "Middle box top",
    "Left middle box side",
    "Center box bar horizontal",
    "Box intersection",
    "A caron",
    "a caron",
    "Lower left box corner double",
    "Upper left box corner double",
    "Middle box bottom double",
    "Middle box top double",
    "Left box side double",
    "Center box bar horizontal double",
    "Box intersection double",
    "International currency symbol",
    "d stroke",
    "D stroke",
    "D caron",
    "E diaeresis",
    "d caron",
    "N caron",
    "I acute",
    "I circumflex",
    "e caron",
    "Lower right box corner",
    "Upper left box corner",
    "Solid fill character",
    "Solid fill character bottom half",
    "T ogonek",
    "U ring",
    "Solid fill character upper half",
    "O acute",
    "German sharp s",
    "O circumflex",
    "N acute",
    "n acute",
    "n caron",
    "S caron",
    "s caron",
    "R acute",
    "U acute",
    "r acute",
    "U double acute",
    "y acute",
    "Y acute",
    "t cedilla",
    "Acute accent",
    "dash",
    "Double acute accent",
    "Ogonek",
    "Caron",
    "Breve",
    "Paragraph sign",
    "Divide sign",
    "Cedilla",
    "Degree sign",
    "Diaeresis",
    "Center dot",
    "u double acute",
    "R caron",
    "r caron",
    "Solid square",
    "Required Space"
};

main() {
    int i;
    printf("IBM Code Page 852\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[i-128]);
    }
}
