/*
  cp866.c.  Produce a table of Microsoft Code Page 866.
  F. da Cruz, Columbia University, 1991.
*/
char *name[] = {
    "Cyrillic A",
    "Cyrillic Be",
    "Cyrillic Ve",
    "Cyrillic Ghe",
    "Cyrillic De",
    "Cyrillic Ie",
    "Cyrillic Zhe",
    "Cyrillic Ze",
    "Cyrillic I",
    "Cyrillic short I",
    "Cyrillic Ka",
    "Cyrillic El",
    "Cyrillic Em",
    "Cyrillic En",
    "Cyrillic O",
    "Cyrillic Pe",
    "Cyrillic Er",
    "Cyrillic Es",
    "Cyrillic Te",
    "Cyrillic U",
    "Cyrillic Ef",
    "Cyrillic Ha",
    "Cyrillic Tse",
    "Cyrillic Che",
    "Cyrillic Sha",
    "Cyrillic Shcha",
    "Cyrillic Hard Sign",
    "Cyrillic Yeri",
    "Cyrillic Soft Sign",
    "Cyrillic E",
    "Cyrillic Yu",
    "Cyrillic Ya",
    "Cyrillic a",
    "Cyrillic be",
    "Cyrillic ve",
    "Cyrillic ghe",
    "Cyrillic de",
    "Cyrillic ie",
    "Cyrillic zhe",
    "Cyrillic ze",
    "Cyrillic i",
    "Cyrillic short i",
    "Cyrillic ka",
    "Cyrillic el",
    "Cyrillic em",
    "Cyrillic en",
    "Cyrillic o",
    "Cyrillic pe",
    "Fill character light",
    "Fill character medium",
    "Fill character heavy",
    "Center box bar vertical",
    "Right middle box side",
    "Right box side double to single",
    "Right box side single to double",
    "Upper right box corner single to double",
    "Upper right box corner double to single",
    "Right box side double",
    "Center box vertical double",
    "Upper right box corner double",
    "Lower right box corner double",
    "Lower right box corner single to double",
    "Lower right box corner double to single",
    "Upper right box corner",
    "Lower right box corner",
    "Middle box bottom",
    "Middle box top",
    "Left middle box side",
    "Center box bar horizontal",
    "Box intersection",
    "Left box side single to double",
    "Left box side double to single",
    "Lower left box corner double",
    "Upper left box corner double",
    "Middle box bottom double",
    "Middle box top double",
    "Left box side double",
    "Center box bar horizontal double",
    "Box intersection double",
    "Middle box bottom single to double",
    "Middle box bottom double to single",
    "Middle box top double to single",
    "Middle box top single to double",
    "Lower left box corner double to single",
    "Lower left box corner single to double",
    "Upper left box corner single to double",
    "Upper left box corner double to single",
    "Box intersection single to double",
    "Box intersection double to single",
    "Lower right box corner",
    "Upper left box corner",
    "Solid fill character",
    "Solid fill character bottom half",
    "Solid fill character left half",
    "Solid fill character right half",
    "Solid fill character upper half",
    "Cyrillic er",
    "Cyrillic es",
    "Cyrillic te",
    "Cyrillic u",
    "Cyrillic ef",
    "Cyrillic ha",
    "Cyrillic tse",
    "Cyrillic che",
    "Cyrillic sha",
    "Cyrillic shcha",
    "Cyrillic hard sign",
    "Cyrillic yeri",
    "Cyrillic soft sign",
    "Cyrillic e",
    "Cyrillic yu",
    "Cyrillic ya",
    "Cyrillic Io",
    "Cyrillic io",
    "Ukranian Ie",
    "Ukranian ie",
    "Cyrillic Je",
    "Cyrillic je",
    "Bielorussian short U",
    "Bielorussian short u",
    "Degree symbol",
    "Large center dot",
    "Small center dot",
    "Radical symbol",
    "Numero sign",
    "Currency symbol",
    "Solid square",
    "Required Space"
};

main() {
    int i;
    printf("Microsoft Code Page 866\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[i-128]);
    }
}
