/*
  hebrew-7.c.  Produce a table of Hebrew-7.
  F. da Cruz, Columbia University, 1993.
*/
char *name[] = {
    "SPACE",
    "EXCLAMATION MARK",
    "QUOTATION MARK",
    "NUMBER SIGN",
    "DOLLAR SIGN",
    "PERCENT SIGN",
    "AMPERSAND",
    "APOSTROPHE",
    "LEFT PARENTHESIS",
    "RIGHT PARENTHESIS",
    "ASTERISK",
    "PLUS SIGN",
    "COMMA",
    "HYPHEN, MINUS SIGN",
    "PERIOD, FULL STOP",
    "SOLIDUS, SLASH",
    "DIGIT ZERO",
    "DIGIT ONE",
    "DIGIT TWO",
    "DIGIT THREE",
    "DIGIT FOUR",
    "DIGIT FIVE",
    "DIGIT SIX",
    "DIGIT SEVEN",
    "DIGIT EIGHT",
    "DIGIT NINE",
    "COLON",
    "SEMICOLON",
    "LESS-THAN SIGN, LEFT ANGLE BRACKET",
    "EQUALS SIGN",
    "GREATER-THAN SIGN, RIGHT ANGLE BRACKET",
    "QUESTION MARK",
    "COMMERCIAL AT SIGN",
    "CAPITAL LETTER A",
    "CAPITAL LETTER B",
    "CAPITAL LETTER C",
    "CAPITAL LETTER D",
    "CAPITAL LETTER E",
    "CAPITAL LETTER F",
    "CAPITAL LETTER G",
    "CAPITAL LETTER H",
    "CAPITAL LETTER I",
    "CAPITAL LETTER J",
    "CAPITAL LETTER K",
    "CAPITAL LETTER L",
    "CAPITAL LETTER M",
    "CAPITAL LETTER N",
    "CAPITAL LETTER O",
    "CAPITAL LETTER P",
    "CAPITAL LETTER Q",
    "CAPITAL LETTER R",
    "CAPITAL LETTER S",
    "CAPITAL LETTER T",
    "CAPITAL LETTER U",
    "CAPITAL LETTER V",
    "CAPITAL LETTER W",
    "CAPITAL LETTER X",
    "CAPITAL LETTER Y",
    "CAPITAL LETTER Z",
    "LEFT SQUARE BRACKET",
    "REVERSE SOLIDUS, BACKSLASH",
    "RIGHT SQUARE BRACKET",
    "CIRCUMFLEX ACCENT",
    "LOW LINE, UNDERLINE",
    "HEBREW LETTER ALEPH",
    "HEBREW LETTER BET",
    "HEBREW LETTER GIMEL",
    "HEBREW LETTER DALET",
    "HEBREW LETTER HE",
    "HEBREW LETTER WAW",
    "HEBREW LETTER ZAIN",
    "HEBREW LETTER CHET",
    "HEBREW LETTER TET",
    "HEBREW LETTER YOD",
    "HEBREW LETTER TERMINAL KAPH",
    "HEBREW LETTER KAPH",
    "HEBREW LETTER LAMED",
    "HEBREW LETTER TERMINAL MEM",
    "HEBREW LETTER MEM",
    "HEBREW LETTER TERMINAL NUN",
    "HEBREW LETTER NUN",
    "HEBREW LETTER SAMECH",
    "HEBREW LETTER AYIN",
    "HEBREW LETTER TERMINAL PE",
    "HEBREW LETTER PE",
    "HEBREW LETTER TERMINAL ZADE",
    "HEBREW LETTER ZADE",
    "HEBREW LETTER QOPH",
    "HEBREW LETTER RESH",
    "HEBREW LETTER SHIN",
    "HEBREW LETTER TAW",
    "LEFT CURLY BRACKET, LEFT BRACE",
    "VERTICAL LINE, VERTICAL BAR",
    "RIGHT CURLY BRACKET, RIGHT BRACE",
    "TILDE",
    "RUBOUT, DELETE"
};


main() {
    int i, j;
    char c;

    printf("Hebrew 7-Bit Character Set\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 32; i < 128; i++) {
	j = i - 32;
	c = (i == 127) ? 32 : i;
	printf("(%c)  %3d  %02d/%02d  %3o  %2X  %s\n",
	       c, i, i/16, i%16, i, i, name[j]);
    }
}
