/*
  hebrew-iso.c.  Produce a table of the ISO 8859-5 Latin/Hebrew alphabet.
  F. da Cruz, Columbia University, 1993.
*/
char *name[] = {
    "No-break space",
    "UNUSED",
    "Cent sign",
    "Pound sign",
    "Currency sign",
    "Yen sign",
    "Broken bar",
    "Paragraph sign",
    "Diaeresis",
    "Copyright sign",
    "Multiplication sign",
    "Left angle quotation",
    "Not sign",
    "Soft hyphen",
    "Registered trade mark",
    "Macron, line above",
    "Degree sign, ring above",
    "Plus-minus sign",
    "Superscript two",
    "Superscript three",
    "Acute accent",
    "Micro sign",
    "Pilcrow sign",
    "Middle dot",
    "Cedilla",
    "Superscript one",
    "Division sign",
    "Right angle quotation",
    "One quarter",
    "One half",
    "Three quarters",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "Double low line",
    "Hebrew letter aleph",
    "Hebrew letter bet",
    "Hebrew letter gimel",
    "Hebrew letter dalet",
    "Hebrew letter he",
    "Hebrew letter waw",
    "Hebrew letter zain",
    "Hebrew letter chet",
    "Hebrew letter tet",
    "Hebrew letter yod",
    "Hebrew letter terminal kaph",
    "Hebrew letter kaph",
    "Hebrew letter lamed",
    "Hebrew letter terminal mem",
    "Hebrew letter mem",
    "Hebrew letter terminal nun",
    "Hebrew letter nun",
    "Hebrew letter samech",
    "Hebrew letter ayin",
    "Hebrew letter terminal pe",
    "Hebrew letter pe",
    "Hebrew letter terminal zade",
    "Hebrew letter zade",
    "Hebrew letter qoph",
    "Hebrew letter resh",
    "Hebrew letter shin",
    "Hebrew letter taw",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED",
    "UNUSED"
};

main() {
    int i, j;
    printf("ISO 8859-8 Latin/Hebrew Alphabet\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 160; i < 256; i++) {
	j = i - 160;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
