/*
  latin2.c.  Produce a table of ISO Latin Alphabet 1.
  F. da Cruz, Columbia University, 1992.
*/
char *name[] = {
/* 10/00 */   "No-break space",
/* 10/01 */   "A ogonek",
/* 10/02 */   "Breve",
/* 10/03 */   "L with stroke",
/* 10/04 */   "Currency sign",
/* 10/05 */   "L caron",
/* 10/06 */   "S acute",
/* 10/07 */   "Paragraph sign",
/* 10/08 */   "Diaeresis",
/* 10/09 */   "S caron",
/* 10/10 */   "S cedilla",
/* 10/11 */   "T caron",
/* 10/12 */   "Z acute",
/* 10/13 */   "Soft hyphen",
/* 10/14 */   "Z caron",
/* 10/15 */   "Z dot above",
/* 11/00 */   "Degree sign, ring above",
/* 11/01 */   "a ogonek",
/* 11/02 */   "ogonek",
/* 11/03 */   "l with stroke",
/* 11/04 */   "Acute accent",
/* 11/05 */   "l caron",
/* 11/06 */   "s acute",
/* 11/07 */   "Caron",
/* 11/08 */   "Cedilla",
/* 11/09 */   "s caron",
/* 11/10 */   "s cedilla",
/* 11/11 */   "t caron",
/* 11/12 */   "z acute",
/* 11/13 */   "Double acute accent",
/* 11/14 */   "z caron",
/* 11/15 */   "z dot above",
/* 12/00 */   "R acute",
/* 12/01 */   "A acute",
/* 12/02 */   "A circumflex",
/* 12/03 */   "A breve",
/* 12/04 */   "A diaeresis",
/* 12/05 */   "L acute",
/* 12/06 */   "C acute",
/* 12/07 */   "C Cedilla",
/* 12/08 */   "C caron",
/* 12/09 */   "E acute",
/* 12/10 */   "E ogonek",
/* 12/11 */   "E diaeresis",
/* 12/12 */   "E caron",
/* 12/13 */   "I acute",
/* 12/14 */   "I circumflex",
/* 12/15 */   "D caron",
/* 13/00 */   "D stroke",
/* 13/01 */   "N acute",
/* 13/02 */   "N caron",
/* 13/03 */   "O acute",
/* 13/04 */   "O circumflex",
/* 13/05 */   "O double acute",
/* 13/06 */   "O diaeresis",
/* 13/07 */   "Multiplication sign",
/* 13/08 */   "R caron",
/* 13/09 */   "U ring",
/* 13/10 */   "U acute",
/* 13/11 */   "U double acute",
/* 13/12 */   "U diaeresis",
/* 13/13 */   "Y acute",
/* 13/14 */   "T cedilla",
/* 13/15 */   "German sharp s",
/* 14/00 */   "r acute",
/* 14/01 */   "a acute",
/* 14/02 */   "a circumflex",
/* 14/03 */   "a breve",
/* 14/04 */   "a diaeresis",
/* 14/05 */   "l acute",
/* 14/06 */   "c acute",
/* 14/07 */   "c cedilla",
/* 14/08 */   "c caron",
/* 14/09 */   "e acute",
/* 14/10 */   "e ogonek",
/* 14/11 */   "e diaeresis",
/* 14/12 */   "e caron",
/* 14/13 */   "i acute",
/* 14/14 */   "i circumflex",
/* 14/15 */   "d caron",
/* 15/00 */   "d stroke",
/* 15/01 */   "n acute",
/* 15/02 */   "n caron",
/* 15/03 */   "o acute",
/* 15/04 */   "o circumflex",
/* 15/05 */   "o double acute",
/* 15/06 */   "o diaeresis",
/* 15/07 */   "Division sign",
/* 15/08 */   "r caron",
/* 15/09 */   "u ring",
/* 15/10 */   "u acute",
/* 15/11 */   "u double acute",
/* 15/12 */   "u diaeresis",
/* 15/13 */   "y acute",
/* 15/14 */   "t cedilla",
/* 15/15 */   "Dot above"
};


main() {
    int i, j;
    printf("ISO 8859-2 Latin Alphabet 2\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 160; i < 256; i++) {
	j = i - 160;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
