/*
  maclatin.c.  Produce a table of Mac Kermit's Extended Latin character set.
  F. da Cruz, Columbia University, 1992.
*/
char *name[] = {
"A diaeresis",				/* 128 */
"A ring",				/* 129 */
"C cedilla",				/* 130 */
"E acute",				/* 131 */
"N tilde",				/* 132 */
"O diaeresis",				/* 133 */
"U diaeresis",				/* 134 */
"a acute",				/* 135 */
"a grave",				/* 136 */
"a circumflex",				/* 137 */
"a diaeresis",				/* 138 */
"a tilde",				/* 139 */
"a ring",				/* 140 */
"c cedilla",				/* 141 */
"e acute",				/* 142 */
"e grave",				/* 143 */
"e circumflex",				/* 144 */
"e diaeresis",				/* 145 */
"i acute",				/* 146 */
"i grave",				/* 147 */
"i circumflex",				/* 148 */
"i diaeresis",				/* 149 */
"n tilde",				/* 150 */
"o acute",				/* 151 */
"o grave",				/* 152 */
"o circumflex",				/* 153 */
"o diaeresis",				/* 154 */
"o tilde",				/* 155 */
"u acute",				/* 156 */
"u grave",				/* 157 */
"u circumflex",				/* 158 */
"u diaeresis",				/* 159 */
"Y acute",				/* 160 */
"Degree sign, ring above",		/* 161 */
"Cent sign",				/* 162 */
"Pound Sterling sign",			/* 163 */
"Paragraph (section) sign",		/* 164 */
"Multiplication sign",			/* 165 */
"Pilcrow sign",				/* 166 */
"German sharp s",			/* 167 */
"Registered trademark symbol",		/* 168 */
"Copyright symbol",			/* 169 */
"Superscript 2",			/* 170 */
"Acute accent",				/* 171 */
"Diaeresis",				/* 172 */
"Superscript 3",			/* 173 */
"AE digraph, A with E",			/* 174 */
"O slash, O oblique stroke",		/* 175 */
"Superscript 1",			/* 176 */
"Plus or minus sign",			/* 177 */
"One quarter",				/* 178 */
"One half",				/* 179 */
"Yen sign",				/* 180 */
"Greek mu, micro sign",			/* 181 */
"UNUSED",				/* 182 */
"UNUSED",				/* 183 */
"UNUSED",				/* 184 */
"UNUSED",				/* 185 */
"Three quarters",			/* 186 */
"Feminine ordinal",			/* 187 */
"Masculine ordinal",			/* 188 */
"UNUSED",				/* 189 */
"ae digraph, a with e",			/* 190 */
"o slash, o oblique stroke",		/* 191 */
"Question mark inverted",		/* 192 */
"Exclamation mark inverted",		/* 193 */
"Not sign",				/* 194 */
"L with stroke",			/* 195 */
"Florin sign",				/* 196 */
"Grave accent",				/* 197 */
"UNUSED",				/* 198 */
"Left angle quotation",			/* 199 */
"Right angle quotation",		/* 200 */
"Broken bar",				/* 201 */
"No break space",			/* 202 */
"A grave",				/* 203 */
"A tilde",				/* 204 */
"O tilde",				/* 205 */
"OE digraph",				/* 206 */
"oe digraph",				/* 207 */
"Soft hyphen",				/* 208 */
"UNUSED",				/* 209 */
"UNUSED",				/* 210 */
"UNUSED",				/* 211 */
"l with stroke",			/* 212 */
"UNUSED",				/* 213 */
"Division sign",			/* 214 */
"UNUSED",				/* 215 */
"y diaeresis",				/* 216 */
"Y diaeresis",				/* 217 */
"UNUSED",				/* 218 */
"International currency symbol",	/* 219 */
"Icelandic Eth",			/* 220 */
"Icelandic eth",			/* 221 */
"Icelandic Thorn",			/* 222 */
"Icelandic thorn",			/* 223 */
"y acute",				/* 224 */
"Center dot, middle dot",		/* 225 */
"UNUSED",				/* 226 */
"UNUSED",				/* 227 */
"UNUSED",				/* 228 */
"A circumflex",				/* 229 */
"E circumflex",				/* 230 */
"A acute",				/* 231 */
"E diaeresis",				/* 232 */
"E grave",				/* 233 */
"I acute",				/* 234 */
"I circumflex",				/* 235 */
"I diaeresis",				/* 236 */
"I grave",				/* 237 */
"O acute",				/* 238 */
"O circumflex",				/* 239 */
"UNUSED",				/* 240 */
"O grave",				/* 242 */
"U acute",				/* 242 */
"U circumflex",				/* 243 */
"U grave",				/* 244 */
"i dotless",				/* 245 */
"Circumflex",				/* 246 */
"Tilde",				/* 247 */
"Macron, overbar",			/* 248 */
"Breve",				/* 249 */
"Dot accent",				/* 250 */
"Ring above",				/* 251 */
"Cedilla",				/* 252 */
"Hungarian umlaut",			/* 253 */
"Ogonek",				/* 254 */
"Caron, hacek"				/* 255 */
};

main() {
    int i;
    printf("Macintosh Kermit Extended Latin Character Set\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[i-128]);
    }
}

