.TH TEXTPS LOCAL 
.SH NAME
textps \- convert text file to PostScript
.SH SYNOPSIS
.B textps
[
.B \-h
] [
.B \-v
] [
.B \-c 
.I
charset
] <
.I input
>
.I output

.SH DESCRIPTION
.I textps
converts an ordinary text file to PostScript, suitable for printing on
a PostScript printer such as the Apple Laserwriter, or viewing with a
PostScript previewer such as Preview on the NeXT.  Reads from standard
input, writes to standard output.
.I textps
converts text files to Courier-11, 66 lines to the page, 80 characters to the
line.  Handles pagination, tabs, line wrap, overstruck characters (via
backspace) and overstruck lines (via carriage return).  Absorbs ANSI escape
sequences without printing them.  If the input file is already PostScript, it
is simply copied to the output without alteration.
.I textps
produces no special effects.  

Unlike other "enscriptors", 
.I
textps
handles 8-bit character sets correctly.  The default file character set is
CP437 on PCs, the NeXT character set on NeXT workstations, and ISO 8859-1
Latin Alphabet 1 elsewhere.  Override the default character set with
command-line switches.  Shift-In/Shift-Out codes (Ctrl-N and Ctrl-O) within
the text are also handled correctly, allowing for representation of 8-bit
characters in the 7-bit environment, for example in e-mail.

.SH OPTIONS
.TP
.B \-h
displays a help message.
.TP
.B \-v
produces a page showing the textps program version number and the
printer's PostScript version number.
.TP
.B \-c
specifies the file's character set.  The choices are 
.I apple
(Apple QuickDraw),
.I cp437
(IBM code page 437),
.I cp850
(IBM code page 850),
.I decmcs
(DEC multinational character set),
.I latin1
(ISO Latin Alphabet 1), and
.I next
(the NeXT character set).  The character set name can be abbreviated as long
as you have given enough characters to distinguish it from the others.
.PD
.SH EXAMPLES
textps < infile > outfile

textps < infile | lpr

textps -c cp850 < infile > prn

textps -v -c latin1 < infile | lpr     

.SH ERRORS
Returns an exit status code of 0 on success, 1 on
failure.  Fails only if it is invoked with invalid command line options,
in which case an error message is printed, along with usage instructions.

.SH BUGS
.I textps
constructs its own internal font, which contains all of the characters
of Latin Alphabet 1, plus 32 additional.  File characters that don't have
equivalents in this font, such as PC line- and box- drawing characters, are
approximated with ASCII characters like '+', '-', '|' and 'X'.  Characters that
cannot be translated are shown as '?'.

Printers with PostScript versions prior to 47.0 might display certain
characters as spaces: broken bar, copyright, trade mark, not sign, fractions,
superscripts, Y/y-acute, Icelandic Thorn/thorn and Eth/eth.  Use the -v option
to have the printer display its PostScript version number.

When
.I textps
is installed as a print filter, there is no way way to pass options to it.
So, for example, you can't tell it to use a different character set.  In that
case, run textps "manually":

textps -c decmcs < decmcs.txt | lpr

If
.I textps
is installed as a print filter, and a file fails to print correctly, run the
file through the Transcript
.I pstext
program before printing it:

pstext < file | lpr

Note:
.I pstext
does not handle 8-bit characters or line wrap.

.SH AUTHOR
Frank da Cruz, Columbia University, July 1991, with help and/or PostScript
code from Bur Davis of Adobe.
