# CK9KER.MAK, version 1, 04/30/87 Robert Larson
#             version 2, 04/12/91 Christian Hemsing for kermit 5a
#             version 3, 03/04/92 kermit 5a,beta; explicit 680x0 distinction
#             version 4, 10/01/92 kermit 5a,beta; added MYCURSES
# based on ckuker.mak
#
# -- Makefile to build C-Kermit for os9/68k
#
# Before proceeding, read the instructions below, and also do read the file
# ck9ker.bwr (the "beware file"), and then rename this file to "makefile"
# or "Makefile", and then:
#
# for os9/68k: make
#
# or don't rename it and type: make -f=ck9ker.mak
#
#
#############################################################################
#
# Notes:
#
#   You should remove the -t=/r0 option if you don't have a
#   ramdisk named /r0.
#
#   Change ODIR to where you want the executable (give a full path).
#   Change RDIR to where you want the rels (can be a relative path).
#
ODIR= /r1/exe
RDIR = ./rels
#
#   Edit the PROGRAM macro to the name you want kermit to have
#   Use the apropriate TYPE macro depending on your processor
#
#   If Kermit is too large for your machine you can add some
#   defines to make it smaller:
#   -dNODEBUG   don't include debugging information
#   -dNOHELP    no on-line help
#   -dNOTLOG    no transaction logging
#   -dNOSCRIPT  no UUCP-style script command
#   -dNOCSETS   no character set translation
#   -dNOMSEND   no msend command
#   -dNOICP     no interactive command parser
#   -dNODIAL    no modem support
#   -dNOXMIT    no tranmit command
#   -dNOSPL     no script programming language
#   Edit the TYPE macro according to your machine.
#
#   If you have problems changing the line speed do read ck9ker.bwr and
#   add -dXMODE option to the CFLAGS if neccessary and wanted (see ck9ker.bwr)
#
#   for futher information see ckuins.doc (installation manual)
###########################################################################
#
#  Compile and Link variables:
#
CC = cc
TYPE=0		#use this if you compile for 68000,68008,68010 or 68070
#TYPE=2		#use this if you compile for 68020,68030
#TYPE=2cw	#use this if you compile for 68020,68030, smaller but slower
#minimum size:
#CFLAGS= -ixt=/r0 -k=$(TYPE)w -dVOID=void -dSIG_V -dDYNAMIC -dNODEBUG \
#   -dNOHELP -dNOTLOG -dNOSCRIPT -dNOCSETS -dNOMSEND -dNODIAL -dNOICP
#maximum size:
CFLAGS= -ixt=/r0 -k=$(TYPE)w -dVOID=void -dSIG_V -dDYNAMIC -dPARSENSE \
		-dKANJI -dMYCURSES
LFLAGS= -ixt=/r0 -k=$(TYPE)w
SDIR = .
PROGRAM= wermit
#
###########################################################################
#
# Dependencies Section:
#
RFILES = ckcmai.r ckucmd.r ckuusr.r ckuus2.r ckuus3.r ckuus4.r ckuus5.r \
   ckuus6.r ckuus7.r ckuusx.r ckuusy.r ckcpro.r ckcfns.r ckcfn2.r ckcfn3.r \
   ckuxla.r ck9con.r ck9tio.r ck9fio.r ck9asm.r ckudia.r ckuscr.r

$(PROGRAM): $(RFILES)
 chd $(RDIR);$(CC) $(LFLAGS) -f=$(ODIR)/$@ $(RFILES)

ckcmai.r: ckcmai.c ckcker.h ckcdeb.h ckcsym.h ckcasc.h ckcnet.h

ckcpro.r: ckcpro.c ckcker.h ckcdeb.h ckcasc.h

ckcpro.c: ckcpro.w wart ckcdeb.h ckcasc.h ckcker.h
 $(ODIR)/wart ckcpro.w ckcpro.c

wart: ckwart.r
 chd $(RDIR);$(CC) $(LFLAGS) -f=$(ODIR)/$@ ckwart.r

ckwart.r: ckwart.c

ckcfns.r: ckcfns.c ckcker.h ckcdeb.h ckcsym.h ckcasc.h ckcxla.h ckuxla.h

ckcfn2.r: ckcfn2.c ckcker.h ckcdeb.h ckcsym.h ckcasc.h ckcxla.h ckuxla.h

ckcfn3.r: ckcfn3.c ckcker.h ckcdeb.h ckcsym.h ckcasc.h ckcxla.h ckuxla.h

ckuxla.r: ckuxla.c ckcker.h ckcdeb.h ckcxla.h ckuxla.h

ckuusr.r: ckuusr.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
        ckcasc.h ckcnet.h

#in case compiled with -k=0w or -k=2cw: explicit -k=0cl 
#(long pc rel. offsets) necessary because too many constants in ckuus2.c
ckuus2.r: ckuus2.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
        ckcasc.h
	cc $(CFLAGS) -r=$(RDIR) -k=$(TYPE)cl $*.c

ckuus3.r: ckuus3.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
        ckcasc.h ckcnet.h

ckuus4.r: ckuus4.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
        ckcasc.h ckcnet.h ckuver.h

ckuus5.r: ckuus5.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcasc.h

ckuus6.r: ckuus6.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcasc.h

ckuus7.r: ckuus7.c ckucmd.h ckcker.h ckuusr.h ckcdeb.h ckcxla.h ckuxla.h \
		ckcasc.h ckcnet.h

ckuusx.r: ckuusx.c  ckcker.h ckuusr.h ckcdeb.h ckcasc.h

ckuusy.r: ckuusy.c  ckcker.h ckcdeb.h ckcasc.h

ckucmd.r: ckucmd.c ckcasc.h ckucmd.h ckcdeb.h

ck9fio.r: ck9fio.c ckcker.h ckcdeb.h

ck9tio.r: ck9tio.c ckcdeb.h

ck9con.r: ck9con.c ckcker.h ckcdeb.h

ckudia.r: ckudia.c ckcker.h ckcdeb.h ckucmd.h ckcasc.h

ckuscr.r: ckuscr.c ckcker.h ckcdeb.h ckcasc.h
