/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* |_o_o|\\ Copyright (c) 1986 The Software Distillery.  All Rights Reserved */
/* |. o.| || This program may not be distributed without the permission of   */
/* | .  | || the authors.                                                    */
/* | o  | ||    Dave Baker     Ed Burnette  Stan Chow    Jay Denebeim        */
/* |  . |//     Gordon Keener  Jack Rouse   John Toebes  Doug Walker         */
/* ======          BBS:(919)-471-6436      VOICE:(919)-469-4210              */
/*                                                                           */
/* Contributed to Columbia University for inclusion in C-Kermit.             */
/*
  Permission is granted to any individual or institution to use this
  software as long as it is not sold for profit.  This copyright notice must be
  retained.  This software may not be included in commercial products without
  written permission of Columbia University.
*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*  C K I S T U  --  Stubs for functions not yet implemented on Amiga */

#ifndef _lint
static char *version = "Amiga stub routines, $Id: ckistu.c,v 1.6 92/10/30 16:10:04 swalton Exp Locker: swalton $";
#endif

/*
 Author: Jack Rouse, The Software Distillery

 $Log:	ckistu.c,v $
 * Revision 1.6  92/10/30  16:10:04  swalton
 * Change in the format of the copyright notice.  No code changes.
 * 
 * Revision 1.5  92/01/15  17:14:59  swalton
 * Use Id rather than Header in the RCS ID string.
 * 
 * Revision 1.4  91/07/18  16:01:28  swalton
 * Stub version of getdws() routine added (new for 5A(172)).
 * 
 * Revision 1.3  91/05/29  09:08:42  swalton
 * 1.  Changed function definitions to prototype style.  Required adding
 *     a few forward declarations.
 * 2.  Removed includes of stdio.h, stdlib.h, and string.h, as they are
 *     now pulled in by ckcdeb.h, provided we compile with -DCK_ANSILIBS.
 * 
 * Revision 1.2  90/11/07  14:41:45  swalton
 * Version 1.2--released to world as first beta test version simultaneously
 * with release of edit 5A(160).
 * 
 * Revision 1.1  90/07/12  22:30:04  swalton
 * Administrative check-in only;  no modifications were made to this modue
 * for version 5A(149) of C Kermit.
 * 
 * Revision 1.0  90/04/30  11:54:42  swalton
 * Initial revision
 * 
*/

#include "ckcdeb.h"
#include "ckcker.h"
#include "ckucmd.h"

char *dialv = "Dial Command unimplemented";
struct keytab mdmtab[] = {
	"direct", 	0, 	0,	/* no modem control */
	"generic", 	1, 	0	/* use 7 wire modem control */
};

int nmdm = sizeof(mdmtab) / sizeof(struct keytab);
 
int
ckdial(char *s) {
	printf("Sorry, DIAL command not implemented yet.\n");
	return(-2);
}

char *loginv = "Script Command unimplemented";

int
dologin(char *s) {
	printf("Sorry, SCRIPT command not implemented yet\n");
	return(-2);
}

char *
getdws(int mdmtyp) {
	return NULL;
}
