$ ! ckvker.com for VMS V5.0 and greater.
$ ! For pre-5.0 versions, use (at your own risk) CKVOLD.COM.
$ ! Lee Tibbert <tibbert@cosby.enet.dec.com>
$ ! 9 October 1992
$ ! Based upon many earlier generations of CKVKER.COM by Terry Kennedy
$ ! and others.
$ ! Network decision-making section redone, fdc, 14 Oct 92.
$ 
$ ! See CKVINS.DOC for detailed installation instructions.
$
$ ! Copyright (C) 1985, 1992, Trustees of Columbia University in the City of 
$ ! New York.  Permission is granted to any individual or institution to use
$ ! this software as long as it is not sold for profit.  This copyright
$ ! notice must be retained.  This software may not be included in commercial
$ ! products without written permission of Columbia University.
$ 
$ goto begin
$ ! Supports OpenVMS AXP(tm) and VAX(tm) builds:
$
$ ! Notes:
$ ! 	I have not found a good way to use  one set of CC flags
$ ! 	for VAX and both AXP paths.  If you change one, remember to 
$ !	change the other two.
$  
$ ! VAX Notes:
$ ! 	On OpenVMS VAX, supports WINTCP, MULTINET, & DEC TCP/IP Services in
$ ! 	addition to serial line (DEC TCP/IP file fixes in progress 1992-10-08) 
$ 
$ ! 	VAX Link should really use SYS$LIBRARY:VAXCRTL.EXE shareable but
$ ! 	I did not change prior practice.
$  
$ ! AXP Notes:
$
$ ! 	AXP Link uses SYS$LIBRARY:DECC$SHR.EXE shareable (From IMAGELIB.OLB)
$ 
$ ! 	There are two OpenVMS AXP builds possible. The separate compilation
$ ! 	version is the default in order to keep PAGEFILE Quota down.
$ ! 	The /Plus_List_Optimize version takes more resources at compile time
$ ! 	but yields smaller, faster code. Take your pick (by [un]commenting
$ !	call in subroutine Alpha_Build)
$
$ ! 	AXP build does not support TCP/IP (link command needs to vary.)
$
$ !___________________________________________________________________________
$
$ Begin:
$  On Control_Y Then Goto The_Exit
$ 
$  On Warning Then Goto The_Exit
$ 
$  axp_cc := "DECC_AXP"	! LT personal value, not DEC value
$
$
$  hw_arch := "VAX" ! Assume VAX
$  if (f$getsyi("CPU") .eq. 128) ! 128 means "not a VAX"
$   then
$    hw_arch := "''f$getsyi("Arch_Name")'"
$    if ("''hw_arch'" .nes. "Alpha") 
$     then
$     if (f$locate("ALPHA", f$edit("''hw_arch'","UPCASE")) -
		 .lt. f$length("''hw_arch'"))
$      then
$       hw_arch := "Alpha" ! Treat as Alpha AXP
$      else
$       write sys$output "Unknown hardware architecture ''hw_arch'"
$       exit %x10000004   
$      endif ! Unknown
$    endif ! String not "Alpha" 
$   endif ! Not VAX
$
$  sys_ver = f$edit(f$getsyi("version"),"compress")
$  if f$extract(0,1,sys_ver) .nes. "V"
$  then
$    type sys$input
You appear to be running a Field Test version of VMS. This script will
assume that the operating system version is at least V5.0.

$    sys_ver = "V5.0"
$  endif
$  sys_maj = 0+f$extract(1,1,sys_ver)
$  sys_min = 0+f$extract(3,1,sys_ver)
$  if sys_maj .lt. 5 then if (sys_min/2)*2 .ne. sys_min then -
     sys_min = sys_min - 1
$  vms_ver = "VMS_V''sys_maj'''sys_min'"
$
$  ! Type:
$  !    net_option = "NONET"
$  ! before running this procedure to build C-Kermit without TCP/IP network
$  ! support on a system that has a TCP/IP package installed.
$  !
$  if f$type(net_option) .eqs. "STRING"
$  then
$    write sys$output "Network option override = ''net_option'"
$    goto Net_Done
$  endif
$
$  net_option = "NONET"
$  if f$search("MULTINET:MULTINET_SOCKET_LIBRARY.EXE") .nes. ""
$  then
$    net_option = "MULTINET"
$  else
$  if f$search("TWG$TCP:[NETDIST.LIB]TWGLIB.OLB") .nes. ""
$  then
$    net_option = "WINTCP"
$  else
$  if f$search("SYS$STARTUP:UCX$STARTUP.COM") .nes. ""
$  then
$    net_option = "DEC_TCPIP"
$  endif ! DEC TCP/IP
$  endif ! Wollongong
$  endif ! MultiNet
$
$ Net_Done:
$
$  if f$type(net_option) .eqs. ""
$  then
$    net_option = "NONET"
$    net_name = "no"
$  endif
$
$  if net_option .eqs. "NONET"
$  then
$    net_name = "no"
$  else
$  if net_option .eqs. "MULTINET"
$  then
$    net_name = "MultiNet"
$  else
$  if net_option .eqs. "WINTCP"
$  then
$    net_name = "WIN/TCP"
$    define vaxc$include twg$tcp:[netdist.include],sys$library
$    define sys twg$tcp:[netdist.include.sys]
$  else
$  if net_option .eqs. "DEC_TCPIP"
$  then 
$    net_name = "DEC TCP/IP Services for OpenVMS(tm)"
$  else
$    write sys$output "Unknown net_option: ''net_option'"
$    net_option = "NONET"
    net_name = "no"
$  endif ! None
$  endif ! DEC TCP/IP
$  endif ! Wollongong
$  endif ! MultiNet
$
$  if sys_maj .lt. 5
$  then
$    write sys$output "You are running VMS V''sys_ver'."
$    type sys$input
VMS C-Kermit has not been verified to build properly under this version, 
although pre-built versions should run properly.  Please exercise caution 
until you have verified proper operation. 

$ endif
$
$ call 'hw_arch'_Build
$
$ The_Exit:
$  exit $STATUS
$ !___________________________________________________________________________
$ !___________________________________________________________________________
$ AXP_CC: Subroutine
$  On Control_Y Then $exit %x10000004
$  On Warning Then   $exit $status
$
$ write sys$output "	    ''P1' at ''f$time()"
$  cc/'debug'/standard='lint_standard'/'optimize' -
	/define=("DEBUG", "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
	"''net_option'", "''cc_ver'", "''vms_ver'") 'P1
$  exit 
$ EndSubroutine !AXP_CC
$ !___________________________________________________________________________
$ AXP_Incremental_Wermit: Subroutine
$  On Control_Y Then $exit %x10000004
$  On Warning Then   $exit $status
$
$  write sys$output f$fao("!_  Using separate CC commands.")
$  call axp_cc ckcmai.c
$  call axp_cc ckcfn2.c
$  call axp_cc ckcfn3.c
$  call axp_cc ckcfns.c
$  call axp_cc ckcpro.c
$  call axp_cc ckucmd.c
$  call axp_cc ckudia.c
$  call axp_cc ckuscr.c
$  call axp_cc ckuus2.c
$  call axp_cc ckuus3.c
$  call axp_cc ckuus4.c
$  call axp_cc ckuus5.c
$  call axp_cc ckuus6.c
$  call axp_cc ckuus7.c
$  call axp_cc ckuusr.c
$  call axp_cc ckuusx.c
$  call axp_cc ckuusy.c
$  call axp_cc ckuxla.c
$  call axp_cc ckvcon.c
$  call axp_cc ckcnet.c
$  call axp_cc ckvfio.c
$  call axp_cc ckvtio.c
$  call axp_cc ckvioc.c
$ 
$  write sys$output "  Linking WERMIT at ''f$time()"
$  link/'link_debug' /exec=wermit.exe -
 	ckcmai, ckcfn2, ckcfn3, ckcfns, ckcpro, ckucmd, ckudia, -
	ckuscr, ckuus2, ckuus3, ckuus4, ckuus5, ckuus6, ckuus7, -
	ckuusr, ckuusx, ckuusy, ckuxla, ckvcon, ckcnet, ckvfio, -
	ckvtio, ckvioc
$  
$  exit 
$ EndSubroutine !AXP_Incremental_Wermit
$ !___________________________________________________________________________
$ AXP_Optimized_Wermit: Subroutine
$  On Control_Y Then $exit %x10000004
$  On Warning Then   $exit $status
$
$  write sys$output f$fao("!_  Using single CC/Plus_List_Optimize command.")
$  write sys$output f$fao("!_  	  This compilation takes a while.")
$
$  cc/obj=ckcmai/'debug'/standard='lint_standard'/'optimize' -
	/define=("DEBUG", "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
	"''net_option'", "''cc_ver'", "''vms_ver'")/plus_list_optimize -
 	ckcmai + ckcfn2 + ckcfn3 + ckcfns + ckcpro + ckucmd + ckudia + -
	ckuscr + ckuus2 + ckuus3 + ckuus4 + ckuus5 + ckuus6 + ckuus7 + -
	ckuusr + ckuusx + ckuusy + ckuxla + ckvcon + ckcnet + ckvfio + -
	ckvtio + ckvioc 
$
$    write sys$output "  Linking   WERMIT at ''f$time()"
$    link/'link_debug' /exec=wermit.exe ckcmai.obj
$
$  exit 
$ EndSubroutine !AXP_Optimized_Wermit
$ !___________________________________________________________________________
$ Alpha_Build: Subroutine 
$  On Control_Y Then $exit %x10000004
$  On Warning Then   $exit $status
$
$  cc_ver = "''axp_cc'"
$
$  !debug  := nodebug
$  debug  := debug
$
$  Link_Debug  := nodebug
$
$  ! optimize := optimize=level=0 ! level=0 means NoOptimize
$  optimize := optimize=level=4   ! level=4 means greatest optimization
$
$  !lint_standard := ANSI89 
$  lint_standard := VAXC ! Evil living is its own retribution....
$ 
$
$  write sys$output f$fao("!/Operating System: OpenVMS(tm) AXP(tm)!/")
$  write sys$output -
	"Building WERMIT with ''net_name' network support at ''f$time()"
$ 
$  write sys$output "  Compiling CKWART at ''f$time()"
$  call axp_cc ckwart.c
$
$  write sys$output "  Linking   CKWART at ''f$time()"
$  link/exec=ckwart ckwart.obj
$  purge ckwart.obj
$  write sys$output "  Running   CKWART at ''f$time()"
$  ckwart = "$" +f$parse("CKWART.EXE",,,"DEVICE") +-
           f$parse("CKWART.EXE",,,"DIRECTORY") + "CKWART"
$  ckwart ckcpro.w ckcpro.c
$  purge ckcpro.c
$
$  write sys$output f$fao("!/  Compiling WERMIT files at ''f$time()")
$
$ ! Incremental build is default. To get /Plus_List_Optimized
$ ! Comment out the incremental_wermit and uncomment the optimized.
$  call AXP_incremental_wermit 
$ !  call AXP_optimized_wermit

$  write sys$output "Done building WERMIT at ''f$time()"
$
$  write sys$output f$fao("!/Building CKVCVT at ''f$time()")
$  write sys$output "  Compiling CKVCVT at ''f$time()"
$  call axp_cc ckvcvt.c
$  write sys$output "  Linking   CKVCVT at ''f$time()"
$  link/'link_debug'/exec=ckvcvt ckvcvt.obj
$  set file/protection=(g:re,w:re) ckvcvt.exe
$  purge ckvcvt.obj
$  write sys$output "Done building CKVCVT at ''f$time()"
$
$  exit 
$ EndSubroutine !AXP_Build
$ !___________________________________________________________________________
$ 
$ VAX_Build: Subroutine
$ On Control_Y Then $exit %x10000004
$ On Warning Then   $exit $status
$ 
$ lint_standard := NoPortable
$
$  write sys$output f$fao("!/Operating System: OpenVMS(tm) VAX(tm)!/")
$ 
$   cc_ver = "VAXC023"
$   if f$search("sys$library:fscndef.h") .nes. "" then cc_ver = "VAXC024"
$   if f$search("sys$library:ppl$routines.h") .nes. "" then cc_ver = "VAXC030"
$   if f$search("sys$library:xabrudef.h") .nes. "" then cc_ver = "VAXC031"
$ ! lt 1992-08-14 Could be VAXC032
$
$ 
$ if (cc_ver .nes. "VAXC031")
$ then
$ type sys$input
Your system has an older version of the VAX C compiler.  VMS C-Kermit was
designed to be compiled under VAX C V3.1 or newer.  It has not been verified
to build properly under this version, although pre-built versions should run
properly.  Please exercise caution until you have verified proper operation.

$ endif
$
$ write sys$output "Building WERMIT with ''net_name' network support"
$ if f$search("wermit.olb") .eqs. "" then libr/create=(Block:1920)/object-
	 wermit.olb
$
$ write sys$output "  Compiling CKVIOC"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckvioc.obj ckvioc.c
$ library/replace wermit.olb ckvioc.obj
$ delete ckvioc.obj.*
$
$ write sys$output "  Compiling CKCNET"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckcnet.obj ckcnet.c
$ library/replace wermit.olb ckcnet.obj
$ delete ckcnet.obj.*
$
$ write sys$output "  Compiling CKVTIO"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckvtio.obj ckvtio.c
$ library/replace wermit.olb ckvtio.obj
$ delete ckvtio.obj.*
$
$ write sys$output "  Compiling CKVFIO"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckvfio.obj ckvfio.c
$ library/replace wermit.olb ckvfio.obj
$ delete ckvfio.obj.*
$
$ write sys$output "  Compiling CKCFN2"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckcfn2.obj ckcfn2.c
$ library/replace wermit.olb ckcfn2.obj
$ delete ckcfn2.obj.*
$ write sys$output "  Compiling CKCFN3"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckcfn3.obj ckcfn3.c
$ library/replace wermit.olb ckcfn3.obj
$ delete ckcfn3.obj.*
$ write sys$output "  Compiling CKCFNS"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckcfns.obj ckcfns.c
$ library/replace wermit.olb ckcfns.obj
$ delete ckcfns.obj.*
$ write sys$output "  Compiling CKCMAI"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckcmai.obj ckcmai.c
$ library/replace wermit.olb ckcmai.obj
$ delete ckcmai.obj.*
$ write sys$output "  Compiling CKWART"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckwart.obj ckwart.c
$ write sys$output "  Linking CKWART"
$ ! no symbol table lt 1992-08-14  
$ link/exec=ckwart ckwart.obj, sys$share:vaxcrtl.olb/library
$ purge ckwart.obj
$ write sys$output "Running CKWART"
$ ckwart = "$" +f$parse("CKWART.EXE",,,"DEVICE") +-
    f$parse("CKWART.EXE",,,"DIRECTORY") + "CKWART"
$ ckwart ckcpro.w ckcpro.c
$ purge ckcpro.c
$ write sys$output "  Compiling CKCPRO"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckcpro.obj ckcpro.c
$ library/replace wermit.olb ckcpro.obj
$ delete ckcpro.obj.*
$ write sys$output "  Compiling CKUCMD"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckucmd.obj ckucmd.c
$ library/replace wermit.olb ckucmd.obj
$ delete ckucmd.obj.*
$ write sys$output "  Compiling CKUDIA"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckudia.obj ckudia.c
$ library/replace wermit.olb ckudia.obj
$ delete ckudia.obj.*
$ write sys$output "  Compiling CKUSCR"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuscr.obj ckuscr.c
$ library/replace wermit.olb ckuscr.obj
$ delete ckuscr.obj.*
$ write sys$output "  Compiling CKUUS2"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuus2.obj ckuus2.c
$ library/replace wermit.olb ckuus2.obj
$ delete ckuus2.obj.*
$ write sys$output "  Compiling CKUUS3"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuus3.obj ckuus3.c
$ library/replace wermit.olb ckuus3.obj
$ delete ckuus3.obj.*
$ write sys$output "  Compiling CKUUS4"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuus4.obj ckuus4.c
$ library/replace wermit.olb ckuus4.obj
$ delete ckuus4.obj.*
$ write sys$output "  Compiling CKUUS5"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuus5.obj ckuus5.c
$ library/replace wermit.olb ckuus5.obj
$ delete ckuus5.obj.*
$ write sys$output "  Compiling CKUUS6"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuus6.obj ckuus6.c
$ library/replace wermit.olb ckuus6.obj
$ delete ckuus6.obj.*
$ write sys$output "  Compiling CKUUS7"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuus7.obj ckuus7.c
$ library/replace wermit.olb ckuus7.obj
$ delete ckuus7.obj.*
$ write sys$output "  Compiling CKUUSR"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuusr.obj ckuusr.c
$ library/replace wermit.olb ckuusr.obj
$ delete ckuusr.obj.*
$ write sys$output "  Compiling CKUUSX"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuusx.obj ckuusx.c
$ library/replace wermit.olb ckuusx.obj
$ delete ckuusx.obj.*
$ write sys$output "  Compiling CKUUSY"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuusy.obj ckuusy.c
$ library/replace wermit.olb ckuusy.obj
$ delete ckuusy.obj.*
$
$ write sys$output "  Compiling CKUXLA"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckuxla.obj ckuxla.c
$ library/replace wermit.olb ckuxla.obj
$ delete ckuxla.obj.*
$ write sys$output "  Compiling CKVCON"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckvcon.obj ckvcon.c
$ library/replace wermit.olb ckvcon.obj
$ delete ckvcon.obj.*
$
$ write sys$output "  Linking WERMIT"
$ if net_option .eqs. "MULTINET"
$ then
$ ! No symbol table     -lt.  1992-08-14  
$ link wermit.olb/library/include=(ckcfn2, ckcfn3, ckcfns,-
    ckcmai, ckcpro, ckucmd, ckudia, ckuscr, ckuus2, ckuus3, ckuus4, ckuus5,-
    ckuus6, ckuus7, ckuusr, ckuxla, ckvcon, ckcnet, ckvfio, ckvtio),-
    sys$share:vaxcrtl.olb/library/exec=wermit.exe, sys$input:/options
multinet:multinet_socket_library.exe/share 
$ else
$ if net_option .eqs. "WINTCP"
$ then
$ ! No symbol table     -lt.  1992-08-14  
$ link wermit.olb/library/include=(ckcfn2, ckcfn3, ckcfns,-
    ckcmai, ckcpro, ckucmd, ckudia, ckuscr, ckuus2, ckuus3, ckuus4, ckuus5,-
    ckuus6, ckuus7, ckuusr, ckuxla, ckvcon, ckcnet, ckvfio, ckvtio),-
    twg$tcp:[netdist.lib]twglib.olb/library,-
    sys$share:vaxcrtl.olb/library/exec=wermit.exe
$ else
$ if net_option .eqs. "DEC_TCPIP" !    -lt.  1992-09-14  
$ then
$ ! No symbol table     -lt.  1992-08-14  
$ link wermit.olb/exec=wermit.exe/library -
    /include=(ckcfn2, ckcfn3, ckcfns,-
    ckcmai, ckcpro, ckucmd, ckudia, ckuscr, ckuus2, ckuus3, ckuus4, ckuus5,-
    ckuus6, ckuus7, ckuusr, ckuxla, ckvcon, ckcnet, ckvfio, ckvtio, ckvioc),-
    sys$library:ucx$ipc.olb/library, -
    sys$share:vaxcrtl.olb/library 
$ else
$ ! No symbol table     -lt.  1992-08-14  
$ link wermit.olb/exec=wermit.exe/library/include=(ckcfn2, ckcfn3, ckcfns,-
    ckcmai, ckcpro, ckucmd, ckudia, ckuscr, ckuus2, ckuus3, ckuus4, ckuus5,-
    ckuus6, ckuus7, ckuusr, ckuxla, ckvcon, ckcnet, ckvfio, ckvtio),-
    sys$share:vaxcrtl.olb/library 
$ endif
$ endif
$ endif
$ set file/protection=(g:re,w:re) wermit.exe
$ write sys$output "Done building WERMIT"
$ exit 
$ write sys$output "Building CKVCVT"
$ write sys$output "  Compiling CKVCVT"
$ cc/debug/standard='lint_standard'/optimize/define=("DEBUG",-
  "TLOG", "DYNAMIC", "CK_CURSES", "IFDEBUG", "KANJI", -
  "''net_option'", "''cc_ver'", "''vms_ver'")/obj=ckvcvt.obj ckvcvt.c
$ write sys$output "  Linking CKVCVT"
$ ! No symbol table     -lt.  1992-08-14  
$ link/exec=ckvcvt ckvcvt.obj, sys$share:vaxcrtl.olb/library
$ set file/protection=(g:re,w:re) ckvcvt.exe
$ purge ckvcvt.obj
$ write sys$output "Done building CKVCVT"
$ exit
$ EndSubroutine !VAX_Build
$
$ !________________________   End of File   __________________________________
