.TH ANSITAR 1 5/1/84
.SH NAME
ansitar \- read or write ANSI multifile labeled tapes
.SH SYNOPSIS
.B ansitar
subcommand [blocksize] [linesize] [vsn] file
.br
.B ansitar
.RB "subcommand[" "RSl" "]"
[blocksize] [linesize] [labelsize] [vsn] file
.LP
.SH DESCRIPTION
.I Ansitar
reads from or writes to a magnetic tape in ANSI labeled
tape format, which is a 
useful format for exchange of ASCII character files
with a non-UNIX system. Eight-bit binary is also possible,
but the results are likely to be unsatisfactory in most
cases.
.PP
A non-standard version compiled with 
.B #define PIP
permits reading of RT11 and RSTS files as well.
.PP
.I subcommand
is any rational concatenation of compatible characters from
the following groups \- only one from each group:
.IP 
.B [crtx], [bBDF], [RS], 
.B l, U, v, V, [0..9]
.LP
.TP
.B c
Create a new multifile tape. (Destroy all previous files on tape). 
.TP
.B r
Replace files on tape without destroying any previous files. 
.TP
.B t
List all files on tape. 
.TP
.B x
Extract files from tape. (See note on `*' wild-card character). 
.TP 
.B b 
Use next argument as a tape block size. 
.TP 
.B B 
Use next argument as a tape block size and following argument as
line size (for blocking/unblocking of fixed length records).  
.TP
.B D
.I Reading. 
Not required for System level 3 tape with valid HDR2 label.  
For System level 1 and 2 use next argument as tape block size. 
.I Writing.
Write HDR2/EOF2 labels and variable 
length records (D format, System level 3) with block size
2048 and maximum line size 255. 
.TP 
.B F 
.I Reading.
Not required if tape has valid HDR2 label.  Use 
.B B
for ANSI System level 1 tapes.
.I Writing. 
Same as B, but write HDR2/EOF2 label for 
automatic unblocking. (F format, System level 3).
.TP
.B R
Read with RT11 label and name conventions.
.TP
.B S
Read with RSTS conventions (same as RT11, 
except 80-character labels).
.TP
.B l
Use next argument as non-standard label size.
.TP
.B U
Do case conversion on alphabetic characters in filenames.
Upper-case to lower-case from tape to UNIX.  Lower-case
to upper-case from UNIX to tape.
.TP
.B v
Use 
.I `verbose' 
mode \- Lots of information about labels.
.TP
.B V
Use next argument (up to 6 alphanumeric characters) as tape
.I vsn.
.TP
.B 1..9
Select tape unit (default is 
.I /dev/rmt8
).   
.PP
The arguments for 
.B b, B, D, F, l 
are unsigned decimal strings.  It is probably preferable
to use only upper-case alphabetics in the argument to 
.B V.
Arguments are evaluated in the order in which the associated
subcommand characters appear.
.PP
Note: The `*' wild card character may be used to get a number
of related files from tape, but in that case the filename
must be quoted to prevent the shell from attempting to
expand the wild card. When writing from UNIX to tape,
wild cards work normally.
.SH SEE ALSO
.I ANSI X3.27-1978:
Magnetic Tape Labels and File Structure for Information Interchange.
.br
.I ISO 1001-1979:
Magnetic Tape Labels and File Structure for Information Interchange.
.SH AUTHORS
Unknown, modified by David R. Brown, further 
modified by Pierre A. MacKay.
.SH BUGS
