*COPY                                                 IK0KAN            06995000
         CHECKVER IK0KAN,4.2                                   @SC90072 06995002
         TITLE 'Kanji conversion routines KJETOA+KJATOE'       @SC91325 06995004
* Entry: R2->buffer, R3=length                                 @SC91325 06995006
* Exit: R15=length of converted buffer (may be longer if ATOE, @SC91325 06995008
*       may be longer or shorter if ETOA)                      @SC91325 06995010
*  The available buffer space is assumed to be 2.5 * (R3) for  @SC91325 06995012
*  all conversions.                                            @SC91325 06995014
* During execution: R2-> output buffer, R3= count remaining,   @SC91325 06995016
*     R4-> input buffer, R6-> original buffer, R7-> 1-byte tbl @SC91325 06995018
*     R8-> 2-byte tbl,   R9-> start of loop                    @SC91325 06995020
*                                                                       06995022
KJETOA   ENTER ,                                               @SC91325 06995024
         USING KJIBMEUC,8                                      @SC91325 06995026
         LA    7,ETOA        One-byte table                    @SC91325 06995028
         L     8,=A(KJIBMEUC) Two-byte table (IBM for example) @SC91325 06995030
         MVI   KJDIR,1       Signal for E-to-A                 @SC91325 06995032
         BAL   9,KJCOPY      Set start of loop here            @SC91325 06995034
*                                                                       06995036
         LH    1,KJLSHFT     Length-1 of shift                 @SC91325 06995038
         CR    1,3           That much left?                   @SC91325 06995040
         BNL   KJEA2         Not enough for the whole shift    @SC91325 06995042
         EX    1,KJCMP2      Shift?                            @SC91325 06995044
         BNE   KJEA1         No                                @SC91325 06995046
         MVI   KJSTATE,2     Yes                               @SC91325 06995048
         B     KJESHZ        Gobble the shift                  @SC91325 06995050
KJEA1    EX    1,KJCMP1      Shift to Roman?                   @SC91325 06995052
         BNE   KJEA2         No                                @SC91325 06995054
         MVI   KJSTATE,1     Yes                               @SC91325 06995056
KJESHZ   SR    3,1           Yes, deduct length                @SC91325 06995058
         AR    4,1           Yes, deduct length                @SC91325 06995060
         B     KJONEZ        Gobble the shift                  @SC91325 06995062
KJCMP1   CLC   0(,4),KJSHF1  Shifting to Roman state?          @SC91325 06995064
KJCMP2   CLC   0(,4),KJSHF2  Shifting to Kanji state?          @SC91325 06995066
*                                                                       06995068
KJEA2    CLI   KJSTATE,1     Non-Kanji state?                  @SC91325 06995070
         BE    KJEA3         Yes, copy and translate one byte  @SC91325 06995072
         C     3,F1          No, do we have two to do?         @SC91325 06995074
         BNH   KJDONE        No, drop the extra                @SC91325 06995076
         CLI   1(4),X'FF'    Valid Kanji?                      @SC91325 06995078
         BE    KJDFLT        No, use default                   @SC91325 06995080
         CLC   1(,4),KJBOF+3 Valid Kanji?                      @SC91325 06995082
         BL    KJDFLT        No, use default                   @SC91325 06995084
         B     KJTWO         Ok so far                         @SC91325 06995086
*                                                                       06995088
KJEA3    MVC   0(1,2),0(4)   Copy one byte                     @SC91325 06995090
         TR    0(1,2),0(7)   And translate according to table  @SC91325 06995092
         CLI   0(2),X'8E'    Confused with Katakana prefix?    @SC91325 06995094
         BE    KJEA4         Yes, prefix it                    @SC91325 06995096
         CLI   0(2),X'A1'    Confused with Kanji?              @SC91325 06995098
         BL    KJONEY        No, go ahead with single-byte     @SC91325 06995100
KJEA4    MVC   1(1,2),0(2)   Insert Katakana prefix            @SC91325 06995102
         MVI   0(2),X'8E'                                      @SC91325 06995104
         LA    2,2(,2)       Update output ptr                 @SC91325 06995106
         B     KJONEZ        Now gobble input character        @SC91325 06995108
*                                                                       06995110
* Setup buffer by making a 2nd copy of the source -- use the   @SC91325 06995112
*  first area as the output buffer.                            @SC91325 06995114
KJCOPY   LR    6,2           Save buffer ptr                   @SC91325 06995116
         LA    4,1(,3)       Length of string + 1              @SC91325 06995118
         SRA   4,1                                             @SC91325 06995120
         AR    4,3           Get 1.5 * length in all           @SC91325 06995122
         LA    5,0(3,4)      Must have room for 2.5 times len  @SC91325 06995124
         C     5,F64KP       Assume big buffer                 @SC91325 06995126
         BNL   RTRNM1        Not big enough                    @SC91325 06995128
         AR    4,2           Temporary storage for info        @SC91325 06995130
         LR    5,3           Copy length                       @SC91325 06995132
         AR    3,3           Double so it will end right       @SC91325 06995134
         MVCL  4,2           Make a copy                       @SC91325 06995136
         SR    4,3           Back up for input ptr             @SC91325 06995138
         SR    2,3           Back up for output ptr            @SC91325 06995140
         MVI   KJSTATE,1     Always start in Roman mode        @SC91325 06995142
         CLC   =C'FUJ',FILALF Fujitsu Kanji codes?             @SC91325 06995144
         BNE   *+8           No                                @SC91325 06995146
          L    8,=A(KJFUJITS) Yes, only one table both ways    @SC91325 06995148
         CLC   =C'HIT',FILALF Hitachi Kanji codes?             @SC91325 06995150
         BNE   *+8           No                                @SC91325 06995152
          L    8,=A(KJHITACH) Yes, only one table both ways    @SC91325 06995154
         BR    9             Start the loop                    @SC91325 06995156
*                                                                       06995158
KJATOE   ENTER ALT                                             @SC91325 06995160
         LA    7,ATOE        One-byte table                    @SC91325 06995162
         L     8,=A(KJEUCIBM) Two-byte table                   @SC91325 06995164
         MVI   KJDIR,2       Signal for A-to-E                 @SC91325 06995166
         BAL   9,KJCOPY      Set start of loop here            @SC91325 06995168
*                                                                       06995170
         CLI   0(4),X'FF'    meta-DEL?                         @SC91325 06995172
         BE    KJAE1         Yes, treat as one-byte code       @SC91325 06995174
         CLI   0(4),X'A1'                                      @SC91325 06995176
         BNL   KJAE2                                           @SC91325 06995178
         CLI   0(4),X'8E'    Katakana prefix?                  @SC91325 06995180
         BNE   KJAE1         No, treat as ordinary 1-byte code @SC91325 06995182
         BCTR  3,0           Yes, skip prefix                  @SC91325 06995184
         LTR   3,3           See if another byte               @SC91325 06995186
         BZ    KJDONE        No, error                         @SC91325 06995188
         LA    4,1(,4)       Ok, treat that as Katakana        @SC91325 06995190
*        OI    0(4),X'80'    Make sure (needed?)               @SC91325 06995192
KJAE1    CLI   KJSTATE,1     Shifting to non-Kanji state       @SC91325 06995194
         BE    KJONE         Already there                     @SC91325 06995196
         MVC   0(2,2),KJSHF1 Insert shift                      @SC91325 06995198
         AH    2,KJLSHFT     In case of 2-byte shift           @SC91325 06995200
         LA    2,1(,2)                                         @SC91325 06995202
         MVI   KJSTATE,1                                       @SC91325 06995204
KJONE    MVC   0(1,2),0(4)   Copy one byte                     @SC91325 06995206
         TR    0(1,2),0(7)   And translate according to table  @SC91325 06995208
KJONEY   LA    2,1(,2)       Update output ptr                 @SC91325 06995210
KJONEZ   LA    4,1(,4)       Gobble input byte                 @SC91325 06995212
         BCTR  3,9                                             @SC91325 06995214
         B     KJDONE        Finished                          @SC91325 06995216
*                                                                       06995218
KJAE2    C     3,F1          No, do we have two to do?         @SC91325 06995220
         BNH   KJDONE        No, drop the extra                @SC91325 06995222
         CLI   1(4),X'A1'    Valid Kanji?                      @SC91325 06995224
         BL    KJONEZ        No, discard seemingly valid byte  @SC91325 06995226
         CLI   KJSTATE,2     Yes, switch to Kanji state        @SC91325 06995228
         BE    KJTWO         Already there, ok                 @SC91325 06995230
         MVC   0(2,2),KJSHF2 Insert shift                      @SC91325 06995232
         AH    2,KJLSHFT     In case of 2-byte shift           @SC91325 06995234
         LA    2,1(,2)       Update output ptr                 @SC91325 06995236
         MVI   KJSTATE,2                                       @SC91325 06995238
KJTWO    SR    0,0                                             @SC91325 06995240
         ICM   0,3,0(4)      Get two bytes                     @SC91325 06995242
         S     0,KJBOF       Remove byte offsets               @SC91325 06995244
         BM    KJDFLT        Invalid (happens only for ETOA)   @SC91325 06995246
         LR    1,4                                             @SC91325 06995248
         CLC   KJLSIZ,=H'0'  Null translation?                 @SC91325 06995250
         BE    KJ2COP        Yes, just copy input bytes        @SC91325 06995252
         SRDL  0,8           Convert into table index          @SC91325 06995254
         MH    0,KJLSIZ      Size of a layer in table          @SC91325 06995256
         SRL   1,24          Offset within layer               @SC91325 06995258
         AR    1,0                                             @SC91325 06995260
         AR    1,1           Double for byte pointer           @SC91325 06995262
         CH    1,KJTSIZ      Within table?                     @SC91325 06995264
         BL    *+8           Ok                                @SC91325 06995266
KJDFLT    LH   1,=H'-2'      No, use the default               @SC91325 06995268
         LA    1,KJTBL0(1,8) Add start of table                @SC91325 06995270
KJ2COP   MVC   0(2,2),0(1)   Copy to output                    @SC91325 06995272
         LA    2,2(,2)                                         @SC91325 06995274
         LA    4,2(,4)                                         @SC91325 06995276
         S     3,F2                                            @SC91325 06995278
         BPR   9                                               @SC91325 06995280
*                                                                       06995282
KJDONE   CLI   KJDIR,2       Doing A-to-E?                     @SC91325 06995284
         BNE   KJRET         No, all done                      @SC91325 06995286
         CLI   KJSTATE,1     Ending in Roman state?            @SC91325 06995288
         BE    KJRET         Yes, everything's ok              @SC91325 06995290
         MVC   0(2,2),KJSHF1 Insert shift to Roman             @SC91325 06995292
         AH    2,KJLSHFT     In case of 2-byte shift           @SC91325 06995294
         LA    2,1(,2)                                         @SC91325 06995296
KJRET    LR    15,2                                            @SC91325 06995298
         SR    15,6                                            @SC91325 06995300
         RET   ,                                               @SC91325 06995302
*                                                                       06995304
         LOCALS ,                                              @SC91325 06995306
KJDIR    DS    X             Direction: 1=EtoA, 2=AtoE         @SC91325 06995308
KJSTATE  DS    X             State for Kanji translation       @SC91325 06995310
*                                                                       06995312
         EXIT  ,                                               @SC91325 06995314
KJTTBL   CSECT                                                 @SC91325 06995316
KJFUJITS DS    0F                                              @SC91325 06995318
         DC    XL4'A1A1'     First valid input code            @SC91325 06995320
         DC    H'0,0'        Size of each layer (no table!)    @SC91325 06995322
         DC    Y(1-1)        Length-1 of shift codes           @SC91325 06995324
         DC    X'29',3X'0'   Enter Roman mode                  @SC91325 06995326
         DC    X'28',3X'0'   Enter Kanji mode                  @SC91325 06995328
         DC    X'A1A1'       Default for invalid input codes   @SC91325 06995330
*                                                                       06995332
KJHITACH DS    0F                                              @SC91325 06995334
         DC    XL4'A1A1'     First valid input code            @SC91325 06995336
         DC    H'0,0'        Size of each layer (no table!)    @SC91325 06995338
         DC    Y(2-1)        Length-1 of shift codes           @SC91325 06995340
         DC    X'0A41',2X'0' Enter Roman mode                  @SC91325 06995342
         DC    X'0A42',2X'0' Enter Kanji mode                  @SC91325 06995344
         DC    X'A1A1'       Default for invalid input codes   @SC91325 06995346
*                                                                       06995348
KJIBMEUC DS    0F                                              @SC91325 06995350
KJBOF    DC    XL4'4141'     First valid input code            @SC91325 06995352
KJLSIZ   DC    H'190'        Size of each layer                @SC91325 06995354
KJTSIZ   DC    Y(KJIBMZ-KJIBMEUC-KJTBL0) Total size of table   @SC91325 06995356
KJLSHFT  DC    Y(1-1)        Length-1 of shift codes           @SC91325 06995358
KJSHF1   DC    X'0F',3X'0'   Enter Roman mode                  @SC91325 06995360
KJSHF2   DC    X'0E',3X'0'   Enter Kanji mode                  @SC91325 06995362
         DC    X'A1A1'       Default for invalid input codes   @SC91325 06995364
KJTBL0   EQU   *-KJIBMEUC                                      @SC91325 06995366
         HTBL       A6C1,A6C2,A6C3,A6C4,A6C5,A6C6,A6C7         @SC91325 06995368
         HTBL  A6C8,A6C9,A6CA,A6CB,A6CC,A6CD,A6CE,A6CF         @SC91325 06995370
         HTBL  A6D0,A6D1,A6D2,A6D3,A6D4,A6D5,A6D6,A6D7         @SC91325 06995372
         HTBL  A6D8,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995374
         HTBL  A1A1,A6A1,A6A2,A6A3,A6A4,A6A5,A6A6,A6A7         @SC91325 06995376
         HTBL  A6A8,A6A9,A6AA,A6AB,A6AC,A6AD,A6AE,A6AF         @SC91325 06995378
         HTBL  A6B0,A6B1,A6B2,A6B3,A6B4,A6B5,A6B6,A6B7         @SC91325 06995380
         HTBL  A6B8,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995382
         HTBL  A7D1,A7D2,A7D3,A7D4,A7D5,A7D6,A7D7,A7D8         @SC91325 06995384
         HTBL  A7D9,A7DA,A7DB,A7DC,A7DD,A7DE,A7DF,A7E0         @SC91325 06995386
         HTBL  A7E1,A7E2,A7E3,A7E4,A7E5,A7E6,A7E7,A7E8         @SC91325 06995388
         HTBL  A7E9,A7EA,A7EB,A7EC,A7ED,A7EE,A7EF,A7F0         @SC91325 06995390
         HTBL  A7F1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995392
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995394
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995396
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995398
         HTBL  A7A1,A7A2,A7A3,A7A4,A7A5,A7A6,A7A7,A7A8         @SC91325 06995400
         HTBL  A7A9,A7AA,A7AB,A7AC,A7AD,A7AE,A7AF,A7B0         @SC91325 06995402
         HTBL  A7B1,A7B2,A7B3,A7B4,A7B5,A7B6,A7B7,A7B8         @SC91325 06995404
         HTBL  A7B9,A7BA,A7BB,A7BC,A7BD,A7BE,A7BF,A7C0         @SC91325 06995406
         HTBL  A7C1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995408
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995410
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995412
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995414
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995416
         HTBL  A1F2,A1A5,A1E3,A1CA,A1DC,A1C3,A1F5,A1A1         @SC91325 06995418
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995420
         HTBL  A1AA,A1EF,A1F6,A1CB,A1A8,A1A1,A1DD,A1BF         @SC91325 06995422
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995424
         HTBL  A1A1,A1A4,A1F3,A1B2,A1E4,A1A9,A1A1,A1A1         @SC91325 06995426
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1AE         @SC91325 06995428
         HTBL  A1A7,A1F4,A1F7,A1C7,A1E1,A1A1,A1A1,A3E1         @SC91325 06995430
         HTBL  A3E2,A3E3,A3E4,A3E5,A3E6,A3E7,A3E8,A3E9         @SC91325 06995432
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A3EA         @SC91325 06995434
         HTBL  A3EB,A3EC,A3ED,A3EE,A3EF,A3F0,A3F1,A3F2         @SC91325 06995436
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1B1         @SC91325 06995438
         HTBL  A3F3,A3F4,A3F5,A3F6,A3F7,A3F8,A3F9,A3FA         @SC91325 06995440
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995442
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995444
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1D0,A3C1         @SC91325 06995446
         HTBL  A3C2,A3C3,A3C4,A3C5,A3C6,A3C7,A3C8,A3C9         @SC91325 06995448
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1D1,A3CA         @SC91325 06995450
         HTBL  A3CB,A3CC,A3CD,A3CE,A3CF,A3D0,A3D1,A3D2         @SC91325 06995452
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1F0,A1A1         @SC91325 06995454
         HTBL  A3D3,A3D4,A3D5,A3D6,A3D7,A3D8,A3D9,A3DA         @SC91325 06995456
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A3B0,A3B1         @SC91325 06995458
         HTBL  A3B2,A3B3,A3B4,A3B5,A3B6,A3B7,A3B8,A3B9         @SC91325 06995460
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A3,A1D6,A1D7         @SC91325 06995462
         HTBL  A1A2,A1A6,A5F2,A5A1,A5A3,A5A5,A1F1,A1A1         @SC91325 06995464
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A5A7,A5A9,A5E3         @SC91325 06995466
         HTBL  A5E5,A5E7,A5C3,A5EE,A1BC,A5F5,A5F6,A1A1         @SC91325 06995468
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995470
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995472
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995474
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995476
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A5A2,A5A4,A5A6         @SC91325 06995478
         HTBL  A5A8,A5AA,A5AB,A5AD,A5AF,A5B1,A5B3,A1A1         @SC91325 06995480
         HTBL  A5B5,A5B7,A5B9,A5BB,A5BD,A5BF,A5C1,A5C4         @SC91325 06995482
         HTBL  A5C6,A5C8,A5CA,A5CB,A5CC,A5CD,A5CE,A1A1         @SC91325 06995484
         HTBL  A1A1,A5CF,A5D2,A5D5,A1A1,A1C1,A5D8,A5DB         @SC91325 06995486
         HTBL  A5DE,A5DF,A5E0,A5E1,A5E2,A5E4,A5E6,A1A1         @SC91325 06995488
         HTBL  A5E8,A5E9,A5EA,A5EB,A1A1,A1A1,A1A1,A1A1         @SC91325 06995490
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A5EC,A5ED         @SC91325 06995492
         HTBL  A5EF,A5F3,A1AB,A1AC,A5AC,A5AE,A5B0,A5B2         @SC91325 06995494
         HTBL  A5B4,A5B6,A5B8,A5BA,A5BC,A5BE,A5C0,A5C2         @SC91325 06995496
         HTBL  A5C5,A5C7,A5C9,A5D0,A5D3,A5D6,A5D9,A5DC         @SC91325 06995498
         HTBL  A5F4,A5D1,A5D4,A5D7,A5DA,A5DD,A5F0,A5F1         @SC91325 06995500
         HTBL  A1B3,A1B4,A1A1,A1A1,A1C0,A1A1,A1A1,A1A1         @SC91325 06995502
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995504
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995506
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995508
         HTBL  A1A1,A1A1,A1A1,A1A1,A1D8,A1D9,A1CE,A1CF         @SC91325 06995510
         HTBL  A4F2,A4A1,A4A3,A4A5,A1BD,A1DE,A1E2,A1E7         @SC91325 06995512
         HTBL  A1EE,A1A1,A1AD,A4A7,A4A9,A4E3,A4E5,A4E7         @SC91325 06995514
         HTBL  A4C3,A4EE,A1A1,A1A1,A1BE,A1B7,A1B8,A1B9         @SC91325 06995516
         HTBL  A1BA,A1BB,A1AF,A1C6,A1C8,A1CC,A1D2,A1D4         @SC91325 06995518
         HTBL  A1DA,A1E5,A1E8,A1E9,A1F8,A2A8,A2A9,A1A1         @SC91325 06995520
         HTBL  A1A1,A1A1,A1B0,A1C7,A1C9,A1CD,A1D3,A1D5         @SC91325 06995522
         HTBL  A1DB,A1E6,A1A1,A1EA,A1DF,A1E0,A1C2,A2AE         @SC91325 06995524
         HTBL  A1C5,A1C4,A1A1,A4A2,A4A4,A4A6,A4A8,A4AA         @SC91325 06995526
         HTBL  A4AB,A4AD,A4AF,A4B1,A4B3,A1A1,A4B5,A4B7         @SC91325 06995528
         HTBL  A4B9,A4BB,A4BD,A4BF,A4C1,A4C4,A4C6,A4C8         @SC91325 06995530
         HTBL  A4CA,A4CB,A4CC,A4CD,A4CE,A1A1,A1A1,A4CF         @SC91325 06995532
         HTBL  A4D2,A4D5,A1A1,A1A1,A4D8,A4DB,A4DE,A4DF         @SC91325 06995534
         HTBL  A4E0,A4E1,A4E2,A4E4,A4E6,A1A1,A4E8,A4E9         @SC91325 06995536
         HTBL  A4EA,A4EB,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995538
         HTBL  A1A1,A1A1,A1A1,A1A1,A4EC,A4ED,A4EF,A4F3         @SC91325 06995540
         HTBL  A1A1,A1A1,A4AC,A4AE,A4B0,A4B2,A4B4,A4B6         @SC91325 06995542
         HTBL  A4B8,A4BA,A4BC,A4BE,A4C0,A4C2,A4C5,A4C7         @SC91325 06995544
         HTBL  A4C9,A4D0,A4D3,A4D6,A4D9,A4DC,A1A1,A4D1         @SC91325 06995546
         HTBL  A4D4,A4D7,A4DA,A4DD,A4F0,A4F1,A1B5,A1B6         @SC91325 06995548
         HTBL  A1A1,A1A1,A1FB,A1FC,A2A4,A2A5,A1FD,A1F9         @SC91325 06995550
         HTBL  A1FA,A1FE,A2A1,A2A2,A2A3,A2A6,A2A7,A1EB         @SC91325 06995552
         HTBL  A1EC,A1ED,A2AA,A2AB,A2AC,A2AD,A1A1,A1A1         @SC91325 06995554
         HTBL  A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1,A1A1         @SC91325 06995556
         HTBL  A1A1,B0EC,C6F3,BBB0,BBCD,B8DE,CFBB,BCB7         @SC91325 06995558
         HTBL  C8AC,B6E5,BDBD,C9B4,C0E9,CBFC,B2AF,C5D4         @SC91325 06995560
         HTBL  C6BB,C9DC,B8A9,BBD4,B6E8,C4AE,C2BC,C5EC         @SC91325 06995562
         HTBL  C0BE,C6EE,CBCC,C2E7,C3E6,BEAE,BEE5,B2BC         @SC91325 06995564
         HTBL  C7AF,B7EE,C6FC,C5C4,BBD2,BBB3,CBDC,C0EE         @SC91325 06995566
         HTBL  C6A3,CCEE,B9A9,B6C8,CCDA,B0E6,CFBA,C5E7         @SC91325 06995568
         HTBL  CDBA,B9E2,B2AC,C9D7,B8B6,B5FE,BAB4,C0B5         @SC91325 06995570
         HTBL  BEBE,B5A1,CFC2,C0BD,C3CB,C8FE,B5C8,BAEA         @SC91325 06995572
         HTBL  C0D0,C3AB,C5C5,C4B9,BCA3,C2F4,B6E2,BFB7         @SC91325 06995574
         HTBL  B8FD,B6B6,B5D7,CAA1,BDEA,CABF,C6E2,B9F1         @SC91325 06995576
         HTBL  B2BD,BAE5,B5DC,BFCD,BAEE,C9F4,C0B6,BCA1         @SC91325 06995578
         HTBL  B5C1,C0B8,C2E5,BDD0,BFE5,BFB9,B8F7,B2C3         @SC91325 06995580
         HTBL  B9E7,BFC0,CED3,BDC5,B9D4,BFAE,CCC0,B3A4         @SC91325 06995582
         HTBL  B0C2,B9AC,CADD,C2C0,C9D9,B9BE,CEEB,C1B0         @SC91325 06995584
         HTBL  C3CE,C9F0,B0CB,BEBC,CAAC,BEA1,CDD1,B9AD         @SC91325 06995586
         HTBL  C2A4,B5A4,C0AE,B8AB,CDF8,B2F1,B3D8,B4E4         @SC91325 06995588
         HTBL  BBBA,B4D6,C3CF,BCAB,CEC9,B4D8,B0A6,C0AF         @SC91325 06995590
         HTBL  C8F8,B7D7,CAB8,BCEA,C9E3,CAFD,BBF6,B8CD         @SC91325 06995592
         HTBL  C9CA,B4EE,C5CF,B9B0,B8C5,CAD5,C1D2,C5B4         @SC91325 06995594
         HTBL  C7B7,BEEC,CDCE,BEEB,C4C5,CEA9,C5D9,B8E1         @SC91325 06995596
         HTBL  BAA3,C9A7,C0DF,C4CC,C6B0,B8E5,C6E0,C4EA         @SC91325 06995598
         HTBL  C3D3,B2B0,C9CD,CDFD,BAE4,BCC2,B1D1,C5AA         @SC91325 06995600
         HTBL  BBCA,BDA8,B2A3,CCBE,B9A7,C3DD,C7EE,CECF         @SC91325 06995602
         HTBL  B8CB,CDD5,B1C9,B1CA,B4EF,B6CC,C2BF,B2EC         @SC91325 06995604
         HTBL  BFBF,B7C3,C0C5,B1DF,CCD0,C9D2,CBAD,CABC         @SC91325 06995606
         HTBL  CBA1,C8AF,C0C4,C1FD,CEC1,C3E9,BBF1,BBFE         @SC91325 06995608
         HTBL  CAAA,BCD6,C6C1,CDD7,C2D0,C4CD,BDA9,C7F2         @SC91325 06995610
         HTBL  B2CF,C0A5,CCFD,CEB4,C2A2,C5F6,BDD3,BBD6         @SC91325 06995612
         HTBL  BDD5,BCD2,C7CF,C6FE,B7FA,BAAC,BFF9,BFCA         @SC91325 06995614
         HTBL  B6BD,B1BA,C0BA,C6B1,C0AD,CAC6,BCD4,BDF5         @SC91325 06995616
         HTBL  BBDE,B6E1,C4BE,CCDC,CDE8,B2E8,C1EA,B9F5         @SC91325 06995618
         HTBL  B4DD,C1A5,CDB3,BBCE,C2E8,B7A7,BBE6,B7F2         @SC91325 06995620
         HTBL  B3A3,CBA7,C5DA,CDAD,B2C8,C0FE,B7D0,C4B4         @SC91325 06995622
         HTBL  C5B7,B4FC,C3D6,C0F5,C0C6,BCB0,B7C1,CCCC         @SC91325 06995624
         HTBL  BCEF,CDA2,B3B0,B8B5,C2CE,BCAF,B8E6,BDF7         @SC91325 06995626
         HTBL  B9AF,C0A4,CDA6,CBD9,B9A5,BBF9,BBFB,B9DD         @SC91325 06995628
         HTBL  C6C3,BAEB,C3A3,B8FE,BCE8,C5F9,C3D2,B2F3         @SC91325 06995630
         HTBL  CCE7,B1BF,C8F7,BBD7,B0A4,C9D4,BFDC,C1B4         @SC91325 06995632
         HTBL  BCF7,C1B1,C8C4,C8D3,C4E7,B8BD,BFA9,C1C8         @SC91325 06995634
         HTBL  CEE0,B8F8,BAE0,B9E1,BEA6,B7EB,C9BD,CCF0         @SC91325 06995636
         HTBL  B3E3,BBE4,C0A9,CBAE,BEC2,BBE5,B9A8,BAF6         @SC91325 06995638
         HTBL  C7C8,B0F7,BFF4,B3AB,BDE0,BCF9,C8F1,BEBB         @SC91325 06995640
         HTBL  B6AF,B8A6,CDA7,B1A7,BCE3,B5C6,BBFD,B2D6         @SC91325 06995642
         HTBL  B0FA,B5AA,B9D3,CACC,BDA4,B1DB,BDBB,CCF4         @SC91325 06995644
         HTBL  CCD3,B1F3,CCE4,B1FC,B7BF,BFB4,C5D0,C1E1         @SC91325 06995646
         HTBL  CCF8,B9C0,BCC1,CCB3,C0F4,BEEF,BCE9,B4F0         @SC91325 06995648
         HTBL  B4C9,C2D9,BFAD,BAC7,B0CA,B2CE,CDB5,C0D6         @SC91325 06995650
         HTBL  C2AD,B5AC,CEAE,C0BF,BEBA,BDA3,BEC8,B1F6         @SC91325 06995652
         HTBL  C1F7,B2ED,CBF6,C5AF,B4DF,CCE9,B4F4,BDE9         @SC91325 06995654
         HTBL  B0F1,C2A7,C8E6,C7BD,CFC3,C5EA,C5BE,BFFB         @SC91325 06995656
         HTBL  CFA2,C2BE,CCB1,B5EB,BCF2,C8CB,B2C1,CBFE         @SC91325 06995658
         HTBL  C4AB,C9D5,BEF2,CCB5,B9CD,B3DA,BCE7,B0D5         @SC91325 06995660
         HTBL  C0EF,C0DA,BADE,CAD2,BAD9,BAD1,B0F0,C9DB         @SC91325 06995662
         HTBL  CEA4,C2B0,BECF,CAD1,B2BF,BAF9,C8E0,BABA         @SC91325 06995664
         HTBL  B1D7,C7E4,BFCE,BFBC,C2E6,C4BB,C4E1,BBD9         @SC91325 06995666
         HTBL  C0B0,B3D1,B2C5,CCA3,B1D2,B5C4,B0B5,CEA8         @SC91325 06995668
         HTBL  CFA9,B2D0,C9EC,B5B1,C5C0,CDBF,B8BA,C8AA         @SC91325 06995670
         HTBL  B6E4,B6F5,B8F2,B1A9,C8BE,BCFD,B1FB,C1ED         @SC91325 06995672
         HTBL  B5AD,C0B2,B9BD,BADD,C7DF,B0F5,B8C0,B7AA         @SC91325 06995674
         HTBL  BFC8,BDF1,B9EE,C1C7,BDB8,C0E1,C0E8,C2EC         @SC91325 06995676
         HTBL  B7E8,B6B5,BDE3,BCC6,C0DC,C0B1,C3E5,CEB1         @SC91325 06995678
         HTBL  B1C7,B8CA,B3A6,B6F1,B7C9,B7B2,BDE7,B6A6         @SC91325 06995680
         HTBL  B3E8,CECC,BBD8,B2F2,BCBC,B2CC,B3C6,CBBE         @SC91325 06995682
         HTBL  CBC9,CCF3,B7FB,CDDB,B5B5,BFDE,CDBD,BFA7         @SC91325 06995684
         HTBL  C0C7,BFA2,B2C4,B9B1,B0CC,C5B5,C9AC,C2B3         @SC91325 06995686
         HTBL  B5DE,BADF,B3C0,B7AF,B1E4,C5E8,B4EB,C6CA         @SC91325 06995688
         HTBL  C9FE,C7AE,B3E4,B6A8,CAE2,BBCB,CDA5,BAD8         @SC91325 06995690
         HTBL  CBBC,BDA1,B3CA,C3A4,B3DE,B1E0,BDF4,CFC6         @SC91325 06995692
         HTBL  B7BC,B8AD,CCEF,C9F7,C6C0,B0D7,C2C7,C6AC         @SC91325 06995694
         HTBL  B0B0,C3CA,C0AA,C1B3,C3C4,B3DB,CDEE,C7DB         @SC91325 06995696
         HTBL  C4F8,C4D4,B8E3,B4B6,B4B2,C8BF,CCAD,BCFB         @SC91325 06995698
         HTBL  B8BB,B2AD,C2EA,B9FE,C1F0,BBBB,C0B9,C7C0         @SC91325 06995700
         HTBL  C6E1,BECA,CDCD,C5C2,BEAF,B2F0,BCF5,B2BB         @SC91325 06995702
         HTBL  CAD4,B0D1,BEB1,B7B8,BEF5,BCA8,C5B9,C9B2         @SC91325 06995704
         HTBL  B3F4,BCA2,CDFC,C6EC,B1A6,BAB8,B5DA,C1AA         @SC91325 06995706
         HTBL  B5EF,BEF0,CEFD,C3BA,B4DB,B9DB,CCCF,BCEC         @SC91325 06995708
         HTBL  C0D3,B0A1,C1A1,C3E7,C5C9,BEC3,BDD1,B8A1         @SC91325 06995710
         HTBL  CFAF,C2F0,B8F9,BEB0,CBC7,B1D9,BBE9,BCC4         @SC91325 06995712
         HTBL  B2C2,CBC2,C9DA,B7AC,B3CE,CBD2,CAC2,C3CD         @SC91325 06995714
         HTBL  B4D1,B5AE,B0DD,C5FD,BDC9,CEBE,C5FC,BFC6         @SC91325 06995716
         HTBL  CFBF,C0A1,BBDC,CDC6,C8F4,B6C9,CDB4,B2E1         @SC91325 06995718
         HTBL  BBE1,B2FE,C8D7,C0D1,BDC2,B4AC,BDDF,B1FE         @SC91325 06995720
         HTBL  C1E8,B7B3,C1F5,BBC0,BFA5,C0F7,C4EB,CCCA         @SC91325 06995722
         HTBL  CAB4,B9D2,B9C3,BCFE,C0E7,C2D4,C4E3,CED0         @SC91325 06995724
         HTBL  B7DA,CBE3,B7C4,CFAB,B0EB,C3B0,B0E9,B8C2         @SC91325 06995726
         HTBL  C6B3,CAFC,B9B8,BAC2,B7EF,C1DB,B8B3,BBC5         @SC91325 06995728
         HTBL  BBC8,CED8,B4E9,C8D6,C4A5,CAB9,B6A1,C5F2         @SC91325 06995730
         HTBL  CDCF,B9BB,C6BC,C3F2,CDBB,CCF7,BCCC,B4B0         @SC91325 06995732
         HTBL  B9C1,C3C3,CCEB,BDBC,CEB6,B9CB,C9A9,C2AE         @SC91325 06995734
         HTBL  CAD9,BAFE,B5AF,CBE0,BBB2,B1C4,CAE6,BFE4         @SC91325 06995736
         HTBL  CAD6,BFA6,BBDF,C5C1,B4B4,B5E5,B8A2,C5B8         @SC91325 06995738
         HTBL  C8A8,B3EB,C4ED,C8F3,B9E6,C3B1,BAD0,B3C8         @SC91325 06995740
         HTBL  BDE8,B8EC,BAF2,B0E8,CAA5,BAC6,C6AF,B2CA         @SC91325 06995742
         HTBL  B5FB,C3BC,C5D3,B0C6,BBFA,CFC0,B7F3,CBF4         @SC91325 06995744
         HTBL  BFB6,B5BB,C5B0,BBA5,B7CF,BDBE,CEE4,C2D6         @SC91325 06995746
         HTBL  CAF6,BCBA,B8FC,C2A6,C3ED,C2AC,BAA2,BEE8         @SC91325 06995748
         HTBL  BBEE,C4DA,C7EB,C5DE,B5A5,CAF5,B6B3,C8F5         @SC91325 06995750
         HTBL  B2B9,C9DF,C0E2,B7DD,B9F0,CEF2,C8CC,BEFE         @SC91325 06995752
         HTBL  CEE9,BEAD,C6F1,BABD,C8BD,CCF2,B1C6,C1BE         @SC91325 06995754
         HTBL  C2D3,CEA6,B3F9,C3CC,BEB4,B0AD,C9B8,BFBD         @SC91325 06995756
         HTBL  B3B2,CAEC,CAE4,CBDA,C0BC,BDFC,BAFB,C9D8         @SC91325 06995758
         HTBL  B4A5,B6A5,BCC7,B5ED,C7E3,B0DC,BECB,C3E3         @SC91325 06995760
         HTBL  B8FA,CDDC,B7AE,C8EE,B8AC,CFA7,B2C6,C6B2         @SC91325 06995762
         HTBL  C7F0,CAA7,B5A2,BEC6,CEB2,CFB7,B5E6,BFB3         @SC91325 06995764
         HTBL  BFCB,C3C7,BCCD,BAB9,CDF2,C0DE,C2D1,C0EB         @SC91325 06995766
         HTBL  BBCF,CEA7,BBC4,B7CA,BEDD,B6BF,C2EE,CEA5         @SC91325 06995768
         HTBL  B7B0,BBE0,B9CC,C1E0,CEBC,B1BE,B7B4,B6D0         @SC91325 06995770
         HTBL  B5E1,B4D3,B4B1,BACA,CEA2,B4E3,C7EC,CDD2         @SC91325 06995772
         HTBL  C3DB,B3AC,B4B9,B7CB,B1D8,B3E1,B6D1,BAE2         @SC91325 06995774
         HTBL  CCBF,B2A6,B3F7,B0EA,CBE1,BED0,B6CA,B6CB         @SC91325 06995776
         HTBL  CAF3,C4F3,BEDA,C0E3,B0E3,BADB,BCF3,C9C2         @SC91325 06995778
         HTBL  B6CD,CDBE,B4A4,CEE1,BFE1,C3F6,CCA4,B9E4         @SC91325 06995780
         HTBL  C9E9,C8BC,B5B7,B4DE,C5AC,CBF8,BFAC,B4E0         @SC91325 06995782
         HTBL  C5FA,C4C9,C6A4,BEE6,B1F4,C7B3,B2DD,B0D9         @SC91325 06995784
         HTBL  B1A1,CBE7,C8E9,B8EE,B0BD,B1AB,B2E6,B4F3         @SC91325 06995786
         HTBL  B2AE,B2A1,C7BC,B4C6,CBA5,B9DF,B7BD,CEB5         @SC91325 06995788
         HTBL  C8CF,BBA6,B3AD,B1DD,B6F8,B1E9,C0EA,C7F7         @SC91325 06995790
         HTBL  B7E0,BACD,C6D8,B5E9,BDAA,CBE8,B8A8,BDCC         @SC91325 06995792
         HTBL  C9E1,BECD,B8C4,C0EC,B6F0,C9BE,C8AB,C2B8         @SC91325 06995794
         HTBL  C6F9,B7B9,BBD5,B1D5,CEE3,BFC3,BBEA,B0F8         @SC91325 06995796
         HTBL  B7D1,D6E1,B3D0,B9C2,C0F6,C6C9,BBEB,CCD4         @SC91325 06995798
         HTBL  B5F0,CCD6,C2DE,C7A4,CCA9,C2B5,B6B7,C3F8         @SC91325 06995800
         HTBL  B3D3,B5A3,B6C1,C8CE,C9FD,B6EC,C1BC,C0AC         @SC91325 06995802
         HTBL  BCA7,C9F1,C5D8,B7A6,CCAF,B9B3,CAE5,BDAC         @SC91325 06995804
         HTBL  C2A5,BAC8,B8B1,B9B9,B9D6,B4B3,C9FC,CBAC         @SC91325 06995806
         HTBL  C7C9,C6C4,B7E2,BCB1,BFB5,BAA7,C4B6,CED5         @SC91325 06995808
         HTBL  CDEA,BCED,BAE6,B6D2,C7A7,CAC1,C4F9,B5D9         @SC91325 06995810
         HTBL  C3BB,C9FA,C6D2,C8B4,C6F4,B0E5,CDE4,B1B1         @SC91325 06995812
         HTBL  BBA8,CDB7,C9E2,B6C0,C1D8,BBF4,BAEF,C5BA         @SC91325 06995814
         HTBL  C7F6,C2E2,B8C7,B6AD,CBD3,B9E0,C6FD,C6A6         @SC91325 06995816
         HTBL  B5F6,BDEF,BDD2,CFB2,B0CD,BBF5,B2A4,C3B4         @SC91325 06995818
         HTBL  BDFE,B3D7,B5D1,B9FC,B5CF,B6DE,CAF1,B0DB         @SC91325 06995820
         HTBL  C1F6,B8D7,CAF7,BEDE,C7B0,CCB6,B3A7,B8E7         @SC91325 06995822
         HTBL  C7D8,C9B1,C3A6,B4F5,C2F7,C6AB,C9C4,B4C4         @SC91325 06995824
         HTBL  BEF8,CBCD,B1C0,C8C7,C7CB,BDCA,BEC4,B3C1         @SC91325 06995826
         HTBL  B7E9,CDBC,C7DC,B8A4,B2AB,C9AE,B5B4,BBB6         @SC91325 06995828
         HTBL  B5EE,CDB6,B3F8,CECE,C7BB,CEB9,BCDA,CDD3         @SC91325 06995830
         HTBL  BDE1,BDB5,C3C6,B1E7,B0EF,B7D9,C6C6,C7FA         @SC91325 06995832
         HTBL  C5ED,C6C8,C2B2,B0B2,B5D2,C6EF,C7FE,CAE7         @SC91325 06995834
         HTBL  C0CF,B3DD,B3A8,B8B2,CCA6,B7F8,C0C1,B3D5         @SC91325 06995836
         HTBL  B0E1,B2DF,B5A8,BEB2,B8E2,B9C5,BBE7,B9D7         @SC91325 06995838
         HTBL  C2B4,C0E4,C2DF,B3A5,B8C6,B8CE,BEBD,CEE8         @SC91325 06995840
         HTBL  B0CF,C8A2,CBCF,C6CD,CAEB,C8A5,BBD1,B7EC         @SC91325 06995842
         HTBL  BAA4,C3DE,BAAE,CADB,C6E9,C2E0,CBF3,C2AB         @SC91325 06995844
         HTBL  CAD8,C4C2,C9FB,BACE,CFA4,CAA3,BAE7,C0CA         @SC91325 06995846
         HTBL  CCBC,B4C5,CCC8,B4F6,BAC4,BFB2,CBC0,BFF0         @SC91325 06995848
         HTBL  C4D0,C8F9,BBCC,B5CD,C0A3,C4E9,C1F1,B5DD         @SC91325 06995850
         HTBL  C4EC,C5F4,BFD3,B9C8,C1DA,B7AB,C5DD,B7F4         @SC91325 06995852
         HTBL  B2DA,C2A8,BCE5,B3DF,CCC4,C1D0,BDA7,B5FD         @SC91325 06995854
         HTBL  B8DF,E8DF,BBEF,B4FB,B5F9,B8AA,C2EB,BEF9         @SC91325 06995856
         HTBL  C5FB,CAC4,CDE1,C3B5,C8E5,B4A8,B5F3,C3AF         @SC91325 06995858
         HTBL  CCC1,B3BE,B7EA,C7F5,BDB0,C1EF,C7D4,CCB4         @SC91325 06995860
         HTBL  C9ED,C8EF,B6D3,B6DA,C4F1,B4ED,C4A3,BBA1         @SC91325 06995862
         HTBL  CABB,CAC9,C6E7,B6DB,B5DB,BCEE,B4AA,B4A2         @SC91325 06995864
         HTBL  C8D8,B6D5,B3CB,C7B5,C4C7,B2D9,B3EA,B0FB         @SC91325 06995866
         HTBL  B9F8,B3B9,BCB4,C4F7,BADA,B7DE,B1EF,C5E2         @SC91325 06995868
         HTBL  B5FC,CCF5,BFDD,B2F6,C2A9,CEBB,BFB8,BCCE         @SC91325 06995870
         HTBL  CEF3,C0BB,C8A1,CEC5,BDAE,B6F9,C1FC,C0A7         @SC91325 06995872
         HTBL  BBF7,B2B5,C3AE,CDF0,BBC9,BFDB,B5CC,C2D8         @SC91325 06995874
         HTBL  CAFE,B9B6,CFAA,C7D1,B7B1,BFE2,CEF8,C3EE         @SC91325 06995876
         HTBL  C6AE,C7BA,C3FA,C9C1,B7E3,BCD0,C0D5,B3FD         @SC91325 06995878
         HTBL  BED1,B6B2,CDEB,C7A6,C2BB,B9A6,C6A9,C2F3         @SC91325 06995880
         HTBL  CBE5,B1EC,C5DF,BECE,CDA3,C1CF,B0C5,B6BB         @SC91325 06995882
         HTBL  CFCB,CAA9,C5E0,B1AD,B7BB,C1EB,C3EC,CEDD         @SC91325 06995884
         HTBL  B4CA,B9D5,BDA2,C3AA,B6FC,CFC9,B4F8,C5A8         @SC91325 06995886
         HTBL  CFA1,B9EF,CDDF,C7B4,C7A1,BEE3,C7C6,B0C0         @SC91325 06995888
         HTBL  B5D5,BEB7,CDCB,CAE1,B3B5,BAC5,CCE1,CBBA         @SC91325 06995890
         HTBL  CDC8,C4CB,BEB5,CEB8,B4CF,C7F4,BCD1,B8DB         @SC91325 06995892
         HTBL  BAE1,C8DD,C5E1,B2DB,B7BA,C1D5,B3FB,CBB7         @SC91325 06995894
         HTBL  C6DE,B4EA,BCCB,C0CE,B1EE,BDFD,B5DF,CDC7         @SC91325 06995896
         HTBL  C2B9,B6AC,B2F7,BCF8,C3F9,C7D5,B7C0,B0D2         @SC91325 06995898
         HTBL  C1E7,C1E3,B9EB,B0B7,C3D7,BCDC,C5CC,C3D9         @SC91325 06995900
         HTBL  B8BC,CEFB,C8EB,BAD7,C6A8,B6DD,C4A7,BCB5         @SC91325 06995902
         HTBL  C8E3,BBA3,B9C9,BCA4,CEC0,B5EC,C2A3,B8B4         @SC91325 06995904
         HTBL  B4AB,BFF2,CEF0,B2B8,B1AC,B6C7,BFD8,CBB9         @SC91325 06995906
         HTBL  CAFA,C4DE,CCAB,C4C3,BFC1,B6E7,B4CE,BFFE         @SC91325 06995908
         HTBL  B8B7,C4C0,BCBE,B0F4,CDB8,C4AC,C3DF,CCF9         @SC91325 06995910
         HTBL  E6FB,C6C7,C3EB,BDF0,B2D1,C4EF,C1C3,C8E1         @SC91325 06995912
         HTBL  B6B9,C1D4,CAA2,CCF6,CDFA,B9AA,C9B9,C3B8         @SC91325 06995914
         HTBL  CDF6,C8C8,CDD9,CEB3,B4DC,BCAA,B9B5,C1AD         @SC91325 06995916
         HTBL  B8F5,CFD3,BBED,C6F0,CBBD,C7BE,B5BF,B7E7         @SC91325 06995918
         HTBL  C8D5,CDB9,B6FA,B7BE,C4D8,B9C4,BAD2,BAB0         @SC91325 06995920
         HTBL  BBFC,C1C9,BDD9,BBD0,CBA4,BAD5,C8F2,B8D4         @SC91325 06995922
         HTBL  C7A2,C4AA,BEE2,BEF4,CBEB,C5E3,CCA7,C0D7         @SC91325 06995924
         HTBL  CBB4,C6DA,CED7,BFA8,B1A2,B7F5,C9D3,B6C3         @SC91325 06995926
         HTBL  C5DC,B4A9,B6D7,CAC7,B0E4,B1B4,C1C4,C5FE         @SC91325 06995928
         HTBL  BAE9,C1CA,CED9,C7D0,BDC6,C4E0,BED2,B7A8         @SC91325 06995930
         HTBL  CDA4,CDED,CEE6,C1AF,B1FD,BDCB,B1F2,BCF1         @SC91325 06995932
         HTBL  CFB6,C2BA,CEAC,BBA7,CDAC,CEEF,BAF7,CDF1         @SC91325 06995934
         HTBL  C8B1,BFEB,B6D6,CCE6,C7D3,CBC3,B4CB,C9A1         @SC91325 06995936
         HTBL  B6EE,BFBB,BCEB,BEA7,B7A1,C5D6,B3D9,BDE4         @SC91325 06995938
         HTBL  C1AC,CBB0,CDC2,B5E3,BAA1,B6A9,B4BF,BDF8         @SC91325 06995940
         HTBL  C6B8,CED1,B8D0,C3EA,B1F0,C9B0,B5D6,BCB9         @SC91325 06995942
         HTBL  CAE3,C1C6,C6D1,C4BA,B5D3,C4C1,BFC9,BFD2         @SC91325 06995944
         HTBL  B0AE,B3CD,C9E5,B8D5,C3E8,C5F0,CDDE,BDDC         @SC91325 06995946
         HTBL  BFC7,B4F1,BBDD,CFD1,C3C8,B5CA,BADC,B1D4         @SC91325 06995948
         HTBL  BABF,B2BE,C3DC,C1B2,BCAD,B6D8,C9F5,B5F2         @SC91325 06995950
         HTBL  B7DF,BCE1,C9DE,C0FB,C6A7,CDD8,BFBA,B0BF         @SC91325 06995952
         HTBL  C7DE,C5A1,CEBD,C1C5,BDC1,BEEA,B9DA,B6E0         @SC91325 06995954
         HTBL  CBF1,BFD0,CBEC,B5B9,CDC0,B3BA,B7DC,BEB9         @SC91325 06995956
         HTBL  C5DB,B8ED,CEE5,C6EA,B6FE,C8B7,B4F9,C8E8         @SC91325 06995958
         HTBL  C6B6,B8E0,CBFA,C8A6,CDE2,C3B6,C2C5,C3E1         @SC91325 06995960
         HTBL  B2FC,C2DA,B4C7,C9CF,B1F7,BED7,B6FB,C6CF         @SC91325 06995962
         HTBL  C4B0,B4D4,B5B0,B4FA,C7DD,B1EA,BCBF,CDC4         @SC91325 06995964
         HTBL  BDD6,C9B6,CAF4,BDAD,CCA5,CDE3,C4B2,C1E5         @SC91325 06995966
         HTBL  C7F1,CBEA,C9C3,BCD5,CCDB,C2A1,B2D4,C9BC         @SC91325 06995968
         HTBL  C0F8,B7C7,B5F7,C1DD,CEAF,C4A2,B7FC,BBAE         @SC91325 06995970
         HTBL  C8C2,C4D6,C0F0,C5A6,C0B4,BACC,B0A9,C3D5         @SC91325 06995972
         HTBL  B6DC,CEF5,C1FB,B4B7,C2F5,B6AB,B9E3,BDA6         @SC91325 06995974
         HTBL  CDAA,B4D7,CEDE,CBFD,CCC3,C1DC,BFCC,BDB1         @SC91325 06995976
         HTBL  BACF,CBDE,CBE2,C4F0,BEEE,C2CC,BEC7,BEDC         @SC91325 06995978
         HTBL  C1FA,B6EA,BDC0,B4B5,B1AF,B6C4,BBBF,CCE3         @SC91325 06995980
         HTBL  E3A6,B7A4,CAA4,C3FB,C7B8,C3F3,B0DF,C2FB         @SC91325 06995982
         HTBL  CACB,B7D6,CDE5,B0CE,C4FA,CCBA,C0D2,C2FE         @SC91325 06995984
         HTBL  B8B9,B0AF,CEC2,B8B0,C3A7,BEA3,CCB8,B7C8         @SC91325 06995986
         HTBL  BEC9,DFB7,B4E1,B6EB,B4D5,C9E8,C8A9,CDFB         @SC91325 06995988
         HTBL  C4E2,B6C6,BEF6,B8AE,C5A5,BEFB,CCC2,BFC2         @SC91325 06995990
         HTBL  B6B8,CADE,C2F6,B4A3,C6AD,C4AF,B7C2,C4C4         @SC91325 06995992
         HTBL  C7C5,C6DF,B1BB,C6D7,C9C8,B2B6,CEF4,B3F2         @SC91325 06995994
         HTBL  CCB2,BEA2,B2B1,CAAE,C4B3,B1E8,C4E4,B2F8         @SC91325 06995996
         HTBL  B0B1,BFA3,CEC3,B4DA,BFEF,B2B3,CFC7,B2B7         @SC91325 06995998
         HTBL  C5B1,B4A7,BFEC,C7C3,C2F2,CABE,C4B8,E2AB         @SC91325 06996000
         HTBL  B1F8,C5CD,C1CE,B7A9,C4A6,CBA2,C9CB,B2C7         @SC91325 06996002
         HTBL  C4D2,B0FE,C0DD,BAC1,C3C5,B9D8,BBEC,C0FC         @SC91325 06996004
         HTBL  DBEA,BDC4,B9F2,B9F6,B4D2,C2AF,BEF7,CCED         @SC91325 06996006
         HTBL  B0DE,C3C0,CDA1,CEC4,EDEC,B4EC,C9A5,BAFD         @SC91325 06996008
         HTBL  CBD1,CBBB,BAA9,BBDB,CBB1,CFAD,C8AD,C5EF         @SC91325 06996010
         HTBL  CAA8,C6B9,CBE4,BABB,B1A3,B8C9,B0ED,B4FE         @SC91325 06996012
         HTBL  C5C7,CBCB,B8D8,B8F0,B7C5,BBAD,BCD9,B6F4         @SC91325 06996014
         HTBL  B2EA,C3A5,B1C8,C9E7,CAE8,BDCF,BEB6,B4BB         @SC91325 06996016
         HTBL  B8AF,B7F9,B4C0,CEC8,C1BA,CBD0,B2F5,B7D4         @SC91325 06996018
         HTBL  BEA9,C6F7,C7CC,CBAA,C3D1,C1C0,CDF7,DAF6         @SC91325 06996020
         HTBL  C1E2,BAB7,BACB,C8BB,BFF8,C0CB,B5A7,B6C5         @SC91325 06996022
         HTBL  E9C3,CEF7,C8CA,CAB3,CDF3,C4D1,C7F3,CDAE         @SC91325 06996024
         HTBL  C7D2,C7C4,B2E2,BFA1,CCC7,CBB5,B2CD,B0FD         @SC91325 06996026
         HTBL  CBFB,B0C3,BEB8,CDF5,B8DC,C4BC,C9DD,B4FD         @SC91325 06996028
         HTBL  B2FB,B9A3,C7DA,BDDB,CBC4,B0BC,C5F5,B0A5         @SC91325 06996030
         HTBL  C4C8,B4BE,BBC2,C2B7,C3A2,C5AB,CBD8,CDE7         @SC91325 06996032
         HTBL  BFCF,B8A5,B2CB,BCD3,BEFD,B7F7,C1FE,CEEE         @SC91325 06996034
         HTBL  CAED,CBC5,B8EB,C7E5,BAF0,B2D5,B1CD,E4C2         @SC91325 06996036
         HTBL  BFEA,CED2,C4E8,B1CB,B4C1,B3F0,B8D3,CCE8         @SC91325 06996038
         HTBL  B3CF,BBBD,C5B6,CAF8,CEF6,B5F1,BEE7,B6E6         @SC91325 06996040
         HTBL  BFFD,BDC3,C3F0,C2B6,DFE6,BFE9,B7B6,BCCA         @SC91325 06996042
         HTBL  CBB3,B3B8,CCA1,C8B9,B7AD,C3A1,B5F5,C6D3         @SC91325 06996044
         HTBL  E9E2,C8C1,BFB0,C2E1,CBED,C1F2,CDA8,B3A9         @SC91325 06996046
         HTBL  B3FE,CDB0,CDC9,B0E7,BDDA,B0A7,C8B3,CCD2         @SC91325 06996048
         HTBL  D6D6,B6EF,BEA4,C1B5,BEDB,C7AA,BAC0,B4F2         @SC91325 06996050
         HTBL  BFAF,D0D2,B0BE,CBC1,CAB7,B3B6,B5BA,BDAF         @SC91325 06996052
         HTBL  BBF2,C4E5,C6BD,B3EE,B4A6,E4D8,CCAC,C6B7         @SC91325 06996054
         HTBL  BBF0,B2E5,BBA2,B9B7,C0C0,C4D5,C3C2,B2A2         @SC91325 06996056
         HTBL  BAF3,BDC7,C8E4,C9EA,BED8,C7AB,B2E3,DAF5         @SC91325 06996058
         HTBL  B4AE,B0D6,BDDD,B8DD,C3E2,B1B0,B3E0,BFE0         @SC91325 06996060
         HTBL  BEE0,C9B3,CAD3,C5A9,BDD8,BFD4,C7EF,CFCE         @SC91325 06996062
         HTBL  C9BA,CDAF,BDEB,C1A6,C6E8,C1A4,BBF8,B7E6         @SC91325 06996064
         HTBL  C4FB,B3E7,B8F1,B7CE,BDCD,B6CF,C7E7,BFE6         @SC91325 06996066
         HTBL  BFE8,B5BC,DAF0,B4BA,C7AD,C9A4,CFC8,B7F6         @SC91325 06996068
         HTBL  B9BF,B9C6,BBA4,E3B6,C4D3,C9E4,C0C9,C4A9         @SC91325 06996070
         HTBL  B5BE,C6D6,C3F5,C7A3,B0D4,C2FA,C6A5,BCAC         @SC91325 06996072
         HTBL  BBAA,BFC4,CFA3,BAAB,C2CB,BCE4,BCD8,BBE3         @SC91325 06996074
         HTBL  CCD7,BFFA,DFD6,C1CB,CCE2,C0AB,BBDA,CAB6         @SC91325 06996076
         HTBL  C5A3,C3C9,C8CD,B0D8,B7A3,CFC1,CBF2,B2A7         @SC91325 06996078
         HTBL  CAB0,C2B1,B4D9,C5AD,BCB8,C7A5,EDBB,B9B4         @SC91325 06996080
         HTBL  DBD8,B1ED,E4AA,CAD0,CBBF,B1F1,B0C8,E0F8         @SC91325 06996082
         HTBL  C7D9,CDB1,C5C6,B6BC,B9D9,B2F4,CBEF,DFC0         @SC91325 06996084
         HTBL  B9FA,CBDF,B5B3,B5B6,B3D6,C4EE,C8A4,CAD7         @SC91325 06996086
         HTBL  C8C6,C1F4,C9A8,B8CF,C1B9,C3B2,CBC6,BCFC         @SC91325 06996088
         HTBL  C8C9,CFC5,BFD7,CEED,BCAE,EAF7,CDC1,B9CA         @SC91325 06996090
         HTBL  BBB4,CFB5,C1EE,C6A1,BDD4,CAF2,B3B3,CBD7         @SC91325 06996092
         HTBL  C1B7,C4DB,B1E3,CCAE,B6E3,C5BD,CDAB,C0D9         @SC91325 06996094
         HTBL  C7A8,BEDF,CCD5,C2D5,BDE2,CDD6,B4CC,B5D8         @SC91325 06996096
         HTBL  C0A6,C9A3,CBA9,C3D4,BBC7,B9BA,CEDC,B7FD         @SC91325 06996098
         HTBL  C7F9,C7E9,B3AA,B2F9,C2D7,BBC3,C0E5,CCD8         @SC91325 06996100
         HTBL  CCEC,B4F7,CCFB,B1A8,B2B4,B0AC,BBB1,C9A6         @SC91325 06996102
         HTBL  BFF3,CEE7,DAEE,C6EB,B8B8,BAF1,B1E1,BAB5         @SC91325 06996104
         HTBL  B7A2,B1C2,BAB2,B9EC,B5E7,B0B8,BEBF,C8E2         @SC91325 06996106
         HTBL  CFBD,BAED,C6DD,BAF8,EBD9,BDF9,C4B7,B8E4         @SC91325 06996108
         HTBL  CBA6,B1CC,B2BA,C1F3,BCB2,C3E0,DEAB,CDEF         @SC91325 06996110
         HTBL  C2F9,CCDF,B3CC,BDEE,BEFA,B6F6,CFB3,CABA         @SC91325 06996112
         HTBL  CDF9,CECD,B5E2,BAE3,BEFC,C1CD,CEF1,CAC0         @SC91325 06996114
         HTBL  B1D6,C6CC,B0C9,C1A9,C2C1,CFCD,B5A6,CCA8         @SC91325 06996116
         HTBL  B7E5,C9D0,C2E4,B0AA,B0B4,CBA8,B9FD,C6ED         @SC91325 06996118
         HTBL  CFCF,E2EA,C9F8,C6F5,B0AB,C0F2,BDED,B2A9         @SC91325 06996120
         HTBL  B1FA,E3C9,CFCA,D7A2,EEB4,B9CE,CBB8,CCB7         @SC91325 06996122
         HTBL  C9EB,BED9,B5E0,C6BF,BFD6,B1B3,BEF3,BDF6         @SC91325 06996124
         HTBL  C8B2,CEB0,CFAC,CAF0,C7A9,B7DB,EDA9,B9F4         @SC91325 06996126
         HTBL  B3ED,C0CD,BCC0,C1F8,B0BA,C5E9,CCEA,B0D0         @SC91325 06996128
         HTBL  CEDF,BDB7,DCC6,B9C7,C5D7,D6C3,CDCA,BFD1         @SC91325 06996130
         HTBL  C4C6,BCCF,BDEC,C4A8,C5A2,BEC5,EFC4,CAC5         @SC91325 06996132
         HTBL  C0B7,C9B7,B9AE,EDD1,C5E6,D5FA,C4FE,B1C1         @SC91325 06996134
         HTBL  C1B8,CAEA,B3D4,B3F1,DEBC,DAD9,C1BD,D0B4         @SC91325 06996136
         HTBL  C1D3,C0E0,CAEE,BBBE,E8D3,B8D6,E6A5,C2E9         @SC91325 06996138
         HTBL  B8EF,C1C2,C8B6,E7C9,CEA1,B7C6,BABE,B1DC         @SC91325 06996140
         HTBL  BFDF,B0A8,C6DC,C8EA,E4CC,B5BD,C9D6,BDBF         @SC91325 06996142
         HTBL  BED4,CECA,BCA6,CBC8,D5AA,CEAD,C6F6,DFC9         @SC91325 06996144
         HTBL  BABC,B0D3,CBB2,E8FA,C1EC,C0FD,C1A7,D4F7         @SC91325 06996146
         HTBL  C7B9,C9E6,B5C0,DAE4,B1C3,C4F6,BEED,C1F9         @SC91325 06996148
         HTBL  B7CC,CBB6,B0F2,CEDB,C1AE,C9CC,CFBC,BBE2         @SC91325 06996150
         HTBL  B1B2,C6BE,C8DE,BCFA,B4E7,B4B8,CCDD,F3D5         @SC91325 06996152
         HTBL  EEB7,BDE6,C5A4,C8F6,B3AE,C6E5,D1EF,B9A1         @SC91325 06996154
         HTBL  BECC,DAC8,DAEF,B6AE,B7CD,B1CE,C6FA,C1D9         @SC91325 06996156
         HTBL  BAB6,B9DC,CBAB,B6BA,E4F1,D4A2,B3F5,A1A1         @SC91325 06996158
         HTBL  CBCE,B1D3,C9E0,B2DC,C3B3,C8A7,B5C2,C4A1         @SC91325 06996160
         HTBL  C3A8,ECE2,E2C3,E0DC,DBA5,EFC1,BCF0,B5E8         @SC91325 06996162
         HTBL  EEDF,D4AA,C5F3,C9F3,C1B6,B6C2,CDE6,CDCC         @SC91325 06996164
         HTBL  B9D1,C6FB,A1A1,B8D1,F0F9,C2E3,ECE4,D6DE         @SC91325 06996166
         HTBL  CBF5,C9EF,D0CB,D8C5,C4F4,C4A4,BCA9,B5F8         @SC91325 06996168
         HTBL  E4BB,B8FB,DAE7,B9F3,B6A7,B5C7,B4D0,C0A2         @SC91325 06996170
         HTBL  B0B3,BAF4,E4D9,BBB7,CFA5,E3B7,CBDD,A1A1         @SC91325 06996172
         HTBL  D0E8,F3CA,C8B0,BFF7,D5E9,C8E7,B5EA,CCFA         @SC91325 06996174
         HTBL  B3FC,DAFB,D5E6,B0BB,C4FC,B9D0,B5CE,BCA5         @SC91325 06996176
         HTBL  DEE8,A1A1,BFB1,C1D7,C2FD,E1E7,CEBA,DAEA         @SC91325 06996178
         HTBL  EED8,B9A2,B1CF,B1B8,D7F6,BCE2,D5D5,C9C7         @SC91325 06996180
         HTBL  D6AA,F0B6,C0DB,C5CE,C8FA,CDA9,B5D4,B9ED         @SC91325 06996182
         HTBL  C2D2,C2DB,B5A9,B5C3,D3FB,BED3,E5AF,EEE7         @SC91325 06996184
         HTBL  C9AA,CECB,BFE7,E9F0,BDE5,C1A3,CEFC,B0EE         @SC91325 06996186
         HTBL  EFFE,E5F6,B6E9,D4E8,D7DC,F0DD,E5F2,BDCE         @SC91325 06996188
         HTBL  B5F4,A1A1,DCC0,CEC6,BEE9,B3C9,C7C7,D6DB         @SC91325 06996190
         HTBL  BDA5,EEFE,CBDB,CAFB,B2D2,B4C8,E6F6,CAAF         @SC91325 06996192
         HTBL  B3B4,DDA4,CDFE,CAAB,DADF,C5EB,CBF9,DBBC         @SC91325 06996194
         HTBL  E6EA,CFCC,A1A1,C9F6,CEC7,CCDE,BDFA,E2A9         @SC91325 06996196
         HTBL  C2DC,B1BD,D7C5,CDD0,A1A1,C7CA,CDD4,CFB9         @SC91325 06996198
         HTBL  D3CB,C8FC,BBA9,BCB6,C7F8,C5BC,C8D4,DEE6         @SC91325 06996200
         HTBL  E4DE,B4A1,DEAD,EFA8,C2ED,BFE3,DFCD,B0F6         @SC91325 06996202
         HTBL  B6F2,C7E0,DDEA,B4AD,DEAC,BBF3,B2C9,B0F9         @SC91325 06996204
         HTBL  CFB0,BCE0,C8FD,BCC3,CBD4,C8A3,BDFB,C5D2         @SC91325 06996206
         HTBL  E4FD,B1F5,BFD5,BFF1,DBF1,CED4,D2C9,CDE9         @SC91325 06996208
         HTBL  B2DE,B3A1,B9BC,DFDB,BFD9,C6AA,BFF5,C4CE         @SC91325 06996210
         HTBL  BAEC,B8E8,D1A5,B9CF,D7AF,C2DD,E3B2,C9A2         @SC91325 06996212
         HTBL  BDAB,C1E4,C0A8,C1D6,DBDB,C3DA,C9AB,B7A5         @SC91325 06996214
         HTBL  DBE1,CAE9,C8C3,BFAB,C7FB,BEE4,F1C1,C3EF         @SC91325 06996216
         HTBL  C4DC,A1A1,B6A2,DCBB,DDAF,BEAC,B3F6,B7F1         @SC91325 06996218
         HTBL  B1E2,CDDA,BFDA,C8B5,BDB3,C8D9,C5E4,C6E6         @SC91325 06996220
         HTBL  B7F0,E9CA,F0F0,E1BE,C3AC,D0C3,F3A8,B8F6         @SC91325 06996222
         HTBL  CEBF,D9C2,C8D0,BFAA,C7B2,EAEA,CBD5,B5CB         @SC91325 06996224
         HTBL  C1BF,C4F5,E4AD,DBB5,E2E0,B3C2,CCF1,B6ED         @SC91325 06996226
         HTBL  BAD4,D0AE,B3B7,DFE5,E7D0,BAAD,ECD3,C1AB         @SC91325 06996228
         HTBL  C6D4,B2E0,C0D4,C7BF,EBB9,DBE0,DDAB,CADF         @SC91325 06996230
         HTBL  B0C7,E3AD,E3C7,B1B9,C0D8,B8A7,E3BB,B8CC         @SC91325 06996232
         HTBL  D7A1,B4BC,EFAE,BDB9,DCAF,C2CF,C0F1,B7D2         @SC91325 06996234
         HTBL  E5B7,C0B3,DEF0,B2D7,C0C3,C4E6,EDBC,EEB2         @SC91325 06996236
         HTBL  E0A5,C8EC,CACA,C5CA,B9EA,EBF5,BBE8,C2EF         @SC91325 06996238
         HTBL  B3E6,B6B0,A1A1,C4F2,C2F8,F2B2,B2E9,C3F4         @SC91325 06996240
         HTBL  DFDF,DCD2,B9B2,B3C3,BFED,BAFA,D2A8,EEE8         @SC91325 06996242
         HTBL  A1A1,B5B8,E2AA,A1A1,D4B0,BBB9,E2A3,BEC0         @SC91325 06996244
         HTBL  E5FC,B4E8,C6F8,CABD,C2AA,CCAA,B2FD,D8AC         @SC91325 06996246
         HTBL  BDDE,C8DA,BAA5,D4C6,BED6,BCDF,CCFE,C9D1         @SC91325 06996248
         HTBL  B8BF,C8DC,CCE0,BEAA,C2C4,C0C2,DCD8,B7D5         @SC91325 06996250
         HTBL  F3CF,F0D6,E6E8,B1DE,BAA8,C9EE,C7D6,DCE2         @SC91325 06996252
         HTBL  DBEB,BEE1,B2EF,BAD3,C0ED,BAC9,C6B4,B7E4         @SC91325 06996254
         HTBL  D0D8,E7E7,CBF0,A1A1,CCFC,CCB0,CEFE,B9AB         @SC91325 06996256
         HTBL  B3D2,D4BB,B5B2,CAE0,C6C5,CDC5,B7B7,C4DF         @SC91325 06996258
         HTBL  C5D1,B3EF,F0D5,C8FB,C3C1,BDBA,C2CD,B7B5         @SC91325 06996260
         HTBL  E6CD,CDB2,BBB5,C5B3,BCBB,CBCA,B6AA,B8F4         @SC91325 06996262
         HTBL  CFB8,CAAD,E1B1,E3F8,C0E6,B3B1,B4C3,C7C1         @SC91325 06996264
         HTBL  CBF7,E9C2,B1EB,DCBA,C9C5,B8EA,B8C8,C3B9         @SC91325 06996266
         HTBL  CDDD,C1D1,E8AC,E2BA,BED5,BDF2,DCA9,C5CB         @SC91325 06996268
         HTBL  B2E7,BAAF,BDB2,B3E9,C7CE,D6A2,E4C6,B3F3         @SC91325 06996270
         HTBL  C4D9,B4E2,B0C1,CBAF,CEE2,D7B0,C1CC,CEA3         @SC91325 06996272
         HTBL  C7AC,CAB2,CDEC,BAE8,C9BB,CED6,CCBB,C2BD         @SC91325 06996274
         HTBL  F0F3,BAFC,BCD7,B2A5,BFC5,CFD2,BCB3,C5EE         @SC91325 06996276
         HTBL  B3EC,B1BC,D8FC,B2C0,B8F3,B2D3,B2AA,BBC6         @SC91325 06996278
         HTBL  B9A4,CCBD,CFD0,BCBD,BCDE,BDD7,B2A8,B3BB         @SC91325 06996280
         HTBL  C9C9,BCF4,BCDB,B8D2,BCE6,B5E4,B2B2,B3E5         @SC91325 06996282
         HTBL  DCD4,F0B5,C2C3,E6DC,B2D8,E8A4,D3AE,B3FA         @SC91325 06996284
         HTBL  C3A9,D3DC,DBBA,C7ED,B0E0,D6F0,E4A8,EDFC         @SC91325 06996286
         HTBL  E8B6,C3B7,BAA6,B0C4,B8A3,CADC,DCC7,BCF6         @SC91325 06996288
         HTBL  B3DC,BAC3,C0F9,C9F9,CAB5,B7FE,DCAA,B9F9         @SC91325 06996290
         HTBL  BCC9,C5AE,BEAB,BAF5,B1B6,B9DE,B0B9,B9FB         @SC91325 06996292
         HTBL  C6E4,CADA,C8D1,C1E6,DCB7,C1DF,C1E9,B8C3         @SC91325 06996294
         HTBL  C3BE,C6CE,E8F1,EDF2,C4D7,B1B7,CAA6,B3C7         @SC91325 06996296
         HTBL  E7DB,B6DF,C3F7,CBD6,B6FD,C7FC,BAD6,E3C1         @SC91325 06996298
         HTBL  B4CD,CAB1,C2C6,C1BB,B4C2,DFF1,F1AE,CCD9         @SC91325 06996300
         HTBL  D6E9,CFAE,C7B1,BCDD,DCA7,BBAF,C6D0,EADE         @SC91325 06996302
         HTBL  B9E5,B2E4,D0A7,DBCC,C3BD,E6A3,B7ED,C4CF         @SC91325 06996304
         HTBL  BBB8,B6D4,B9F7,CAC3,BCC5,E5BA,B0A2,E4A2         @SC91325 06996306
         HTBL  C7E2,DDF7,E8CD,B7E1,CDC3,C2C9,C3D8,BDC8         @SC91325 06996308
         HTBL  B1E5,DBC1,CEFA,BFBE,DCB5,D1E6,E6D1,B1DA         @SC91325 06996310
         HTBL  BFA4,D4A4,BAAA,E8C1,C7E1,E5B9,BEA8,E5B8         @SC91325 06996312
         HTBL  C5B2,BFEE,C6A2,D6BE,DBC3,DBD0,EAB1,E3B9         @SC91325 06996314
         HTBL  C5C8,C6BA,C6DB,E6C6,C8AE,B7D8,F2EE,DBAC         @SC91325 06996316
         HTBL  C4CA,B5C5,B6B1,C5A7,D7FB,CEEC,C4BD,C9F2         @SC91325 06996318
         HTBL  BDB6,C5F7,D7FC,B2EE,CEDA,CCD1,B0FC,CAF9         @SC91325 06996320
         HTBL  C6C2,F2D0,D4D6,C5F8,CCE5,C1DE,C3FE,C8D2         @SC91325 06996322
         HTBL  C3FD,CEEA,B6A4,CEF9,E3B1,B6D9,C6F2,CCCD         @SC91325 06996324
         HTBL  C3AD,BFF6,BEB3,B8BE,C7B6,B6BE,C1A8,C3E4         @SC91325 06996326
         HTBL  BEA5,CAEF,B3AF,CCCB,CACE,B3A2,C8C5,C7D7         @SC91325 06996328
         HTBL  C4B5,B3E2,CACD,B0E2,ECD4,DEF4,B1D0,B1A4         @SC91325 06996330
         HTBL  CAC8,C7CD,B0A3,CCA2,CEB7,BBAB,CCB9,CFBE         @SC91325 06996332
         HTBL  D1F9,B0B6,C8B8,C5E5,B4E6,BEC1,CFA6,CBA3         @SC91325 06996334
         HTBL  B6F3,C5C3,C2FC,B4E5,CCC5,C8DF,CFC4,B0DA         @SC91325 06996336
         HTBL  C0FA,C3F1,C4DD,C9BF,B2FA,C0CC,C1A2,C3D0         @SC91325 06996338
         HTBL  C6D9,B2EB,C9AD,CACF,B3BC,CBE6,B1AE,CEAA         @SC91325 06996340
         HTBL  DFA7,C9B5,C7C2,CDF4,E4B5,C8ED,BDB4,C4FD         @SC91325 06996342
         HTBL  E5D1,C6E3,B5FA,B8C1,C9AF,B6A3,B5D0,C9C0         @SC91325 06996344
         HTBL  C1C1,B6B4,C8C0,BBC1,BAB1,B9E9,B4BD,CCC6         @SC91325 06996346
         HTBL  C3BF,B9E8,BBD3,B3BF,B1A5,C7E8,C9C6,B8DA         @SC91325 06996348
         HTBL  BCC8,C5BF,C8BA,C7E6,CFB4,C2CA,DDF9,CFB1         @SC91325 06996350
         HTBL  B0F3,C7EA,CCC9,B8D9,B3BD,C2C8,CBEE,D8DF         @SC91325 06996352
         HTBL  B1E6,C9CE,BBAC,C5D5,C6CB,C2F1,B3C4,B1F9         @SC91325 06996354
         HTBL  B3C5,CDE0,C0F3,C6B5,BAB3,C4AD,B4AF,B1AA         @SC91325 06996356
         HTBL  B5AB,C5F1,BDF3,C2C2,BFFC,C7FD,CEAB,B6CE         @SC91325 06996358
         HTBL  B1C5,C4B1,B5C9,BBBC,C0C8,C8DB,B8E9,B7D3         @SC91325 06996360
         HTBL  CBE9,C6D5,C8F0,C4BF,B6F7,CCCE,BEF1,B1B5         @SC91325 06996362
         HTBL  CFA8,C3FC,C5BB,A1A1,A1A1,A1A1,A1A1,D0A1         @SC91325 06996364
         HTBL  D0A2,D0A3,A1A1,D0A4,D0A5,D0A6,D0A8,D0A9         @SC91325 06996366
         HTBL  D0AA,D0AB,D6A6,D0AC,D0AD,D0AF,D0B2,D0B1         @SC91325 06996368
         HTBL  D0B3,D0B5,D0B6,D0B7,D0B8,D0B9,D0BA,D0BB         @SC91325 06996370
         HTBL  D0BC,D0BD,D0BE,A1A1,D0BF,D0C0,D0C1,D0C2         @SC91325 06996372
         HTBL  A1A1,D0C4,D0E7,A1A1,A1A1,D0C5,D0C6,D0C8         @SC91325 06996374
         HTBL  A1A1,D0C9,D0CA,D5A4,A1A1,D0C7,A1A1,A1A1         @SC91325 06996376
         HTBL  D0CC,D0CD,A1A1,D0D6,D0CE,D0CF,D5A5,D0D0         @SC91325 06996378
         HTBL  D0D1,A1A1,D0D3,D0D4,D0D5,D0D7,D0D9,D0DA         @SC91325 06996380
         HTBL  D0DB,D0DC,D0DD,D0DE,A1A1,D0DF,D0E0,D0E1         @SC91325 06996382
         HTBL  A1A1,D0E2,D0E3,D0E4,D0E5,D0E6,D0E9,A1A1         @SC91325 06996384
         HTBL  D0EA,D0EB,A1A1,D0EC,D0ED,D0EE,A1A1,D0EF         @SC91325 06996386
         HTBL  D0F0,D0F1,D0F3,D0F4,D0F5,D0F6,D0F7,E0C7         @SC91325 06996388
         HTBL  A1A1,A1A1,A1A1,D0F8,D0F9,D0FA,A1A1,D0FB         @SC91325 06996390
         HTBL  D0FC,D0FD,D0F2,D0FE,D1A1,D1A2,D1A3,D1A4         @SC91325 06996392
         HTBL  A1A1,D1A6,D1A7,A1A1,D1A8,D1A9,D1AA,D1AB         @SC91325 06996394
         HTBL  D1AC,D1AD,D1AE,D1AF,D1B3,D1B1,D1B2,D1B0         @SC91325 06996396
         HTBL  D1B4,D1B5,D1B6,D1B7,D1B8,D1B9,D1BA,A1A1         @SC91325 06996398
         HTBL  D1BC,D1BB,D1BD,D1BE,A1A1,D1C0,D1C1,D1C2         @SC91325 06996400
         HTBL  D1C3,D1C4,D1C5,D1C6,D1C7,D1C8,D1C9,D1CA         @SC91325 06996402
         HTBL  D1CB,D1CC,A1A1,D1CD,D1CE,D1CF,D1D0,D1D1         @SC91325 06996404
         HTBL  D1D2,D1D3,D1D4,D1D5,D1D6,D1D7,A1A1,D1D8         @SC91325 06996406
         HTBL  D1D9,D1DA,D1DB,D1DC,D1DE,A1A1,D1DF,D1E0         @SC91325 06996408
         HTBL  D1E1,D1E2,D1E3,D1E4,D1E5,A1A1,D1E7,D1E8         @SC91325 06996410
         HTBL  D1E9,D1EA,D1EB,D1ED,D1EE,D1EC,D1F0,D1F1         @SC91325 06996412
         HTBL  D1FB,D1F2,D1F5,D1F3,D1F4,D1F6,D1F7,D1F8         @SC91325 06996414
         HTBL  D1FC,D1FA,D1FD,A1A1,A1A1,D2A2,D2A3,D2A4         @SC91325 06996416
         HTBL  D2A5,D2A6,A1A1,D2A7,A1A1,D2A9,D2AA,D2AB         @SC91325 06996418
         HTBL  D2AD,D2AE,D2AF,D2B0,D2B1,A1A1,D2B2,A1A1         @SC91325 06996420
         HTBL  D2B3,D2B4,D2B5,D2B6,D2B7,D2B8,D2B9,A1A1         @SC91325 06996422
         HTBL  D2BA,D2BB,D2BC,D2BD,D2BE,D2BF,D2C1,D2C0         @SC91325 06996424
         HTBL  D2C3,D2C2,D2C4,D2C5,DAAA,D2C6,D2C7,D2C8         @SC91325 06996426
         HTBL  A1A1,D2CB,D2CA,D2CC,A1A1,D2CD,D2CE,D2CF         @SC91325 06996428
         HTBL  D2D0,D2D1,D2D2,A1A1,D2D3,D2D4,D2D5,A1A1         @SC91325 06996430
         HTBL  D2D7,D2D8,A1A1,D2D9,D2DA,D2DB,D2DC,D2DD         @SC91325 06996432
         HTBL  D2DE,D2DF,D2E0,D2E1,D2E2,D2E3,D2E4,D2E5         @SC91325 06996434
         HTBL  D2E6,D2E7,D2E8,D2E9,D2EA,D2EB,D2EC,D2ED         @SC91325 06996436
         HTBL  D2EE,D2EF,D2F0,D2F1,D2F2,A1A1,D2F3,D2F4         @SC91325 06996438
         HTBL  D2F5,D2F6,A1A1,D2F7,D3A5,D3BE,D2F8,D2F9         @SC91325 06996440
         HTBL  D2FA,D2FB,D2FC,D3A6,D2FD,D2FE,D3A1,D3A2         @SC91325 06996442
         HTBL  D3A3,A1A1,D3A4,D3A7,A1A1,D3A8,D3A9,D3AA         @SC91325 06996444
         HTBL  D3AB,D3AC,D3AD,D3AF,D3B0,D3B1,D3B2,D3B3         @SC91325 06996446
         HTBL  D3B4,D3B5,D3B6,D3B7,D3B8,D3B9,D3BA,D3BB         @SC91325 06996448
         HTBL  D3BC,D3BD,D3BF,D3C0,D3C1,D3C2,D3C3,D3C4         @SC91325 06996450
         HTBL  D3C5,D3C6,A1A1,D3C7,D3C8,D3C9,D3CA,D3CC         @SC91325 06996452
         HTBL  D3CD,D3CE,D3CF,D3D0,D3D1,D3D8,D3D2,D3D3         @SC91325 06996454
         HTBL  D3D4,D3D5,D3D6,D3D7,D3D9,D3DA,D3DD,D3DE         @SC91325 06996456
         HTBL  D3DF,D3E0,D3E1,D3E5,D3E2,D3E3,D3E4,D3DB         @SC91325 06996458
         HTBL  D3E9,D3EA,D3E6,D3E7,D3E8,D3EB,D3EC,D3ED         @SC91325 06996460
         HTBL  D3EE,D3F4,D3EF,D3F0,D3F1,D3F2,D3F3,D3F5         @SC91325 06996462
         HTBL  D3F7,D3F6,D3F8,D3F9,D3FA,D3FC,D3FD,D3FE         @SC91325 06996464
         HTBL  D4A1,D4A3,D4A7,D4A5,D4A6,D4A8,D4A9,D4AB         @SC91325 06996466
         HTBL  D4AC,D4AD,A1A1,D4AE,D4AF,A1A1,D4B2,D4B3         @SC91325 06996468
         HTBL  D4B4,D4B5,D4B6,D4B7,D4B9,D4B8,A1A1,D4BA         @SC91325 06996470
         HTBL  D4BC,D4BD,A1A1,D4B1,D4BE,A1A1,D4BF,D4C0         @SC91325 06996472
         HTBL  D4C2,A1A1,D4C1,D4C3,D4C4,D4C5,D4C8,D4CA         @SC91325 06996474
         HTBL  D4C9,D4CC,D4CE,D4CD,A1A1,D4CB,D4CF,D4D0         @SC91325 06996476
         HTBL  D4C7,D4D2,D4D3,D4D7,A1A1,D4D8,A1A1,D4D1         @SC91325 06996478
         HTBL  D4D4,D4D9,D4DA,D4DB,D4DC,D4DD,D4DE,D4D5         @SC91325 06996480
         HTBL  D4E0,D4E2,D4E1,D4DF,D4E3,D4E4,D4E5,D4E6         @SC91325 06996482
         HTBL  D4E7,D4E9,D4EA,A1A1,D4EB,D4EC,D4ED,D4EE         @SC91325 06996484
         HTBL  D4EF,D4F0,D4F1,D4F2,D4F3,D4F5,D4F6,A1A1         @SC91325 06996486
         HTBL  D4F8,D4F9,A1A1,A1A1,A1A1,D4FA,D4FB,D4FC         @SC91325 06996488
         HTBL  D4FD,D4FE,D5A1,D5A2,D5AB,D6AC,D5A3,D5A6         @SC91325 06996490
         HTBL  A1A1,D5A7,A1A1,D5A8,D5A9,D5AC,D5AD,D5AE         @SC91325 06996492
         HTBL  D5AF,D5B0,D5B1,D5B3,D5B2,D5B4,D5B5,D5B6         @SC91325 06996494
         HTBL  D5B7,D5B8,D5B9,D5BA,D5BB,D5BC,D5BD,D5CC         @SC91325 06996496
         HTBL  D5BE,D5BF,D5C0,D5C1,D5C2,D5C3,D5C4,D5C5         @SC91325 06996498
         HTBL  D5C6,D5C7,D5C8,D5C9,D5CA,D5CB,D5CD,D5CE         @SC91325 06996500
         HTBL  D5CF,D5D0,D5D1,D5D2,D5D3,D5D4,A1A1,D5DD         @SC91325 06996502
         HTBL  D5D6,D5D7,D5D8,D5D9,D5DA,D5DB,D5DC,D5DE         @SC91325 06996504
         HTBL  D5DF,D5E0,D5E1,D5E2,D5E3,D5E4,A1A1,D5E5         @SC91325 06996506
         HTBL  A1A1,D5E7,A1A1,D5EB,A1A1,D5E8,D5EA,D5EC         @SC91325 06996508
         HTBL  D5ED,D5EE,D5F0,D5EF,D5F1,D5F2,D5F3,D5F4         @SC91325 06996510
         HTBL  D5F5,A1A1,D5F6,D5F7,D5F8,D5F9,D5FB,D5FC         @SC91325 06996512
         HTBL  D5FD,D5FE,D6A1,D6A3,D6A4,D6A5,D6A7,D6A8         @SC91325 06996514
         HTBL  D6A9,D6AB,D6B3,D6AD,D6AE,D6AF,D6B1,A1A1         @SC91325 06996516
         HTBL  A1A1,D6B2,D6B0,D6B4,D6B5,D6B6,D6B7,D6B8         @SC91325 06996518
         HTBL  A1A1,D6B9,D6BB,D6BC,D6BD,D6C0,D6C1,D6C2         @SC91325 06996520
         HTBL  A1A1,D6C4,D6C5,D6C6,D6C7,D6C8,D6C9,A1A1         @SC91325 06996522
         HTBL  A1A1,D6BF,D6CA,D6CB,A1A1,D6CC,D6CD,A1A1         @SC91325 06996524
         HTBL  D6CE,D6CF,D6D0,D6D1,D6BA,D6D2,D6D3,D6D7         @SC91325 06996526
         HTBL  D6D4,D6D5,D6D8,A1A1,D6D9,A1A1,D6DA,A1A1         @SC91325 06996528
         HTBL  D6DC,D6DD,D6DF,D6E0,D6E2,D6E3,D6E4,D6E5         @SC91325 06996530
         HTBL  D6E6,D6E7,D6E8,D6EA,D6EB,D6EC,D6F3,D6ED         @SC91325 06996532
         HTBL  D6EE,D6EF,D6F1,D6F2,D6F4,D6F5,D6F6,D6F8         @SC91325 06996534
         HTBL  D6F9,D6FA,D6FB,D6FC,D6FD,D6FE,D7A3,D7A4         @SC91325 06996536
         HTBL  D7A5,D7A6,D7A7,D7A8,D7A9,D7AA,D7AD,D7AB         @SC91325 06996538
         HTBL  D7AC,D7AE,D7B1,D7B2,D7B5,D7B6,D7B7,A1A1         @SC91325 06996540
         HTBL  D7B8,D7B9,D7BF,A1A1,D7BA,D7BB,D7BC,D7BD         @SC91325 06996542
         HTBL  D7BE,D7C0,D7C1,D7C2,D7C3,D7B4,D7B3,D7C4         @SC91325 06996544
         HTBL  A1A1,D7C6,D7C7,D7C8,D7C9,D7CA,D7CB,D7CC         @SC91325 06996546
         HTBL  D7CE,D7CD,D7D0,D7CF,D7D1,D7D2,D7D3,D7D4         @SC91325 06996548
         HTBL  A1A1,D7D5,D7D6,D7D7,D7D8,D7D9,D7DA,D8AD         @SC91325 06996550
         HTBL  D7DB,A1A1,D7DD,D7DE,D7E0,D7E1,D7E2,D7E3         @SC91325 06996552
         HTBL  D7E4,D7E5,D7E6,D7E7,D7E8,D7E9,D7EA,D7EB         @SC91325 06996554
         HTBL  D7EC,D7DF,A1A1,D7ED,D7EE,D7EF,D7F0,D7F1         @SC91325 06996556
         HTBL  D7F2,D7F3,D7F4,D7F5,D7F7,D7F8,D7F9,A1A1         @SC91325 06996558
         HTBL  D7FA,D7FD,D7FE,D8A1,D8A2,A1A1,D8A3,D8A4         @SC91325 06996560
         HTBL  D8A5,D8A6,D8A7,D8A8,D8A9,A1A1,D8AA,D8AB         @SC91325 06996562
         HTBL  D8AE,D8AF,D8B0,A1A1,D8B1,A1A1,A1A1,D8B3         @SC91325 06996564
         HTBL  D8B4,D8B5,D8B6,D8B7,D8B8,D8B9,D8BA,D8BB         @SC91325 06996566
         HTBL  D8BC,D8BD,D8BE,D8BF,A1A1,D8C0,D8B2,A1A1         @SC91325 06996568
         HTBL  D8C2,D8C3,D8C1,D8C4,A1A1,D8C6,D8C7,D8C8         @SC91325 06996570
         HTBL  D8D4,D8D7,D8C9,D8CA,D8CB,D8CC,D8DC,D8CD         @SC91325 06996572
         HTBL  D8CE,D8CF,D8D0,D8D1,D8D2,D8D3,D8D5,D8D6         @SC91325 06996574
         HTBL  D8D8,D8D9,A1A1,D8DA,D8DB,D8DD,D8DE,D8E0         @SC91325 06996576
         HTBL  D8E1,D8E2,D8E3,D8E4,D8E5,D8E6,D8E8,D8E9         @SC91325 06996578
         HTBL  D8EA,D8EB,D8EC,D8ED,D8EE,D8EF,D8F0,D8F3         @SC91325 06996580
         HTBL  D8E7,D8F1,D8F5,D8F2,D8F4,D8F6,D8F7,D8F8         @SC91325 06996582
         HTBL  D8F9,D8FA,D8FB,A1A1,D8FD,D8FE,D9A1,D9A2         @SC91325 06996584
         HTBL  D9A3,D9A4,D9A5,D9A6,D9A7,D9A8,D9A9,D9AA         @SC91325 06996586
         HTBL  D9AB,D9AC,D9AD,D9AE,D9AF,D9B0,D9B1,D9B3         @SC91325 06996588
         HTBL  D9B2,D9B4,D9B5,D9B7,D9B8,D9B9,D9BA,D9BB         @SC91325 06996590
         HTBL  D9BC,DAAD,D9BE,D9C0,D9C1,D9B6,D9C3,D9C4         @SC91325 06996592
         HTBL  A1A1,D9C5,D9C6,D9C7,D9C8,D9C9,D9CA,D9CB         @SC91325 06996594
         HTBL  D9CC,D9CD,D9CE,D9CF,D9BD,D9D0,D9D2,D9D1         @SC91325 06996596
         HTBL  D9D4,D9D5,D9D6,D9D7,D9D8,D9D9,D9DA,D9DB         @SC91325 06996598
         HTBL  D9DC,D9DD,D9DF,D9E0,D9DE,D9E1,D9E2,D9E3         @SC91325 06996600
         HTBL  D9E4,A1A1,D9E5,D9E6,D9E7,D9E8,D9E9,D9EB         @SC91325 06996602
         HTBL  D9EC,D9ED,D9EE,D9EF,D9D3,D9F1,D9F2,D9F3         @SC91325 06996604
         HTBL  D9EA,D9F7,D9F4,D9F5,A1A1,D9F6,D9F8,A1A1         @SC91325 06996606
         HTBL  A1A1,D9F9,DAA5,D9FA,D9FB,D9FC,D9FD,D9FE         @SC91325 06996608
         HTBL  DAA1,DAA2,DAA3,DAA4,D9BF,DAA6,DAA7,DAA8         @SC91325 06996610
         HTBL  DAA9,DAAB,DAAC,DAAE,DAAF,DAB2,DAB1,DAB3         @SC91325 06996612
         HTBL  DAB4,DAB5,DAB6,DAB7,DAB8,D9F0,DAB9,DABA         @SC91325 06996614
         HTBL  DABB,DABC,DAB0,DABD,DABE,DABF,DAC0,DAC1         @SC91325 06996616
         HTBL  DAC2,DAC3,A1A1,DAC4,DAC6,DAC7,DAC5,DAC9         @SC91325 06996618
         HTBL  DACA,DACB,DACC,DACD,DACE,DACF,DAD0,DAD1         @SC91325 06996620
         HTBL  DAD2,DAD3,DAD4,DAD5,DAD6,DAD7,DAD8,DADA         @SC91325 06996622
         HTBL  DADC,DADB,DADD,A1A1,A1A1,A1A1,DADE,DAE0         @SC91325 06996624
         HTBL  DAE1,A1A1,DBA6,DAE3,A1A1,A1A1,DAE5,DAE6         @SC91325 06996626
         HTBL  A1A1,DAE8,DAE9,A1A1,A1A1,DAEB,DAED,A1A1         @SC91325 06996628
         HTBL  DAF1,DAEC,A1A1,A1A1,DAF2,DAF3,DAF4,DAF7         @SC91325 06996630
         HTBL  A1A1,DAF8,A1A1,DAF9,A1A1,DBA1,DAFA,A1A1         @SC91325 06996632
         HTBL  DAFC,DAFD,DAFE,DBA2,DBA3,DBA4,DBA7,DBA8         @SC91325 06996634
         HTBL  DBA9,DBAA,DBAB,A1A1,A1A1,A1A1,DBAD,DBAE         @SC91325 06996636
         HTBL  E5D8,DBAF,DBB0,DBB1,DBB2,DBB3,DBB4,DBB7         @SC91325 06996638
         HTBL  DBB6,DBB8,DBB9,DBBB,A1A1,DBBD,DBBE,DBC7         @SC91325 06996640
         HTBL  DBBF,DBC0,DBC2,DBC4,DAE2,DBC5,DBC6,A1A1         @SC91325 06996642
         HTBL  DBC8,DBC9,DBCA,DBCB,DBCD,DBCE,DBD7,DBCF         @SC91325 06996644
         HTBL  A1A1,DBD1,DBD2,DBD3,A1A1,DBD5,DBD4,A1A1         @SC91325 06996646
         HTBL  DBD6,DBD9,DBDA,DBDD,DBDC,A1A1,DBDE,DBDF         @SC91325 06996648
         HTBL  DBE3,DBE2,DBF4,DBE4,DBE5,DBE6,DBF5,DBE7         @SC91325 06996650
         HTBL  DBE8,DBE9,DBEC,DBED,DBEE,DBEF,DBF0,DBF2         @SC91325 06996652
         HTBL  DBF3,DBF6,DBF7,DBF8,DBF9,DBFB,DBFC,DBFD         @SC91325 06996654
         HTBL  DBFE,DCA1,DCA2,DCA3,DCA5,DCAC,DCA6,DCA8         @SC91325 06996656
         HTBL  DCAB,A1A1,DCB2,DBFA,DCAE,DCB1,DCB0,DCAD         @SC91325 06996658
         HTBL  A1A1,DCB3,DCB4,DCA4,DCB6,DCB8,DCC4,DCBC         @SC91325 06996660
         HTBL  A1A1,DCBD,DCBE,DCBF,DCC1,DCC2,DCB9,DCC3         @SC91325 06996662
         HTBL  DCC5,DCC8,A1A1,A1A1,DCC9,DCCA,DCCB,DCCC         @SC91325 06996664
         HTBL  DCCD,DCCE,DCE3,DCCF,DCD0,DCD1,DCD5,DCD6         @SC91325 06996666
         HTBL  DCD7,DCD9,DCD3,DCDA,DCDB,DCDC,DCDD,DCDF         @SC91325 06996668
         HTBL  DCE0,DCE1,A1A1,DCE4,DCE5,DCE6,DCE7,DCE8         @SC91325 06996670
         HTBL  DCF8,DCE9,DCEB,DCEC,A1A1,A1A1,DCED,DCEE         @SC91325 06996672
         HTBL  DCFB,DCF0,DCF1,DCF2,DCF3,DCF4,DCF5,DCF6         @SC91325 06996674
         HTBL  A1A1,DCF7,DCEF,A1A1,DCF9,DCFA,DCFC,DCFD         @SC91325 06996676
         HTBL  DCFE,A1A1,DDA1,DDA8,DDAC,DDA3,DDA5,DDA6         @SC91325 06996678
         HTBL  DDA7,DCEA,DDA9,A1A1,DDAA,DDAD,A1A1,DDB1         @SC91325 06996680
         HTBL  DDA2,DDAE,DDB0,DCDE,DDB2,DDB3,DDB4,DDB6         @SC91325 06996682
         HTBL  DDB7,DDB8,DDBA,DDB9,DDBB,DDBC,DDBD,DDBE         @SC91325 06996684
         HTBL  DDBF,DDC0,DDC1,DDC2,DDC3,DDC4,DDC5,DDC6         @SC91325 06996686
         HTBL  DDC7,DDC8,DDC9,DDCA,DDCB,DDCC,DDCD,DDCE         @SC91325 06996688
         HTBL  DDCF,DDD0,DDD1,DDD2,DDD4,DDD3,DDD5,DDD6         @SC91325 06996690
         HTBL  DDD7,DDD8,DDD9,DDDA,A1A1,DDDB,DDDC,DDDD         @SC91325 06996692
         HTBL  DDDE,DDDF,DDE1,DDE2,DDE3,DDE4,DDE5,DDE6         @SC91325 06996694
         HTBL  A1A1,DDE7,DDE8,A1A1,DDE9,DDEB,DDEC,A1A1         @SC91325 06996696
         HTBL  A1A1,DDED,DDEE,DDEF,DDF0,DDF1,DDF2,DDF3         @SC91325 06996698
         HTBL  DDF4,DDF5,DDF6,DDF8,DDFA,DDFC,A1A1,DDFB         @SC91325 06996700
         HTBL  DDFD,DDFE,DEA1,DEA2,DEA3,DEA4,DEA5,DEA6         @SC91325 06996702
         HTBL  A1A1,DEA8,DEA9,DEAA,DEAE,DEAF,DEB0,DEB1         @SC91325 06996704
         HTBL  A1A1,DEB2,A1A1,DEB3,DEB4,DEB5,DEB6,DEB7         @SC91325 06996706
         HTBL  DEB8,DEB9,DEBA,A1A1,DEBB,DEBD,DED1,DEBE         @SC91325 06996708
         HTBL  DEC0,DEBF,A1A1,DEC1,A1A1,DEC2,DEC3,DEC4         @SC91325 06996710
         HTBL  DEC5,DEC6,A1A1,DEC7,DEC8,DEC9,DECA,A1A1         @SC91325 06996712
         HTBL  A1A1,DECB,DECC,DECD,DECE,DECF,DED0,DED2         @SC91325 06996714
         HTBL  DED3,DED4,A1A1,DED5,DED6,DED7,A1A1,DED8         @SC91325 06996716
         HTBL  DED9,DEDA,DEDB,A1A1,DEDC,A1A1,DEDD,DEDE         @SC91325 06996718
         HTBL  DEDF,DEE1,DEE2,DEE3,DEE4,DEE5,DEE7,DEE9         @SC91325 06996720
         HTBL  DEEA,DEEB,DEEC,DEED,DEEE,DEEF,A1A1,DEF1         @SC91325 06996722
         HTBL  DEF2,DEF3,DEF5,DEF6,DEF7,DEF8,DEF9,DEFA         @SC91325 06996724
         HTBL  DEFB,DEFC,DEFD,DEFE,DEE0,DFA1,DFA2,DFA3         @SC91325 06996726
         HTBL  DFA4,DFA5,DFA6,DFA8,DFA9,DFAA,DFAC,DFCC         @SC91325 06996728
         HTBL  DFAD,A1A1,DFAE,DFAF,DFB9,DFB0,DFB1,DFB3         @SC91325 06996730
         HTBL  DFB4,DFB5,A1A1,DFB6,DFB8,DFC2,DFBA,DFB2         @SC91325 06996732
         HTBL  DFBB,DFBC,DFBD,DFBF,DFBE,A1A1,DFC1,A1A1         @SC91325 06996734
         HTBL  A1A1,DFC3,DFC4,DFC5,DFC6,DFC7,DFC8,DFCA         @SC91325 06996736
         HTBL  DFCB,DFCF,DFAB,A1A1,DFCE,DFD0,DFD1,DFD2         @SC91325 06996738
         HTBL  DFD3,DFD4,A1A1,DFD5,DFD7,A1A1,DFD9,DFDA         @SC91325 06996740
         HTBL  DFDC,DFDD,DFDE,DFE0,DFE1,A1A1,A1A1,DFD8         @SC91325 06996742
         HTBL  DFE2,DFE3,DFE4,A1A1,A1A1,A1A1,DFE8,DFE9         @SC91325 06996744
         HTBL  DFEA,DFEB,DFEC,DFE7,DFED,DFEF,DFF0,A1A1         @SC91325 06996746
         HTBL  DFF2,A1A1,DFF4,DFF5,DFF6,DFFC,DFF7,DFF8         @SC91325 06996748
         HTBL  DFF3,DFF9,DFFD,DFFA,DFFB,DFEE,DFFE,E0A1         @SC91325 06996750
         HTBL  A1A1,E0A2,E0A3,E0A4,E0A6,E0A7,E0A8,E0A9         @SC91325 06996752
         HTBL  E0AA,E0AB,E0AC,E0AD,E0AE,E0AF,E0B0,E0B1         @SC91325 06996754
         HTBL  E0B2,E0B3,E0B5,E0B6,E0B4,E0B7,E0B8,E0B9         @SC91325 06996756
         HTBL  E0BA,A1A1,E0BC,A1A1,E0BD,E0BE,E0BF,E0BB         @SC91325 06996758
         HTBL  E0C0,E0C1,E0C2,E0C3,E0C4,E0C5,E0C6,E0C8         @SC91325 06996760
         HTBL  E0C9,E0CA,E0CB,E0CC,A1A1,E0CD,E0CF,E0CE         @SC91325 06996762
         HTBL  A1A1,E0D0,E0D1,E0D3,E0D2,E0D5,E0D4,E0D6         @SC91325 06996764
         HTBL  E0D7,E0D8,A1A1,E0D9,E0DA,E0DB,E0DD,A1A1         @SC91325 06996766
         HTBL  E0DE,E0DF,E0E0,E0E1,A1A1,A1A1,E0E2,A1A1         @SC91325 06996768
         HTBL  A1A1,E0E3,E0FE,E0E4,E0E9,A1A1,A1A1,E0E6         @SC91325 06996770
         HTBL  A1A1,A1A1,E0E8,A1A1,A1A1,E0EA,E0EB,E0EC         @SC91325 06996772
         HTBL  E0ED,E0EE,E0EF,E0F0,E0F1,E0F2,E0F3,E0F4         @SC91325 06996774
         HTBL  E0F5,E0F6,A1A1,A1A1,E0E7,E0F7,A1A1,E0F9         @SC91325 06996776
         HTBL  E0E5,E0FA,E0FB,E0FC,E0FD,E1A1,E1A2,E1A3         @SC91325 06996778
         HTBL  E1A4,E1A5,E1A7,E1A6,E1A8,E1AA,E1A9,A1A1         @SC91325 06996780
         HTBL  E1AB,E1AC,E1AD,E1B0,E1AE,E1AF,E1B2,E1B3         @SC91325 06996782
         HTBL  E1B4,E1B5,E1B6,E1B7,E1B8,E1B9,E1BA,E1BC         @SC91325 06996784
         HTBL  E1BB,E1BD,E1BF,E1C0,E1C1,A1A1,E1C7,E1C2         @SC91325 06996786
         HTBL  E1C3,E1C4,E1CA,E1C5,E1C6,E1C8,E1C9,E1CB         @SC91325 06996788
         HTBL  E1CC,E1CD,E1CE,E1CF,E1D0,E1D1,E1D2,E1D3         @SC91325 06996790
         HTBL  E1D4,E1D5,E1D6,E1D7,E1D8,E1D9,E1DA,E1DB         @SC91325 06996792
         HTBL  E1DC,E1DD,E1DE,E1DF,E1E0,E1E1,E1E2,E1E3         @SC91325 06996794
         HTBL  E1E4,E1E5,E1E6,E1E8,E1E9,E1EA,E1EB,E1EC         @SC91325 06996796
         HTBL  E1ED,E1EE,E1EF,E1F0,E1F1,E1F2,E1F3,E1F6         @SC91325 06996798
         HTBL  E1F4,E1F5,E1F7,E1F8,E1F9,E1FA,E1FC,E1FB         @SC91325 06996800
         HTBL  E1FD,E1FE,E2A1,E2A2,E2A4,A1A1,E2A5,E2A6         @SC91325 06996802
         HTBL  E2A7,E2A8,E2AC,E2AD,A1A1,A1A1,A1A1,A1A1         @SC91325 06996804
         HTBL  E2AE,E2AF,E2B0,E2B1,E2B2,E2B3,A1A1,E2B4         @SC91325 06996806
         HTBL  E2B5,E2B6,E2B7,E2B8,E2B9,E2BB,E2BC,E2BD         @SC91325 06996808
         HTBL  E2BE,E2BF,E2C0,E2C2,E2C1,E2C4,E2C5,E2C6         @SC91325 06996810
         HTBL  E2C7,E2C8,A1A1,E2C9,E2CA,E2CB,E2CC,E2CD         @SC91325 06996812
         HTBL  E2CE,E2CF,E2D0,E2D1,E2D2,E2D3,E2D4,E2D5         @SC91325 06996814
         HTBL  E2D6,E2D7,E2D8,E2D9,E2DA,E2DB,E2DC,E2DD         @SC91325 06996816
         HTBL  E2DE,E2DF,E2E1,E2E2,E2E3,E2E4,A1A1,E2E5         @SC91325 06996818
         HTBL  E2E6,E2E7,A1A1,E2E8,E2E9,E2EB,A1A1,A1A1         @SC91325 06996820
         HTBL  E2ED,E2EC,A1A1,E2EE,E2F0,E2EF,E2F1,E2F2         @SC91325 06996822
         HTBL  E2F3,E2F4,E2F5,E2F6,E2F7,E2F8,E2F9,E2FA         @SC91325 06996824
         HTBL  E2FB,E2FC,E2FD,E2FE,E3A1,E3A2,E3A3,E3A4         @SC91325 06996826
         HTBL  E3A5,E3A7,E3A8,E3A9,E3AA,A1A1,A1A1,E3AB         @SC91325 06996828
         HTBL  E3AC,A1A1,E3AE,E3AF,E3B0,A1A1,E3B3,E3B4         @SC91325 06996830
         HTBL  A1A1,A1A1,E3B5,A1A1,E3B8,E3BA,E3BC,E3BD         @SC91325 06996832
         HTBL  E3BE,E3BF,E3C0,E3C2,E3C3,E3C4,E3C5,E3C6         @SC91325 06996834
         HTBL  E3C8,E3CA,E3CC,E3CD,E3CB,E3CE,E3CF,E3D0         @SC91325 06996836
         HTBL  E3D2,E3D1,E3D3,E3D4,E3D5,E3D6,E3D7,E3D8         @SC91325 06996838
         HTBL  E3DA,E3DB,E3DC,E3D9,E3DD,E3DF,E3E0,E3E4         @SC91325 06996840
         HTBL  E3DE,E3E3,E3E1,E3E2,E3E5,E3E6,E3E7,E3E8         @SC91325 06996842
         HTBL  D4F4,A1A1,E3E9,E3EA,E3EB,E3EC,E3ED,E3EE         @SC91325 06996844
         HTBL  E3EF,E3F0,A1A1,A1A1,A1A1,E3F1,E3F2,D1BF         @SC91325 06996846
         HTBL  E3F3,E3F4,E4A4,E3F5,E3F6,E3F7,E3FD,E3F9         @SC91325 06996848
         HTBL  E3FA,E3FB,E3FC,E3FE,E4A3,E4A5,E4A6,E4B8         @SC91325 06996850
         HTBL  E4A7,E4A1,E4A9,E4AB,E4AC,E4AE,E4AF,E4B0         @SC91325 06996852
         HTBL  E4B1,E4B2,E4B3,E4B4,E4B6,E4B7,E4B9,E4BD         @SC91325 06996854
         HTBL  E4BA,E4BC,E4BE,E4BF,A1A1,E4C0,E4C1,E4C4         @SC91325 06996856
         HTBL  E4CB,E4C5,E4C3,E4C7,E4C9,E4C8,E4CA,E4CD         @SC91325 06996858
         HTBL  E4CE,E4CF,E4D0,E4D1,E4D2,E4D3,E4D4,E4D5         @SC91325 06996860
         HTBL  E4DA,E4D6,E4D7,E4DF,E4DB,E4DC,E4DD,E4E0         @SC91325 06996862
         HTBL  E4E1,E4E2,E4E3,E4E4,E4E5,E4E7,E4E8,E4E9         @SC91325 06996864
         HTBL  E4E6,E4EA,E4EB,E4EC,E4ED,E4EE,E4EF,A1A1         @SC91325 06996866
         HTBL  E4F0,E4F2,E4F3,E4F5,E4F7,E4F4,E4F6,E4F9         @SC91325 06996868
         HTBL  E4FA,E4FB,E4FC,E4FE,E5A1,E5A2,E5A3,E5A4         @SC91325 06996870
         HTBL  E5A5,E5A6,E5A7,E5A8,E5A9,E5AA,A1A1,E5AB         @SC91325 06996872
         HTBL  A1A1,E5AC,E5AD,E5AE,E5B0,E5B1,E5B2,E5B3         @SC91325 06996874
         HTBL  E5B4,E5B5,E5B6,E5BB,E5BC,E5BD,A1A1,E5BE         @SC91325 06996876
         HTBL  E5BF,E5C0,E5C2,E5C3,A1A1,E5C5,E5C6,E5C7         @SC91325 06996878
         HTBL  E5EE,E5C8,E5C9,A1A1,E5CA,E5CB,E5CC,E5D7         @SC91325 06996880
         HTBL  E5CD,E5CE,E5C4,E5CF,E5D0,E5D2,E5D3,E5D5         @SC91325 06996882
         HTBL  E5D6,E5E1,E5D9,E5DA,E5D4,E5C1,E5DC,E5DB         @SC91325 06996884
         HTBL  E5DD,E5DE,E5DF,E5E0,E5E3,E5E4,E5E5,A1A1         @SC91325 06996886
         HTBL  E5E6,E5E7,E5E2,E5E8,E5E9,E5EA,E5EB,E5EC         @SC91325 06996888
         HTBL  E5EF,E5F0,E5F1,E5ED,E5F3,E5FA,E5F4,E5F5         @SC91325 06996890
         HTBL  E5F7,E5F8,E5F9,E5FB,E5FD,E5FE,E6A1,A1A1         @SC91325 06996892
         HTBL  E6A2,E6A4,E6A6,E6A7,E6A8,E6A9,E6AA,E6AB         @SC91325 06996894
         HTBL  E6AC,E6AE,E6AD,E6AF,E6B0,E6B1,E6B2,E6B4         @SC91325 06996896
         HTBL  E6B3,E6B5,E6B6,E6B7,E6B8,E6B9,A1A1,E6BA         @SC91325 06996898
         HTBL  E6BB,E6BE,E6BC,E6BD,E6BF,E6C0,E6C1,A1A1         @SC91325 06996900
         HTBL  E6C2,E6C3,E6C4,E6C5,E6C7,E6C8,E6C9,E6CA         @SC91325 06996902
         HTBL  E6CB,E6CE,E6CF,E6D0,E6D2,E6D3,E6D4,E6D5         @SC91325 06996904
         HTBL  E6D6,E6D7,E6D8,E6D9,E6DA,E6DB,E6DD,E6DE         @SC91325 06996906
         HTBL  E6DF,E6E0,E6E1,E6E2,E6E3,E6E4,E6E5,E6E6         @SC91325 06996908
         HTBL  E6E7,E6E9,E6EB,E6EC,E6ED,E6EE,E6EF,E6F0         @SC91325 06996910
         HTBL  E6F1,E6F2,E6F3,E6F4,E6F5,E6F7,E6F8,E6F9         @SC91325 06996912
         HTBL  E6FA,E6FC,E6FD,E6FE,E7A2,E7A3,E7A4,E7A5         @SC91325 06996914
         HTBL  E7A6,E7A7,E7A8,E7A9,E7B5,E7AA,E7AB,E7AC         @SC91325 06996916
         HTBL  E7AD,E7AE,E7AF,E7B0,E7B1,E7B2,E7B4,E7B6         @SC91325 06996918
         HTBL  E7B9,E7B3,E7B7,E7BB,E7B8,E7C5,E7BA,E7BC         @SC91325 06996920
         HTBL  E7BD,E7BE,E7BF,E7C0,E7C1,E7C2,E7C4,E7C3         @SC91325 06996922
         HTBL  E7C6,E7C7,E7C8,E7CA,E7CB,E7CC,E7CD,E7CE         @SC91325 06996924
         HTBL  E7CF,E7D2,E7D3,D0B0,E7D4,E7D5,E7D6,E7E4         @SC91325 06996926
         HTBL  E7D7,E7D8,E7D9,E7DA,E7DD,E7DC,E7DE,E7DF         @SC91325 06996928
         HTBL  E7E0,E7E1,E7E2,E7E3,E7E5,E7E6,E7E8,E7E9         @SC91325 06996930
         HTBL  E7EA,E7EB,E7EC,E7ED,E7EE,E7EF,E7F0,E7F1         @SC91325 06996932
         HTBL  A1A1,E7F2,E7F3,E7F4,E7F7,E7F8,E7F9,E7FA         @SC91325 06996934
         HTBL  E7FB,E7FC,E7F5,E7FD,E7FE,E8A1,A1A1,E8A2         @SC91325 06996936
         HTBL  E8A3,E8A5,E8A6,E8A7,E8A8,E8A9,E8AA,E8AB         @SC91325 06996938
         HTBL  E8AD,E8AF,E8B0,E8B1,E8B2,E8B3,E8B4,E8B5         @SC91325 06996940
         HTBL  E8BB,A1A1,E8B7,E8B8,E8B9,E8BA,E7F6,E8BC         @SC91325 06996942
         HTBL  E8AE,E8BD,E8BE,E8BF,E8C0,A1A1,E8C2,E8C8         @SC91325 06996944
         HTBL  E8C3,E8C4,E8C5,E8C6,E8C7,E8C9,E8CA,E8CB         @SC91325 06996946
         HTBL  E8CC,E8CE,A1A1,E8CF,E8D2,E8D4,E8E4,E8D5         @SC91325 06996948
         HTBL  E8D7,E8D8,E8D9,E8E1,A1A1,E8DB,E8DC,E8DD         @SC91325 06996950
         HTBL  E8DE,E8E0,E8D0,E8E2,E8E3,E8E5,E8E6,E8E7         @SC91325 06996952
         HTBL  A1A1,E8E9,E8EA,E8EB,E8EC,E8ED,E8DA,E8EE         @SC91325 06996954
         HTBL  E8EF,E8F0,E8E8,E8F2,E8F3,E8F4,E8F5,E8F6         @SC91325 06996956
         HTBL  E8F7,E8F8,E8F9,E8D1,A1A1,E8D6,E8FB,A1A1         @SC91325 06996958
         HTBL  E8FC,E8FD,E8FE,E9A1,E9A2,E9A3,A1A1,E9A4         @SC91325 06996960
         HTBL  E9A5,E9A6,E9A7,E9A8,E9A9,E9AA,E9AB,E9AC         @SC91325 06996962
         HTBL  E9AD,E9AE,E9AF,E9B0,E9B1,E9B2,E9B3,A1A1         @SC91325 06996964
         HTBL  E7D1,A1A1,E9B4,E9B5,E9B6,E9B7,E9B8,E9B9         @SC91325 06996966
         HTBL  E9BA,E9BB,E9BC,E9BD,E9BE,E9BF,E9C0,E9C1         @SC91325 06996968
         HTBL  E9C4,E9C5,E9C6,E9C7,A1A1,E9C8,E9C9,D1DD         @SC91325 06996970
         HTBL  E9CB,E9CC,E9CD,E9CE,E9CF,E9D0,E9D2,E9D1         @SC91325 06996972
         HTBL  E9D3,E9D4,E9D5,E9D6,E9D7,E9D8,E9D9,E9DA         @SC91325 06996974
         HTBL  A1A1,E9DB,E9DC,E9DD,E9DE,E9DF,E9E0,E9E1         @SC91325 06996976
         HTBL  E9E3,E9E4,E9E5,E9E6,E9E7,E9E8,E9E9,E9EA         @SC91325 06996978
         HTBL  E9EB,E9EC,E9ED,E9EE,E9EF,E9F1,E9F2,E9F3         @SC91325 06996980
         HTBL  E9F4,E9F6,E9F7,E9F8,E9F9,E9FA,E9FB,E9FC         @SC91325 06996982
         HTBL  EAA7,EAA3,E9F5,E9FD,E9FE,EAA1,EAA2,EAA4         @SC91325 06996984
         HTBL  EAA5,EAB2,EAA6,EAA8,EAA9,EAAA,EAAB,EAAC         @SC91325 06996986
         HTBL  EAAD,EAAE,EAAF,EAB0,EABD,EAB3,EAB4,EAB5         @SC91325 06996988
         HTBL  EAB6,EABC,A1A1,EAB7,EABF,EAB8,EAB9,EABA         @SC91325 06996990
         HTBL  EABB,EABE,EAC0,EAC1,EAC2,EAC6,EAC3,EAC4         @SC91325 06996992
         HTBL  EAC5,EAC7,EAC9,EAC8,DEA7,EACA,EACB,EACC         @SC91325 06996994
         HTBL  EACD,EACE,EACF,EAD0,EAD2,EAD3,EAD5,EAD6         @SC91325 06996996
         HTBL  EAD1,EAD7,EAD8,EAD9,EADA,EADB,EADC,EADD         @SC91325 06996998
         HTBL  EADF,EAD4,EAE0,EAE1,EAE2,EAE3,EAE4,EAE5         @SC91325 06997000
         HTBL  EAE6,EAE7,EAE8,EAE9,A1A1,EAEB,EAEC,EAED         @SC91325 06997002
         HTBL  EAEE,EAF4,EAFC,EAEF,EAF0,EAF2,EAF3,EAF5         @SC91325 06997004
         HTBL  EAF6,EAF8,EAF9,EAF1,EAFA,F0B7,EAFB,EAFD         @SC91325 06997006
         HTBL  EAFE,EBA1,EBA4,EBA2,EBA3,EBA5,EBA6,EBA7         @SC91325 06997008
         HTBL  EBA8,EBA9,EBAA,EBAB,EBAC,EBAD,EBAE,EBAF         @SC91325 06997010
         HTBL  EBB0,EBB1,EBB2,EBB3,EBB4,EBB6,EBB5,EBB7         @SC91325 06997012
         HTBL  EBB8,EBBA,EBBB,EBBC,EBBD,EBBE,EBBF,EBC0         @SC91325 06997014
         HTBL  EBC1,A1A1,EBC2,EBC3,EBC4,EBC5,EBC6,A1A1         @SC91325 06997016
         HTBL  EBC7,EBC8,EBC9,EBCA,EBCB,EBCC,EBCD,EBCE         @SC91325 06997018
         HTBL  A1A1,EBCF,EBD0,EBD1,EBD2,EBD3,EBD4,EBD5         @SC91325 06997020
         HTBL  EBD6,EBD7,EBD8,A1A1,EBDD,A1A1,EBDA,EBDB         @SC91325 06997022
         HTBL  EBDC,EBDE,EBDF,EBE0,EBE1,EBE2,EBE3,EBE4         @SC91325 06997024
         HTBL  EBEB,A1A1,A1A1,A1A1,EBE5,EBE6,EBE7,EBE8         @SC91325 06997026
         HTBL  EBE9,EBEA,EBEC,EBED,EBEE,EBEF,EBF0,EBF6         @SC91325 06997028
         HTBL  EBF1,EBF2,EBF3,EBF4,EBF7,EBF8,EBF9,A1A1         @SC91325 06997030
         HTBL  EBFA,EBFB,EBFC,EBFD,ECA4,EBFE,ECA1,ECA2         @SC91325 06997032
         HTBL  ECA3,ECA5,A1A1,ECA6,ECA7,ECA8,ECAC,ECA9         @SC91325 06997034
         HTBL  ECAA,ECAB,ECAD,ECAE,ECAF,ECB0,ECB1,ECB2         @SC91325 06997036
         HTBL  ECB3,ECB4,ECB5,ECB6,ECB7,ECB8,ECB9,ECC1         @SC91325 06997038
         HTBL  ECBA,ECBB,ECBC,ECBD,ECBE,ECBF,ECC2,ECC0         @SC91325 06997040
         HTBL  ECC3,ECC4,ECC5,ECC9,ECC6,ECC7,ECC8,ECCC         @SC91325 06997042
         HTBL  ECCA,ECCB,ECCD,ECDC,ECCE,ECCF,A1A1,A1A1         @SC91325 06997044
         HTBL  ECD0,ECD1,ECD2,ECD6,ECD5,ECD7,ECD8,A1A1         @SC91325 06997046
         HTBL  ECD9,ECDB,ECDD,ECDE,ECDF,ECE0,ECE1,A1A1         @SC91325 06997048
         HTBL  A1A1,ECE3,ECE5,ECE6,ECE7,ECE8,ECE9,ECEA         @SC91325 06997050
         HTBL  ECEB,ECEC,ECED,ECEE,ECEF,ECF0,ECF1,ECF2         @SC91325 06997052
         HTBL  ECF3,ECF5,ECF4,ECF6,ECF7,ECF8,ECF9,ECFA         @SC91325 06997054
         HTBL  ECFB,ECFC,ECFD,ECFE,EDA1,EDA2,EDA3,EDA4         @SC91325 06997056
         HTBL  EDA5,EDA6,EDA7,EDA8,EDAB,EDAA,EDAC,EDAD         @SC91325 06997058
         HTBL  EDB0,EDAE,EDAF,EDB1,EDB2,EDB3,EDB4,EDB5         @SC91325 06997060
         HTBL  EDB6,EDB7,EDB8,EDBA,EDB9,EDBE,EDBF,EDBD         @SC91325 06997062
         HTBL  EDC0,EDC1,EDC2,A1A1,EDC3,EDC4,EDC5,EDC6         @SC91325 06997064
         HTBL  EDC7,EDC8,EDC9,EDD2,EDCA,EDCB,EDCC,EDCE         @SC91325 06997066
         HTBL  EDCF,EDCD,EDD0,EDD3,EDD4,EDD5,EDD6,EDD7         @SC91325 06997068
         HTBL  EDD8,EDD9,EDDB,EDDC,EDDA,EDDD,EDDE,EDDF         @SC91325 06997070
         HTBL  EDE0,EDE1,EDE2,EDE3,EDE4,EDE5,D1FE,D2A1         @SC91325 06997072
         HTBL  EDE6,EDE7,EDE8,A1A1,EDE9,EDEA,EDEB,EDED         @SC91325 06997074
         HTBL  EDEE,EDEF,EDF0,EDF1,EDFE,EDF3,EDF4,EEA5         @SC91325 06997076
         HTBL  EDF5,EDF6,EDF7,EDF8,EDF9,EDFA,EDFB,EDFD         @SC91325 06997078
         HTBL  EEA1,A1A1,EEA2,EEA3,EEA4,EEA6,EEA7,EEA8         @SC91325 06997080
         HTBL  EEA9,EEAA,EEAB,A1A1,EEAC,EEAD,EEAE,EEAF         @SC91325 06997082
         HTBL  EEB0,EEB1,EEB5,EEB3,EEB6,EEBD,EEB8,EEB9         @SC91325 06997084
         HTBL  EEBA,EEBB,EEBC,EEBE,A1A1,EEBF,A1A1,A1A1         @SC91325 06997086
         HTBL  EEC0,EEC1,EEC2,A1A1,EEC3,EEC4,EEC5,EEC6         @SC91325 06997088
         HTBL  EEC7,EEC8,EEC9,EECA,EECB,EECC,EECD,EECE         @SC91325 06997090
         HTBL  EECF,EED0,EED1,EED2,EED3,EED4,EED5,EED6         @SC91325 06997092
         HTBL  EED7,EED9,EEDA,A1A1,EEDE,A1A1,A1A1,EEDB         @SC91325 06997094
         HTBL  EEDC,EEDD,A1A1,EEE0,A1A1,A1A1,EEE1,A1A1         @SC91325 06997096
         HTBL  A1A1,EEE2,EEE3,A1A1,EEE4,A1A1,EEE5,EEE6         @SC91325 06997098
         HTBL  EFCF,EEE9,EEEA,A1A1,EEEB,EEEC,A1A1,A1A1         @SC91325 06997100
         HTBL  EEED,A1A1,EEF1,A1A1,EEEF,A1A1,A1A1,EEF0         @SC91325 06997102
         HTBL  A1A1,EEF6,EEF2,A1A1,A1A1,A1A1,EEF3,EEF4         @SC91325 06997104
         HTBL  EEF5,EEEE,EEFA,EEF7,A1A1,A1A1,A1A1,A1A1         @SC91325 06997106
         HTBL  A1A1,A1A1,EEF8,EEF9,A1A1,A1A1,EFA5,EFA6         @SC91325 06997108
         HTBL  EEFB,A1A1,EEFC,A1A1,EEFD,A1A1,A1A1,EFA1         @SC91325 06997110
         HTBL  A1A1,A1A1,EFA2,EFA3,A1A1,EFA4,A1A1,EFA7         @SC91325 06997112
         HTBL  A1A1,EFA9,EFAA,EFAB,EFAC,A1A1,EFB1,EFAD         @SC91325 06997114
         HTBL  A1A1,EFAF,EFB0,EFBA,EFB2,A1A1,EFB3,EFB4         @SC91325 06997116
         HTBL  EFB5,EFB6,EFB7,EFB8,A1A1,EFB9,EFBB,EFBC         @SC91325 06997118
         HTBL  A1A1,EFBD,EFBE,EFC5,EFBF,EFC0,EFC2,EFC3         @SC91325 06997120
         HTBL  A1A1,EFC6,EFC7,EFC8,A1A1,EFC9,A1A1,EFCA         @SC91325 06997122
         HTBL  EFD4,EFCB,EFCC,EFCD,EFCE,EFD1,EFD0,EFD2         @SC91325 06997124
         HTBL  EFD8,EFD3,EFD5,EFD6,EFD7,EFD9,EFDA,EFDB         @SC91325 06997126
         HTBL  A1A1,EFDC,EFDD,EFDE,EFDF,EFE0,EFE1,EFE2         @SC91325 06997128
         HTBL  EFE3,EFE4,EFE5,EFE6,EFE7,EFE8,EFE9,EFEA         @SC91325 06997130
         HTBL  EFEB,EFEC,EFED,EFEE,EFEF,EFF0,EFF1,EFF2         @SC91325 06997132
         HTBL  EFF3,EFF4,EFF5,EFF6,EFF7,EFF8,EFFA,EFF9         @SC91325 06997134
         HTBL  EFFB,EFFD,F0A1,F0A2,F0A3,EFFC,F0A4,F0A5         @SC91325 06997136
         HTBL  F0A6,E7A1,A1A1,F0A7,F0A8,F0A9,A1A1,A1A1         @SC91325 06997138
         HTBL  F0AB,F0AA,F0AC,F0AD,F0AE,A1A1,F0AF,F0B0         @SC91325 06997140
         HTBL  F0B1,F0B2,F0B3,F0B4,F0BA,F0B8,D2D6,F0BB         @SC91325 06997142
         HTBL  F0BC,F0BD,F0BE,F0C4,F0B9,F0BF,F0C0,F0C1         @SC91325 06997144
         HTBL  F0C2,F0C3,F0C5,F0C6,F0C7,A1A1,F0C8,A1A1         @SC91325 06997146
         HTBL  F0C9,F0CA,F0CC,F0CB,A1A1,F0CD,F0CE,F0CF         @SC91325 06997148
         HTBL  A1A1,A1A1,A1A1,A1A1,F0D0,F0D1,F0D2,F0D3         @SC91325 06997150
         HTBL  F0D4,F0D7,F0D8,F0D9,F0DA,F0DB,F0DC,F0DE         @SC91325 06997152
         HTBL  F0DF,F0E0,F0E1,F0E2,F0E3,F0E4,F0E5,F0E6         @SC91325 06997154
         HTBL  F0E7,F0E8,F0E9,F0EA,F0EB,F0EC,F0EE,F0EF         @SC91325 06997156
         HTBL  F0F1,F0F2,F0F4,F0F5,F0F6,F0F7,F0F8,F0FA         @SC91325 06997158
         HTBL  F0FB,A1A1,A1A1,F0FC,F0FD,F0FE,F1A1,F1A2         @SC91325 06997160
         HTBL  F1A3,F1A4,F1A5,F1A6,F1A7,F1A8,F1A9,F1AA         @SC91325 06997162
         HTBL  E6CC,D2AC,F1AB,A1A1,F1AC,A1A1,F1AD,F1B3         @SC91325 06997164
         HTBL  F1AF,F1B0,F1B1,A1A1,A1A1,F1B2,F1B4,F1B5         @SC91325 06997166
         HTBL  F1B6,F1B7,F1B8,F1B9,F1BA,F1BB,F1BC,F1BD         @SC91325 06997168
         HTBL  F1BE,F1BF,F1C0,F1C2,F1C3,F1C4,F1C5,A1A1         @SC91325 06997170
         HTBL  F1C6,F1C7,F1C8,F1C9,F1CA,F1CB,F1CC,F1CD         @SC91325 06997172
         HTBL  F1CE,F1CF,F1D0,F1D8,F1D1,F1D2,F1D3,F1D4         @SC91325 06997174
         HTBL  F1D5,F1D6,F1D7,F1D9,F1DA,F1DB,F1DE,F1DC         @SC91325 06997176
         HTBL  F1DD,F1DF,F1E0,F1E1,F1E2,A1A1,F1E3,F1E4         @SC91325 06997178
         HTBL  F1E5,F1E6,F1E9,F1E7,F1E8,F1EB,F1EA,F1EC         @SC91325 06997180
         HTBL  F1ED,F1EE,F1EF,F1F0,F1F2,F1F3,F1F1,A1A1         @SC91325 06997182
         HTBL  A1A1,F1F4,F1F5,F1F6,F1F7,F1F8,F1F9,F1FA         @SC91325 06997184
         HTBL  F1FB,F1FC,F1FD,F1FE,F2A1,F2A2,F2A3,F2A4         @SC91325 06997186
         HTBL  F2A5,F2A6,F2A7,F2A8,F2A9,F2AA,F2AB,F2AC         @SC91325 06997188
         HTBL  F2AD,F2AE,DDB5,F2AF,E4F8,F2B0,F2B1,F2B3         @SC91325 06997190
         HTBL  F2B4,F2B5,F2B6,A1A1,F2B7,A1A1,F2B8,A1A1         @SC91325 06997192
         HTBL  F2B9,F2BA,F2BB,F2BC,F2BD,F2BE,F2BF,A1A1         @SC91325 06997194
         HTBL  F2C0,F2C1,F2C2,A1A1,F2C3,F2C4,F2C5,F2C6         @SC91325 06997196
         HTBL  F2C7,F2C8,F2C9,F2CA,F2CB,F2CC,F2CD,F2CF         @SC91325 06997198
         HTBL  F2CE,F2DA,F2DC,F2D1,F2D2,A1A1,F2D3,F2D4         @SC91325 06997200
         HTBL  F2D5,F2D6,F2D7,F2D8,F2D9,F2DB,F2DD,F2DE         @SC91325 06997202
         HTBL  F2DF,F2E0,F2E1,F2E2,F2E3,F2E4,F2E5,F2E6         @SC91325 06997204
         HTBL  F2E7,F2E8,F2E9,F2EF,F2EA,F2EB,F2EC,F2ED         @SC91325 06997206
         HTBL  F2F0,F2F1,F2F2,F2F3,F2F4,F2F5,F2F6,F2F8         @SC91325 06997208
         HTBL  F2F9,F2FA,F2FB,F2F7,F2FC,F2FD,F2FE,F3A1         @SC91325 06997210
         HTBL  F3A2,F3A6,F3A4,F3A5,F3A3,F3A7,A1A1,F3A9         @SC91325 06997212
         HTBL  A1A1,F3AB,F3AC,F3AD,F3AE,F3AF,F3AA,F3B0         @SC91325 06997214
         HTBL  F3B1,F3B2,F3B3,F3B4,F3B5,F3B6,F3B7,F3B8         @SC91325 06997216
         HTBL  A1A1,F3B9,F3BA,F3BB,F3BC,F3BD,F3BE,F3BF         @SC91325 06997218
         HTBL  F3C0,F3C1,A1A1,F3C2,F3C3,F3C4,F3C5,F3C6         @SC91325 06997220
         HTBL  F3C7,F3C8,F3C9,F3CB,F3CC,F3CD,F3CE,F3D0         @SC91325 06997222
         HTBL  F3D1,F3D2,D6F7,DDE0,F3D3,F3D4,F3D6,F3D7         @SC91325 06997224
         HTBL  A1A1,F3D8,F3D9,F3DA,F3DB,F3DC,F3DD,F3DE         @SC91325 06997226
         HTBL  F3DF,F3E0,F3E1,F3E2,F3E3,F3E4,F3E5,F3E6         @SC91325 06997228
         HTBL  F3E7,F3E8,F3E9,F3EA,F3EB,F3EC,F3ED,F3EE         @SC91325 06997230
         HTBL  ECDA,F0ED,F3EF,F3F0,F3F1,F3F2,F3F3,F3F4         @SC91325 06997232
         HTBL  F3F5,F3F6,F3F7,F3F8,F3F9,F3FA,F3FB,F3FC         @SC91325 06997234
         HTBL  F3FD,F3FE,F4A1,F4A2,F4A3,F4A4                   @SC91325 06997236
KJIBMZ   DS    0H                                              @SC91325 06997238
KJEUCIBM DS    0F                                              @SC91325 06997240
         DC    XL4'A1A1',H'94',Y(KJEUCZ-KJEUCIBM-KJTBL0)       @SC91325 06997242
         DC    Y(1-1)        Length-1 of shift codes           @SC91325 06997244
         DC    X'0F',3X'0'   Enter Roman mode                  @SC91325 06997246
         DC    X'0E',3X'0'   Enter Kanji mode                  @SC91325 06997248
         DC    X'4040'                                         @SC91325 06997250
         HTBL  4040,4344,4341,426B,424B,4345,427A,425E         @SC91325 06997252
         HTBL  426F,425A,43BE,43BF,4450,4279,4460,4470         @SC91325 06997254
         HTBL  42A1,426D,43DC,43DD,44DC,44DD,445B,445C         @SC91325 06997256
         HTBL  445D,445E,445F,4358,444A,445A,4261,43E0         @SC91325 06997258
         HTBL  43A1,447C,424F,447F,447E,4461,4471,4462         @SC91325 06997260
         HTBL  4472,424D,425D,4463,4473,4444,4445,42C0         @SC91325 06997262
         HTBL  42D0,4464,4474,4465,4475,4342,4343,4442         @SC91325 06997264
         HTBL  4443,4466,4476,424E,4260,444B,447A,447B         @SC91325 06997266
         HTBL  427E,444C,424C,426E,4467,4477,444D,4468         @SC91325 06997268
         HTBL  4469,4479,44ED,44EE,44EF,444E,425B,42E0         @SC91325 06997270
         HTBL  434A,424A,426C,427B,4250,425C,427C,446A         @SC91325 06997272
         HTBL  44E5,44E6,44E0,44E1,44E4,44E7,44E8,44E9         @SC91325 06997274
         HTBL  44EA,44E2,44E3,44EB,44EC,446B,446C,44F0         @SC91325 06997276
         HTBL  44F1,44F2,44F3,447D,4040,4040,4040,4040         @SC91325 06997278
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997280
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997282
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997284
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997286
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997288
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997290
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997292
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997294
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997296
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997298
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997300
         HTBL  4040,4040,4040,42F0,42F1,42F2,42F3,42F4         @SC91325 06997302
         HTBL  42F5,42F6,42F7,42F8,42F9,4040,4040,4040         @SC91325 06997304
         HTBL  4040,4040,4040,4040,42C1,42C2,42C3,42C4         @SC91325 06997306
         HTBL  42C5,42C6,42C7,42C8,42C9,42D1,42D2,42D3         @SC91325 06997308
         HTBL  42D4,42D5,42D6,42D7,42D8,42D9,42E2,42E3         @SC91325 06997310
         HTBL  42E4,42E5,42E6,42E7,42E8,42E9,4040,4040         @SC91325 06997312
         HTBL  4040,4040,4040,4040,4281,4282,4283,4284         @SC91325 06997314
         HTBL  4285,4286,4287,4288,4289,4291,4292,4293         @SC91325 06997316
         HTBL  4294,4295,4296,4297,4298,4299,42A2,42A3         @SC91325 06997318
         HTBL  42A4,42A5,42A6,42A7,42A8,42A9,4040,4040         @SC91325 06997320
         HTBL  4040,4040,4447,4481,4448,4482,4449,4483         @SC91325 06997322
         HTBL  4451,4484,4452,4485,4486,44C0,4487,44C1         @SC91325 06997324
         HTBL  4488,44C2,4489,44C3,448A,44C4,448C,44C5         @SC91325 06997326
         HTBL  448D,44C6,448E,44C7,448F,44C8,4490,44C9         @SC91325 06997328
         HTBL  4491,44CA,4492,44CB,4456,4493,44CC,4494         @SC91325 06997330
         HTBL  44CD,4495,44CE,4496,4497,4498,4499,449A         @SC91325 06997332
         HTBL  449D,44CF,44D5,449E,44D0,44D6,449F,44D1         @SC91325 06997334
         HTBL  44D7,44A2,44D2,44D8,44A3,44D3,44D9,44A4         @SC91325 06997336
         HTBL  44A5,44A6,44A7,44A8,4453,44A9,4454,44AA         @SC91325 06997338
         HTBL  4455,44AC,44AD,44AE,44AF,44BA,44BB,4457         @SC91325 06997340
         HTBL  44BC,44DA,44DB,4446,44BD,4040,4040,4040         @SC91325 06997342
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997344
         HTBL  4347,4381,4348,4382,4349,4383,4351,4384         @SC91325 06997346
         HTBL  4352,4385,4386,43C0,4387,43C1,4388,43C2         @SC91325 06997348
         HTBL  4389,43C3,438A,43C4,438C,43C5,438D,43C6         @SC91325 06997350
         HTBL  438E,43C7,438F,43C8,4390,43C9,4391,43CA         @SC91325 06997352
         HTBL  4392,43CB,4356,4393,43CC,4394,43CD,4395         @SC91325 06997354
         HTBL  43CE,4396,4397,4398,4399,439A,439D,43CF         @SC91325 06997356
         HTBL  43D5,439E,43D0,43D6,439F,43D1,43D7,43A2         @SC91325 06997358
         HTBL  43D2,43D8,43A3,43D3,43D9,43A4,43A5,43A6         @SC91325 06997360
         HTBL  43A7,43A8,4353,43A9,4354,43AA,4355,43AC         @SC91325 06997362
         HTBL  43AD,43AE,43AF,43BA,43BB,4357,43BC,43DA         @SC91325 06997364
         HTBL  43DB,4346,43BD,43D4,4359,435A,4040,4040         @SC91325 06997366
         HTBL  4040,4040,4040,4040,4040,4040,4161,4162         @SC91325 06997368
         HTBL  4163,4164,4165,4166,4167,4168,4169,416A         @SC91325 06997370
         HTBL  416B,416C,416D,416E,416F,4170,4171,4172         @SC91325 06997372
         HTBL  4173,4174,4175,4176,4177,4178,4040,4040         @SC91325 06997374
         HTBL  4040,4040,4040,4040,4040,4040,4141,4142         @SC91325 06997376
         HTBL  4143,4144,4145,4146,4147,4148,4149,414A         @SC91325 06997378
         HTBL  414B,414C,414D,414E,414F,4150,4151,4152         @SC91325 06997380
         HTBL  4153,4154,4155,4156,4157,4158,4040,4040         @SC91325 06997382
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997384
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997386
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997388
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997390
         HTBL  4040,4040,4040,4040,41C0,41C1,41C2,41C3         @SC91325 06997392
         HTBL  41C4,41C5,41C6,41C7,41C8,41C9,41CA,41CB         @SC91325 06997394
         HTBL  41CC,41CD,41CE,41CF,41D0,41D1,41D2,41D3         @SC91325 06997396
         HTBL  41D4,41D5,41D6,41D7,41D8,41D9,41DA,41DB         @SC91325 06997398
         HTBL  41DC,41DD,41DE,41DF,41E0,4040,4040,4040         @SC91325 06997400
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997402
         HTBL  4040,4040,4040,4040,4180,4181,4182,4183         @SC91325 06997404
         HTBL  4184,4185,4186,4187,4188,4189,418A,418B         @SC91325 06997406
         HTBL  418C,418D,418E,418F,4190,4191,4192,4193         @SC91325 06997408
         HTBL  4194,4195,4196,4197,4198,4199,419A,419B         @SC91325 06997410
         HTBL  419C,419D,419E,419F,41A0,4040,4040,4040         @SC91325 06997412
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997414
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997416
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997418
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997420
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997422
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997424
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997426
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997428
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997430
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997432
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997434
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997436
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997438
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997440
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997442
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997444
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997446
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997448
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997450
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997452
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997454
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997456
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997458
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997460
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997462
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997464
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997466
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997468
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997470
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997472
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997474
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997476
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997478
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997480
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997482
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997484
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997486
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997488
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997490
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997492
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997494
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997496
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997498
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997500
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997502
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997504
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997506
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997508
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997510
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997512
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997514
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997516
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997518
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997520
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997522
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997524
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997526
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997528
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997530
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997532
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997534
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997536
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997538
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997540
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997542
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997544
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997546
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997548
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997550
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997552
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997554
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997556
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997558
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997560
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997562
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997564
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997566
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997568
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997570
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997572
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997574
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997576
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997578
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997580
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997582
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997584
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997586
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997588
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997590
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997592
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997594
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997596
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997598
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997600
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06997602
         HTBL  4040,4040,4867,54D4,557A,46AE,4EF9,45C6         @SC91325 06997604
         HTBL  4F81,5179,4DCE,50D9,50E2,509B,4965,4D60         @SC91325 06997606
         HTBL  4E43,47EC,4E72,4ADD,51F0,50DA,4782,5581         @SC91325 06997608
         HTBL  4C69,50AB,549C,5144,5245,4EF7,49DC,4F8E         @SC91325 06997610
         HTBL  4D7F,4BFB,5448,45A8,4EEB,5489,4BE2,48F1         @SC91325 06997612
         HTBL  5364,504C,50D0,46F6,45B2,47C8,4A9E,4DFB         @SC91325 06997614
         HTBL  4AFA,5147,484F,4C65,5189,4FE0,4763,4FAD         @SC91325 06997616
         HTBL  47E9,4FF7,49D7,558F,4AA9,4975,4880,4E9A         @SC91325 06997618
         HTBL  4DF6,5482,4AEA,5573,49BC,4CDA,4A87,456D         @SC91325 06997620
         HTBL  4F7F,48E9,48AC,49B3,48AA,4541,4EB0,5271         @SC91325 06997622
         HTBL  4AD6,476A,474C,519A,55C8,4C91,4799,52B1         @SC91325 06997624
         HTBL  46CB,4A49,52B9,46DA,4BA3,554E,4EE9,4E8B         @SC91325 06997626
         HTBL  49D8,4CD2,4EAE,5577,55BC,485A,46D5,5099         @SC91325 06997628
         HTBL  478F,55DF,49DD,4C82,4BE7,559E,4DEC,4FB1         @SC91325 06997630
         HTBL  4A89,51A0,50F3,4CDB,55F7,549A,54AB,5255         @SC91325 06997632
         HTBL  5367,466B,4E64,545F,529B,499D,46AB,4ABC         @SC91325 06997634
         HTBL  515F,50A7,5194,48D3,55E8,495E,47AC,4EBC         @SC91325 06997636
         HTBL  45FA,45FB,4F57,50B7,4F52,51B5,5254,5576         @SC91325 06997638
         HTBL  45EE,4780,51C1,4D6F,4A45,50CE,4774,49AC         @SC91325 06997640
         HTBL  4873,54E5,46DF,5177,49EB,53B7,4645,47E1         @SC91325 06997642
         HTBL  50A4,52F2,5078,47D0,54DE,55D0,4AD5,4E6F         @SC91325 06997644
         HTBL  49ED,4DAD,53EE,4BDD,5047,4C5A,4BAA,4D54         @SC91325 06997646
         HTBL  504B,4CEC,46E3,49D4,52C3,4743,4DA4,4E82         @SC91325 06997648
         HTBL  55D7,50E6,4792,46E5,4CEA,4895,49E1,4FA3         @SC91325 06997650
         HTBL  45F2,4AA0,5459,49B1,4FFB,546C,50E5,5464         @SC91325 06997652
         HTBL  4AC6,4572,47FD,49E0,454E,45E9,4E6C,5474         @SC91325 06997654
         HTBL  4E77,509A,4BBD,4E67,4E79,4C81,4950,50B8         @SC91325 06997656
         HTBL  484D,455F,4590,4D71,4770,5461,475A,4876         @SC91325 06997658
         HTBL  459F,47C6,477E,497E,4E89,4686,52B8,48ED         @SC91325 06997660
         HTBL  4F46,47B9,4EE8,46F7,465A,4785,4C9A,5286         @SC91325 06997662
         HTBL  5463,4DBE,4F51,46D9,5377,547A,4BA1,4B6C         @SC91325 06997664
         HTBL  4C51,51C3,49D6,52CA,4AEB,535D,488D,4EE4         @SC91325 06997666
         HTBL  4FAA,54C7,4F9D,49DE,53FC,4677,538A,4EBA         @SC91325 06997668
         HTBL  5599,4641,4745,554B,53BE,484B,45BD,47B7         @SC91325 06997670
         HTBL  46A9,5053,4EC8,4BAF,4C60,4E71,5091,5594         @SC91325 06997672
         HTBL  4EF2,4DA0,53A2,488F,52CB,556D,4682,45A7         @SC91325 06997674
         HTBL  4AF5,47AE,4AB0,4AE4,4F7B,5090,46CD,49A9         @SC91325 06997676
         HTBL  49EA,51AC,556A,4694,53E9,4968,5074,528A         @SC91325 06997678
         HTBL  4C42,4F91,5356,4F6D,4BA5,4D8D,546D,559C         @SC91325 06997680
         HTBL  55CC,4B85,55BB,47CE,4AC1,5351,538F,55D6         @SC91325 06997682
         HTBL  55D8,47BA,54AD,48E5,527F,47DE,4B9E,50C0         @SC91325 06997684
         HTBL  4D61,487A,4F5C,4A4C,477D,53CC,4A5A,5162         @SC91325 06997686
         HTBL  4AE9,505A,4AA3,45BE,4D46,4761,47F1,548E         @SC91325 06997688
         HTBL  4AE3,47E0,4B6F,4FB2,49AD,5571,46C2,47D6         @SC91325 06997690
         HTBL  5475,5384,4FC5,47B4,5441,4BA2,48DF,545E         @SC91325 06997692
         HTBL  50FE,4F97,53D5,4F59,5163,4E69,5445,4856         @SC91325 06997694
         HTBL  51BE,52F0,49B2,4ACC,4962,547D,4C54,5242         @SC91325 06997696
         HTBL  4BD3,4F7C,52AB,4B9B,4E5D,49C2,4970,4F98         @SC91325 06997698
         HTBL  4E7B,4B81,4CD7,4B9A,4C7E,4893,52B5,4FAC         @SC91325 06997700
         HTBL  55DE,48C5,49A2,47F8,4A6F,48DA,4DEB,47F7         @SC91325 06997702
         HTBL  4DD3,51A5,49AA,4FCF,4EC1,536D,55B6,4EFB         @SC91325 06997704
         HTBL  4D4E,4EC4,4F58,54BA,53EA,4AB9,4B55,49E3         @SC91325 06997706
         HTBL  4DA2,5287,46F2,4BEC,4CFC,5084,54B6,4C8C         @SC91325 06997708
         HTBL  4C4A,51EE,487E,4E96,49A1,4DA9,4E4E,45C1         @SC91325 06997710
         HTBL  4DD9,45C5,4FFE,4E75,4862,4CAA,467A,49CB         @SC91325 06997712
         HTBL  4748,49CF,4E4C,5447,49A5,45BF,558B,5584         @SC91325 06997714
         HTBL  51A4,539D,48B8,4C57,47D2,4E9F,4B91,45D1         @SC91325 06997716
         HTBL  45FC,46F1,4D69,4F8B,49DF,474A,4AB5,4B57         @SC91325 06997718
         HTBL  5097,4BF2,4D96,4DAB,4B77,468B,4EF1,4EB1         @SC91325 06997720
         HTBL  4579,4982,4A5B,45B9,494C,50D4,4ED8,4AEC         @SC91325 06997722
         HTBL  5264,46DB,55E0,46FB,4794,487F,48D0,4DAA         @SC91325 06997724
         HTBL  4787,53CE,5058,4AC8,47C0,5059,49CA,5395         @SC91325 06997726
         HTBL  4D8B,4F92,48F7,4FCD,517D,4FDC,4CB4,5192         @SC91325 06997728
         HTBL  4598,51C6,5265,4781,5541,46D7,51ED,457E         @SC91325 06997730
         HTBL  55EA,4D6D,534B,4BC2,4B5F,5248,4AA6,55AE         @SC91325 06997732
         HTBL  4AA4,4ADE,4D5C,5260,4BFC,4D56,458A,5085         @SC91325 06997734
         HTBL  4A81,485C,4B98,4592,4B63,47CC,4C5C,50F0         @SC91325 06997736
         HTBL  49A0,50C8,4D4B,5473,48DB,4986,50AA,51CF         @SC91325 06997738
         HTBL  49F3,51FE,4757,4C7B,4973,4ACA,485E,4A52         @SC91325 06997740
         HTBL  4F61,4D77,4B82,527A,4F72,4A9A,4DC2,51E7         @SC91325 06997742
         HTBL  4B78,55AA,48EE,4BAC,4B73,4575,48BC,52EC         @SC91325 06997744
         HTBL  55AD,555A,4971,47B3,51EC,47D7,4D4D,53E2         @SC91325 06997746
         HTBL  4DD5,4C5F,4A95,51B3,46D2,5385,5542,4BD5         @SC91325 06997748
         HTBL  494E,55B1,47A5,4589,4A58,4E5A,4C9E,51BB         @SC91325 06997750
         HTBL  4BE3,5051,466A,5565,4995,4A8D,4A5C,51D5         @SC91325 06997752
         HTBL  4CD5,4DED,4ED9,4E53,4C83,456B,488B,49B6         @SC91325 06997754
         HTBL  49B7,45FD,49C0,55E7,4FC9,499F,49AE,4A7D         @SC91325 06997756
         HTBL  4B8E,54CF,4B9D,4CF8,4CD8,4D75,555D,4B8F         @SC91325 06997758
         HTBL  4B97,4DD0,4C73,4AA7,54AF,4D87,4673,4586         @SC91325 06997760
         HTBL  507A,478C,4549,4F63,4C8B,4554,5274,4DE9         @SC91325 06997762
         HTBL  4E4D,4A5F,5353,4CFE,4F85,49FC,47AF,52B2         @SC91325 06997764
         HTBL  5588,4EB9,478D,50C3,55F4,49EC,4BB9,4CB8         @SC91325 06997766
         HTBL  4DA6,4BF0,54B2,4D94,4D44,50A6,4FF8,4DF1         @SC91325 06997768
         HTBL  52E1,4A65,467F,4CE5,4E85,479B,4B69,4879         @SC91325 06997770
         HTBL  4F70,497A,47CF,4998,4BC8,47B1,4897,499E         @SC91325 06997772
         HTBL  53DB,4F6A,53D2,4851,4A43,4C52,4BE8,47E4         @SC91325 06997774
         HTBL  49E6,4CB9,46E6,4C64,4690,4E60,4643,48A8         @SC91325 06997776
         HTBL  4EB6,5175,4DC1,4E49,47B0,4993,49AB,5198         @SC91325 06997778
         HTBL  51B4,4FC7,48FA,4688,4A4A,5373,55EF,4EC9         @SC91325 06997780
         HTBL  53B3,4DF9,45C9,54FB,4AD7,48A6,50FB,4D8E         @SC91325 06997782
         HTBL  4953,4BA9,4D78,49F0,54D9,4A74,4BD0,53C3         @SC91325 06997784
         HTBL  50D6,4FC3,4CB5,47A4,4AC2,4B86,46BF,4B43         @SC91325 06997786
         HTBL  54CC,4561,48B2,52FA,52F1,4681,48F4,4B6B         @SC91325 06997788
         HTBL  4CD3,4FD3,4F49,4AE7,4EC3,4666,47BE,4DC6         @SC91325 06997790
         HTBL  508D,5493,486D,48DC,548A,4AC5,4F45,46D3         @SC91325 06997792
         HTBL  5369,49F6,4552,4B79,45BB,497C,47E5,4E55         @SC91325 06997794
         HTBL  4EC2,4E45,4A6C,4AE5,48B4,4C7D,4695,4574         @SC91325 06997796
         HTBL  4C8E,50A2,4E42,478A,47FC,4C6E,46B7,5563         @SC91325 06997798
         HTBL  53AC,479A,55AB,48AD,54A5,49FA,45D4,4AF6         @SC91325 06997800
         HTBL  4A94,53F2,4EAF,47AD,45F8,536B,45CF,4AF7         @SC91325 06997802
         HTBL  5061,4D52,51DB,5471,4F5A,4CC5,4D63,516D         @SC91325 06997804
         HTBL  4AAB,4EB4,55CB,55BF,4C4D,4EEE,4FAF,4545         @SC91325 06997806
         HTBL  4B74,4D99,45DF,4AEE,47F6,50B5,45E5,4698         @SC91325 06997808
         HTBL  4AB1,52D3,55EE,53F1,4F4E,48E7,4D91,49DB         @SC91325 06997810
         HTBL  5170,4EB5,4FC6,478E,5462,53E3,4CAE,5343         @SC91325 06997812
         HTBL  459E,46BB,4870,4978,51E9,4942,4588,46A5         @SC91325 06997814
         HTBL  51AF,5253,4EF3,5466,469E,4BD9,45F4,46C8         @SC91325 06997816
         HTBL  456A,4CA3,53CB,45A9,45B7,515A,469A,45D3         @SC91325 06997818
         HTBL  47C7,538E,4A67,5045,4CAC,4BC5,4F9F,48B0         @SC91325 06997820
         HTBL  4A6D,508B,48BF,52CC,4796,45AD,4FD4,46EB         @SC91325 06997822
         HTBL  48C6,4A4D,48A0,4CBB,4AEF,4FD5,514B,4B67         @SC91325 06997824
         HTBL  4C78,506D,48CB,499A,4760,50EB,52D5,5247         @SC91325 06997826
         HTBL  51D8,489F,46DC,45A4,4BED,4A6E,4AF1,4E8F         @SC91325 06997828
         HTBL  5052,4D86,4863,51B9,46A1,549B,49E5,4A97         @SC91325 06997830
         HTBL  46BD,4571,4DD6,49C7,54C6,48E2,45A0,55B9         @SC91325 06997832
         HTBL  55B5,5380,4C68,50A9,5261,479E,4BF5,4954         @SC91325 06997834
         HTBL  458F,4E94,51EB,50FD,4679,4E95,54D0,4BA4         @SC91325 06997836
         HTBL  5495,5056,549D,4AA5,50DC,4841,4D4C,4946         @SC91325 06997838
         HTBL  45E0,4B44,53A6,5488,4A77,53B8,4EA4,54E8         @SC91325 06997840
         HTBL  4FE7,4667,5359,4B46,53FD,4CBD,55B4,50A8         @SC91325 06997842
         HTBL  55DC,4576,50A5,51B8,4ED3,485B,498B,4773         @SC91325 06997844
         HTBL  4EAD,5188,495B,5176,4D70,4F8A,4E8D,48B1         @SC91325 06997846
         HTBL  548F,4B58,4C43,48EB,46F5,4A6B,53C1,49A3         @SC91325 06997848
         HTBL  4ED4,4DCD,49F1,4B4F,4DE0,48E4,4769,4CBC         @SC91325 06997850
         HTBL  53BF,5354,4CC3,54B4,4C71,47DB,4768,4BA8         @SC91325 06997852
         HTBL  49BD,4D6E,4797,4766,47CD,46BC,4C4E,49AF         @SC91325 06997854
         HTBL  50C9,45EC,4591,4A7C,4B52,5451,4CDE,457F         @SC91325 06997856
         HTBL  46A3,52D2,50AF,4594,4A90,4F50,50A3,48E8         @SC91325 06997858
         HTBL  4FA4,51F1,5499,46C9,4CF4,50B1,4771,5391         @SC91325 06997860
         HTBL  496E,5457,4EA1,48CF,4B93,4F9E,4C77,4FD6         @SC91325 06997862
         HTBL  48F9,49E9,4CF1,4A8A,52A4,4FE4,557D,55D2         @SC91325 06997864
         HTBL  4EB7,4DC7,54C3,4543,509C,48D2,4565,506E         @SC91325 06997866
         HTBL  53DE,4AC9,51F3,54CE,5399,45C0,4843,55EB         @SC91325 06997868
         HTBL  4F5D,516B,4DEE,4899,55B3,4EFC,5093,4992         @SC91325 06997870
         HTBL  48B5,5465,508A,48B6,4BC0,45F0,47D9,4B5E         @SC91325 06997872
         HTBL  4544,467D,4990,4CC1,4B42,4564,55BA,4553         @SC91325 06997874
         HTBL  4A44,4661,46AD,47B6,477B,4FF2,4EA5,4888         @SC91325 06997876
         HTBL  4D6A,4672,48D8,4999,488E,519F,4FEB,46C3         @SC91325 06997878
         HTBL  46C7,4680,4AF0,5382,4874,4A48,4A50,4E90         @SC91325 06997880
         HTBL  4CB0,4948,4B76,4F9C,4650,4F94,52B7,4A8F         @SC91325 06997882
         HTBL  4A9F,45CE,4BBC,4FC2,469F,48F2,46A0,4CBE         @SC91325 06997884
         HTBL  46D8,4651,4597,4857,4584,4C79,5249,5182         @SC91325 06997886
         HTBL  4A62,4853,51E6,4CAB,45C3,4FE3,4D74,506A         @SC91325 06997888
         HTBL  4697,468F,4A75,50BA,545C,4BA6,4C75,52A5         @SC91325 06997890
         HTBL  4547,5042,4D57,4941,53E0,47B8,5469,4C90         @SC91325 06997892
         HTBL  4DAE,5142,46EC,45ED,52BD,4875,54D2,47A7         @SC91325 06997894
         HTBL  4972,55C0,5496,4F6B,4C58,48C4,498A,4BB3         @SC91325 06997896
         HTBL  5151,4BD1,4C4C,4663,4F47,4670,4DBB,4653         @SC91325 06997898
         HTBL  5458,4FEA,4EB8,4AD0,5470,4C6B,54C1,546A         @SC91325 06997900
         HTBL  53A9,52BB,4D79,5257,46D6,4FE9,4B6E,5472         @SC91325 06997902
         HTBL  4762,46A6,46F0,45CB,4D42,4865,4A7B,4B99         @SC91325 06997904
         HTBL  4692,51CE,4CED,4758,49BE,546F,484C,548D         @SC91325 06997906
         HTBL  46B2,4C61,46CF,51A3,47FB,5065,4791,48A1         @SC91325 06997908
         HTBL  47DD,4BEE,4741,46DE,5282,4DD7,4B72,45F1         @SC91325 06997910
         HTBL  4658,49F4,52DA,4A69,4DB3,4BB8,4F93,4B88         @SC91325 06997912
         HTBL  4DDF,53FE,52F6,55A6,4AD3,5548,5149,47A0         @SC91325 06997914
         HTBL  536F,53D9,46E0,48C9,454A,48FB,517F,4DEA         @SC91325 06997916
         HTBL  4D84,4892,4F65,4E93,45A3,4CE2,4FA5,54DD         @SC91325 06997918
         HTBL  4882,4ABF,4CEB,49F7,4FC8,5279,4EBF,459B         @SC91325 06997920
         HTBL  486C,4A9C,4660,5072,4662,4DB0,546B,4FB8         @SC91325 06997922
         HTBL  4CC0,4F80,4EF5,4D67,4FAE,53A4,4894,46CE         @SC91325 06997924
         HTBL  4AD2,5082,47A6,4D47,526E,51A9,47B2,48E6         @SC91325 06997926
         HTBL  474B,458C,4FBE,5152,50E4,50C1,4A9B,4C99         @SC91325 06997928
         HTBL  479D,53F9,55E2,47E2,4671,50F5,4699,4D4F         @SC91325 06997930
         HTBL  50B3,5298,52C0,496D,4C5B,4AA2,45B5,4E6B         @SC91325 06997932
         HTBL  4E47,4F86,5568,46BE,4D43,54EC,4ECA,53AF         @SC91325 06997934
         HTBL  5498,52EF,4959,455D,484A,4871,4850,4AED         @SC91325 06997936
         HTBL  5562,4964,4C48,4EC0,4BFD,4EEC,4D8F,46FE         @SC91325 06997938
         HTBL  46D1,45B3,4AF8,4578,50AC,539B,5585,46C6         @SC91325 06997940
         HTBL  486B,4AC0,5155,4983,4DE6,4742,4E4A,4847         @SC91325 06997942
         HTBL  4976,51B0,49F9,4BDF,476E,49B5,4BD4,4CE4         @SC91325 06997944
         HTBL  5267,5180,53F8,53A8,4DA5,4FA8,50EF,49BA         @SC91325 06997946
         HTBL  4F88,4DE7,4994,4AAD,507F,4FB4,53BD,4CC8         @SC91325 06997948
         HTBL  4BF9,52E7,455E,49D3,4F62,4947,527E,4D85         @SC91325 06997950
         HTBL  45DB,45D9,5196,4DE4,46EF,485F,55F6,475E         @SC91325 06997952
         HTBL  50F4,4CC9,4852,4E54,4E98,4ABA,4B7B,50C2         @SC91325 06997954
         HTBL  4E57,50CA,4F48,4957,4EE5,47C5,4E73,54E6         @SC91325 06997956
         HTBL  489A,48D7,47C3,4CD1,46B8,5347,52E5,49CE         @SC91325 06997958
         HTBL  46F4,45A5,4F8C,4F76,524C,4B59,4987,46E7         @SC91325 06997960
         HTBL  4A76,48F6,4587,4BB2,459D,4D7E,4D41,4777         @SC91325 06997962
         HTBL  4967,54E1,4642,45A1,4C8A,4E59,4A47,4FE5         @SC91325 06997964
         HTBL  545A,4885,4D68,479C,4D5E,4669,4988,4DDE         @SC91325 06997966
         HTBL  4593,4776,4F44,4D89,514F,4D5F,4B66,4FB9         @SC91325 06997968
         HTBL  52C4,50F2,5068,4C84,52CE,52F4,4BC1,46B0         @SC91325 06997970
         HTBL  4BAE,47C1,5178,4FB3,49C4,4BC9,52AF,48D5         @SC91325 06997972
         HTBL  459C,4FCB,526C,4FCC,4F69,4F54,4CF7,4E7C         @SC91325 06997974
         HTBL  5390,54EF,4E76,4B5B,52C5,4C7F,509E,46CC         @SC91325 06997976
         HTBL  52D0,5561,51FB,4ED6,4668,4FED,4753,55E4         @SC91325 06997978
         HTBL  4F64,4C8D,4887,51EF,4B60,469B,465B,5086         @SC91325 06997980
         HTBL  4BBB,52DC,46C4,47EE,4FF1,4A61,466E,45BA         @SC91325 06997982
         HTBL  45C7,477C,47A9,4795,5375,4DCC,4577,4596         @SC91325 06997984
         HTBL  5158,4599,4844,466C,4BB5,496C,457B,4558         @SC91325 06997986
         HTBL  46FD,4FA0,4AE8,53B1,5378,464C,4644,468E         @SC91325 06997988
         HTBL  47C4,55EC,4FDA,4B53,4ED7,5595,5141,4C59         @SC91325 06997990
         HTBL  4AE2,4580,4891,4DFE,4866,535E,4BD2,46F9         @SC91325 06997992
         HTBL  4CCD,5368,507D,4765,525C,47A8,4E8C,498D         @SC91325 06997994
         HTBL  45E2,5169,47A1,4952,49BB,4AF3,5094,53E8         @SC91325 06997996
         HTBL  48A2,47A2,454C,49EE,498F,49FB,53C0,4567         @SC91325 06997998
         HTBL  4764,4DCA,5372,50E3,55DA,46EE,468D,4A4E         @SC91325 06998000
         HTBL  489B,4DC0,5490,5590,4D7B,4E91,518D,4687         @SC91325 06998002
         HTBL  4868,5596,526F,4FC1,467B,4FBF,518E,5566         @SC91325 06998004
         HTBL  50D1,485D,535B,4D48,4CAD,519C,4CE9,45AF         @SC91325 06998006
         HTBL  46B3,4D73,47EF,46B1,4F87,51D4,5076,5160         @SC91325 06998008
         HTBL  5062,4EC6,54B9,4A60,5166,495F,534C,4ECF         @SC91325 06998010
         HTBL  55B0,5171,4C9C,4CDC,4D83,4D59,479F,46B9         @SC91325 06998012
         HTBL  4CBF,4CDF,4FEF,544C,50CB,4E84,4BE1,4B71         @SC91325 06998014
         HTBL  53F5,45D6,5168,4C9F,4C53,52DD,524D,4A8E         @SC91325 06998016
         HTBL  51B7,4B68,48B3,4DDD,4DC3,5555,54A3,499B         @SC91325 06998018
         HTBL  46E9,4ED2,4C67,52DB,4DB7,54A1,4C66,4896         @SC91325 06998020
         HTBL  54A4,4678,4BE9,518C,4793,5070,4B89,4842         @SC91325 06998022
         HTBL  4B62,4F79,50B9,505F,4898,4AAA,4744,5143         @SC91325 06998024
         HTBL  5197,4DE8,4DD2,4BBA,464D,4F4A,4DBD,465E         @SC91325 06998026
         HTBL  4C7C,45B8,4A6A,4943,474D,4B6D,4BB0,53A0         @SC91325 06998028
         HTBL  4B4B,4945,46FA,48CD,4E97,476D,4FFD,4ADC         @SC91325 06998030
         HTBL  47CB,4AF2,4A57,4F67,4EFD,4A41,4C5E,4CEF         @SC91325 06998032
         HTBL  4BD8,4556,5455,4755,45FE,45AB,50D2,55E3         @SC91325 06998034
         HTBL  5478,53B0,4D9E,54B8,47EA,55CD,54DB,55C5         @SC91325 06998036
         HTBL  4FE8,4DE5,53DA,4696,5371,4656,498E,5262         @SC91325 06998038
         HTBL  4960,48A3,5081,48FD,5092,4BC3,46F3,4DA1         @SC91325 06998040
         HTBL  5263,529A,52D7,4A54,4AF4,4B49,4F77,4A93         @SC91325 06998042
         HTBL  51DD,50D8,459A,4778,455B,467E,516F,47FE         @SC91325 06998044
         HTBL  4B7A,47A3,52AE,4996,5383,486F,55D5,4E7E         @SC91325 06998046
         HTBL  4BDB,4585,4DD4,4E5C,4AB6,5388,50BE,4FE1         @SC91325 06998048
         HTBL  4DF7,558A,524E,4E41,4F71,4EFE,46A4,47DF         @SC91325 06998050
         HTBL  4EBB,4AB4,4E46,51C8,547E,4BEF,4581,52FE         @SC91325 06998052
         HTBL  5560,4BBE,4B83,48AB,48E3,5063,51C4,4AA1         @SC91325 06998054
         HTBL  4B7F,4D9D,5487,4CA5,53F3,4861,4A82,48EF         @SC91325 06998056
         HTBL  54CA,54A6,55B8,4E9B,53D8,4FA2,48C7,47F0         @SC91325 06998058
         HTBL  4E8E,4AD4,4989,4D6C,4FF5,47ED,457C,4963         @SC91325 06998060
         HTBL  487D,45B0,45C2,5597,4ECE,46A8,45E8,5089         @SC91325 06998062
         HTBL  4DCF,468C,4C6A,54DC,4C6D,52DF,49A8,4D72         @SC91325 06998064
         HTBL  45F5,4B45,4C94,50BB,4D9F,4FB0,4977,5567         @SC91325 06998066
         HTBL  47AA,455C,4869,4D64,464F,4D53,4C98,4BEA         @SC91325 06998068
         HTBL  4944,4BCB,52E9,4F66,5591,48C1,4DF5,538B         @SC91325 06998070
         HTBL  4FDE,49C5,54B0,4A59,4C62,4BCE,4DF3,55F9         @SC91325 06998072
         HTBL  5558,5556,51C7,4DC5,4B92,51E5,48BA,4E86         @SC91325 06998074
         HTBL  4C74,5153,4FDB,4CC7,475C,4C93,55DD,4555         @SC91325 06998076
         HTBL  4E5F,4DA8,55E9,4DB6,4E6E,4689,5570,4A78         @SC91325 06998078
         HTBL  50B4,4E80,4583,4D5B,4779,4EEF,5546,4674         @SC91325 06998080
         HTBL  55F3,4C8F,4D5D,4B4D,4C89,4E61,45DC,5150         @SC91325 06998082
         HTBL  4BA0,4EFA,49D1,54FE,4C47,45E3,4657,52D1         @SC91325 06998084
         HTBL  54CD,4B5C,4EDF,4E8A,4FD8,47F5,4FA1,4DC9         @SC91325 06998086
         HTBL  54AA,4CBA,5446,4949,5077,52EA,5592,4C87         @SC91325 06998088
         HTBL  53D3,4CE3,477A,4E52,48A4,4E70,4F95,5379         @SC91325 06998090
         HTBL  46B6,4F56,4B61,45E7,489C,4B64,48E0,505B         @SC91325 06998092
         HTBL  4C9B,4DE3,4B90,5387,49B9,51E4,534D,5195         @SC91325 06998094
         HTBL  4BA7,47F4,4A80,4DFC,4FC4,5246,55A7,515E         @SC91325 06998096
         HTBL  4D81,5154,4FF4,51AA,4E56,4DCB,5543,4BF3         @SC91325 06998098
         HTBL  4FB7,45EF,4F41,49CC,5041,5497,4747,48F8         @SC91325 06998100
         HTBL  4E7A,54EE,53DF,45D7,47C9,4F5E,468A,48DD         @SC91325 06998102
         HTBL  4854,4A91,55FA,52A7,507B,4752,55C1,4788         @SC91325 06998104
         HTBL  48D9,4849,5589,4563,4582,5050,4EB2,54F6         @SC91325 06998106
         HTBL  486A,537F,53FB,4C6C,4E83,525D,45D2,46E8         @SC91325 06998108
         HTBL  53D4,52C1,48F0,454F,55D3,4D45,514C,4A64         @SC91325 06998110
         HTBL  45DE,4684,4D90,4CD6,4B6A,494B,4BDE,4BE6         @SC91325 06998112
         HTBL  4C50,4BAB,4CCB,52F8,5583,515C,456F,47D1         @SC91325 06998114
         HTBL  5145,4751,528F,4557,4ADA,545D,4EA9,4D65         @SC91325 06998116
         HTBL  55E1,48BD,51D2,4B65,4EF8,465F,5549,5553         @SC91325 06998118
         HTBL  46A7,49D0,4B7C,4884,4881,4CDD,5071,54F0         @SC91325 06998120
         HTBL  4568,49D2,4FE2,4A99,4D7C,4C72,4BDA,52CF         @SC91325 06998122
         HTBL  4AB7,47EB,4E5E,4BCC,48EC,45E4,466D,497F         @SC91325 06998124
         HTBL  48AE,53C2,55DB,4D98,4F9B,4D50,4EAB,54F7         @SC91325 06998126
         HTBL  4550,48C0,4F96,51A1,50F1,47E8,4654,5550         @SC91325 06998128
         HTBL  46A2,4A73,53D0,4AD8,4C97,4ADB,4A4F,47D3         @SC91325 06998130
         HTBL  55D4,50CF,4AFD,54A7,4DA7,54C4,4D5A,4A84         @SC91325 06998132
         HTBL  4F73,535C,55F1,4FDD,4E65,49F2,5598,4CCF         @SC91325 06998134
         HTBL  54F8,517A,50B0,4C56,4E63,45E6,4846,458E         @SC91325 06998136
         HTBL  55A9,549E,51AD,52F9,4B96,4FC0,4B48,4D93         @SC91325 06998138
         HTBL  50A1,4859,50DD,4559,4ADF,4CB1,495A,555E         @SC91325 06998140
         HTBL  4542,4A86,50E1,5186,4ECB,539E,4A42,51B6         @SC91325 06998142
         HTBL  51D9,4562,4A98,4665,4BF8,4CC6,4FDF,4A55         @SC91325 06998144
         HTBL  5043,4BD7,4A7E,507E,50FA,4F89,4FA9,544E         @SC91325 06998146
         HTBL  4FD0,47D5,4560,4AAE,54C0,5348,49D5,4BF7         @SC91325 06998148
         HTBL  4B9F,5564,45D8,4DF4,5190,4BCD,4ACE,49E2         @SC91325 06998150
         HTBL  474F,4CB3,535F,4845,53EB,55A2,4E7D,4EE3         @SC91325 06998152
         HTBL  4E62,4BFA,5280,46CA,4A72,529F,4ABE,4ECC         @SC91325 06998154
         HTBL  5579,5442,4664,4CE1,4BC7,4EE2,4CFA,4B8A         @SC91325 06998156
         HTBL  4C63,53BA,556F,4AB2,504E,4EF4,47F3,4AC4         @SC91325 06998158
         HTBL  4DAC,4D80,4798,52B3,54EA,54D6,4974,4775         @SC91325 06998160
         HTBL  4F4F,55C3,4FCA,55BD,508F,55C9,494A,49A6         @SC91325 06998162
         HTBL  5481,45F6,4FBA,4980,4DB8,4659,4EE0,4C4B         @SC91325 06998164
         HTBL  4B87,4A92,49EF,52A6,508E,4AD9,52E6,54B3         @SC91325 06998166
         HTBL  55E5,4AE0,4BB6,4AFB,52BF,505C,4B41,4D9B         @SC91325 06998168
         HTBL  51C5,48DE,4E50,478B,49FE,4548,4EA8,54FA         @SC91325 06998170
         HTBL  464B,51FA,4CF6,50F6,4F82,4A85,52F5,5172         @SC91325 06998172
         HTBL  4D95,5582,4F6F,55C2,4ED5,49C9,495C,4790         @SC91325 06998174
         HTBL  47F9,55B2,4F75,4DC8,52E4,46B4,556E,505E         @SC91325 06998176
         HTBL  4ABD,4CA7,5066,4EDC,4759,4956,4FF6,4A5D         @SC91325 06998178
         HTBL  49E8,5346,54A0,5557,46B5,52A8,4CB6,48B9         @SC91325 06998180
         HTBL  4890,4B9C,52F7,53A5,55ED,53AD,4C4F,51A2         @SC91325 06998182
         HTBL  558D,4772,4C9D,50AD,4C76,4FA6,4B80,474E         @SC91325 06998184
         HTBL  51FD,4D97,49DA,517B,4C70,537D,55A5,497B         @SC91325 06998186
         HTBL  4B8D,55F2,46D0,4CC4,48E1,488A,494F,51AB         @SC91325 06998188
         HTBL  46AC,45C8,4B5D,525E,53D7,52A3,52BC,457D         @SC91325 06998190
         HTBL  4CFD,52D9,5087,4FD1,4EA0,509D,45E1,5060         @SC91325 06998192
         HTBL  48CC,526A,52E0,47CA,559A,4AC7,55AC,4D55         @SC91325 06998194
         HTBL  4AB3,4855,4FB5,454B,55A1,4DB1,5159,4966         @SC91325 06998196
         HTBL  4CA4,4FBC,5452,4DBF,46C0,49FD,5593,55AF         @SC91325 06998198
         HTBL  4BCF,49BF,4DBA,4AB8,53F0,55BE,5259,4E66         @SC91325 06998200
         HTBL  546E,45D0,4E88,519D,45EA,55D1,4DA3,50D7         @SC91325 06998202
         HTBL  53AB,4647,4CD4,46AF,475D,517E,4573,496F         @SC91325 06998204
         HTBL  45AC,4878,476B,4551,4EF0,4D7A,4951,51C2         @SC91325 06998206
         HTBL  49F8,4A8C,45CC,4FD9,4D62,5191,4EBD,4E4F         @SC91325 06998208
         HTBL  49C8,4FA7,50EE,4786,4B8C,53B9,51E1,45B1         @SC91325 06998210
         HTBL  4A63,5547,51D3,4595,4D76,5295,47E7,50E0         @SC91325 06998212
         HTBL  5491,4A83,4B4E,4A70,4A5E,47D4,458B,4CA0         @SC91325 06998214
         HTBL  4B51,4DF2,48EA,54AC,4981,4EAA,4BE5,4652         @SC91325 06998216
         HTBL  528D,45B4,53E5,4E6D,5289,4FFC,54B7,544F         @SC91325 06998218
         HTBL  4EDD,489E,5492,4FF3,4F90,45CA,48BB,50C5         @SC91325 06998220
         HTBL  4B94,4649,539F,4E7F,458D,50CD,4A7F,487C         @SC91325 06998222
         HTBL  54D1,4B7D,5157,466F,4CD9,5578,4B95,537E         @SC91325 06998224
         HTBL  4DF8,46DD,5572,556C,559B,5049,476F,4767         @SC91325 06998226
         HTBL  4FB6,484E,45D5,48D6,505D,4B4C,48CE,549F         @SC91325 06998228
         HTBL  4B47,548B,45AA,4E5B,5363,53CF,4C41,47D8         @SC91325 06998230
         HTBL  4D58,496A,4A68,48D4,4AE1,4EBE,52E3,5161         @SC91325 06998232
         HTBL  4AFE,4969,4F4C,516A,5569,50F9,4AA8,5073         @SC91325 06998234
         HTBL  49B8,4DB2,494D,48FE,4AAC,4F5F,554F,4C86         @SC91325 06998236
         HTBL  5285,48AF,45CD,4BC4,464A,4E87,5587,4CC2         @SC91325 06998238
         HTBL  49E4,50B6,4683,50DB,5088,4ECD,51BA,4A71         @SC91325 06998240
         HTBL  4648,46C5,5449,4D49,4EA6,518A,4F6C,4CCE         @SC91325 06998242
         HTBL  4EE7,5199,4C55,50EC,4C85,4C45,4EA3,47DC         @SC91325 06998244
         HTBL  4CB2,47BB,504A,4B5A,4F8F,4877,4CFB,4EF6         @SC91325 06998246
         HTBL  4F4D,5064,4872,5183,47BC,53E1,4EB3,455A         @SC91325 06998248
         HTBL  4ABB,51C0,4AFC,4EC7,4EA2,487B,4A96,52BE         @SC91325 06998250
         HTBL  534A,54B1,5075,4F42,469D,496B,5284,4566         @SC91325 06998252
         HTBL  51F6,4DE1,5057,48D1,49B4,4DE2,48A7,4EAC         @SC91325 06998254
         HTBL  4BDC,559D,49D9,49F5,55F0,4DB9,4CCA,4D8A         @SC91325 06998256
         HTBL  4F78,55CE,5054,53C6,4D88,4FFA,4B4A,48F5         @SC91325 06998258
         HTBL  51E0,4746,53EC,49CD,5290,4D9A,4EEA,454D         @SC91325 06998260
         HTBL  4DDB,475B,4F6E,557B,477F,49C6,4DB4,4AE6         @SC91325 06998262
         HTBL  4CCC,50D5,4A56,53A1,4C88,4F9A,47FA,5079         @SC91325 06998264
         HTBL  4A66,53C9,4756,4E6A,46ED,4B8B,475F,4AAF         @SC91325 06998266
         HTBL  50ED,4E48,557E,4DFD,5454,4B54,5467,45F3         @SC91325 06998268
         HTBL  49B0,45A6,4B84,4E58,4DDC,4B70,558C,55B7         @SC91325 06998270
         HTBL  4EE6,4B56,55CA,489D,556B,4691,555F,55F5         @SC91325 06998272
         HTBL  4864,4646,554D,4F83,46E2,4A51,5080,4A53         @SC91325 06998274
         HTBL  4FEC,5095,54BD,456C,4DBC,4675,51A6,5297         @SC91325 06998276
         HTBL  50BF,53AE,4C44,4FF0,4DEF,46E4,5554,4CF9         @SC91325 06998278
         HTBL  46AA,4F5B,4749,5146,48C8,5096,4E99,4569         @SC91325 06998280
         HTBL  47E6,46C1,5352,495D,47BD,46E1,4BAD,4CA1         @SC91325 06998282
         HTBL  48C3,46EA,4C95,5241,5098,53C8,465C,53AA         @SC91325 06998284
         HTBL  4E9C,4693,4BE0,4CE6,47DA,469C,46D4,4F7A         @SC91325 06998286
         HTBL  525F,4DD8,507C,4CF2,4685,4EE1,4FBD,4F7D         @SC91325 06998288
         HTBL  504F,53DD,467C,488C,46F8,4ACB,4A8B,4C92         @SC91325 06998290
         HTBL  4CB7,4570,48C2,4AC3,47C2,49C1,4789,4D8C         @SC91325 06998292
         HTBL  506C,4D4A,54DA,4DAF,53D1,4889,4C5D,4C46         @SC91325 06998294
         HTBL  4F7E,514E,4BFE,51D7,4848,45DA,48BE,529D         @SC91325 06998296
         HTBL  45B6,49A7,4AD1,52A0,45F9,5083,4655,4D7D         @SC91325 06998298
         HTBL  4CA8,52F3,47BF,4979,53F4,4D66,4BF6,55D9         @SC91325 06998300
         HTBL  4B7E,4D9C,4DB5,4A88,4DFA,51D6,4F43,4676         @SC91325 06998302
         HTBL  52C9,4A7A,4BD6,5450,4CE7,47F2,50BD,4BBF         @SC91325 06998304
         HTBL  4CF5,498C,4EDE,55A3,4EED,4CA6,4ED0,45BC         @SC91325 06998306
         HTBL  50C6,4CA2,4E51,4858,45EB,528C,5174,49A4         @SC91325 06998308
         HTBL  544D,476C,4997,4961,4991,4783,45DD,559F         @SC91325 06998310
         HTBL  55E6,4CF0,5185,46FC,4DC4,50F7,47AB,4984         @SC91325 06998312
         HTBL  4CA9,465D,49E7,48CA,557C,4C49,4ACF,5250         @SC91325 06998314
         HTBL  4BB1,499C,4D82,4883,5344,4C7A,464E,4E44         @SC91325 06998316
         HTBL  4E74,4E9D,4BB7,527D,5296,4EC5,45C4,5181         @SC91325 06998318
         HTBL  526B,47B5,50C7,4ACD,45F7,48A5,4D51,4F55         @SC91325 06998320
         HTBL  45A2,52C7,4A79,5453,4CD0,48B7,4CE0,554C         @SC91325 06998322
         HTBL  519B,508C,4BEB,4DDA,5148,46BA,49C3,544A         @SC91325 06998324
         HTBL  4A46,48FC,4D92,4CE8,509F,4AF9,4958,5559         @SC91325 06998326
         HTBL  45AE,5545,5069,4F4B,4CF3,4C80,50CC,4955         @SC91325 06998328
         HTBL  4BB4,4E68,4DD1,4F60,4EDB,4BCA,555B,54E0         @SC91325 06998330
         HTBL  4C6F,5270,4860,53CA,4BF4,4754,4FE6,4B50         @SC91325 06998332
         HTBL  51F4,5586,497D,55F8,4784,4BC6,48A9,50F8         @SC91325 06998334
         HTBL  4EA7,54BF,486E,52BA,55C7,4A9D,50C4,55C4         @SC91325 06998336
         HTBL  506F,4CEE,4985,53E4,52A1,456E,4546,519E         @SC91325 06998338
         HTBL  50AE,557F,4886,48F3,4FF9,457A,4750,558E         @SC91325 06998340
         HTBL  5067,47E3,4E78,4FD2,4BF1,50E8,4BE4,5293         @SC91325 06998342
         HTBL  50D3,4FBB,50DE,5468,4D6B,545B,4CAF,4040         @SC91325 06998344
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06998346
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06998348
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06998350
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06998352
         HTBL  4040,4040,4040,4040,4040,4040,4040,4040         @SC91325 06998354
         HTBL  4040,4040,5641,5642,5643,5645,5646,5647         @SC91325 06998356
         HTBL  54C8,5648,5649,564A,564B,564D,564E,5355         @SC91325 06998358
         HTBL  564F,61DB,5651,5650,5652,5167,5653,5654         @SC91325 06998360
         HTBL  5655,5656,5657,5658,5659,565A,565B,565C         @SC91325 06998362
         HTBL  565E,565F,5660,5661,5341,5663,5667,5668         @SC91325 06998364
         HTBL  566F,5669,566B,566C,51E2,5672,5673,5676         @SC91325 06998366
         HTBL  5677,5679,567A,4F8D,567C,567D,567E,5675         @SC91325 06998368
         HTBL  567F,53C4,5680,5681,5682,5683,5684,5685         @SC91325 06998370
         HTBL  5687,5688,5689,568B,568C,568D,568E,568F         @SC91325 06998372
         HTBL  5664,51F8,5690,5692,5693,5695,5696,5697         @SC91325 06998374
         HTBL  5699,569A,569B,56AC,569C,569D,569E,569F         @SC91325 06998376
         HTBL  56A0,56A5,56A6,56A7,56A9,56AA,56AB,56AD         @SC91325 06998378
         HTBL  56AE,56AF,56B0,56B1,52D4,56B3,56B4,56B6         @SC91325 06998380
         HTBL  56B7,56B8,56B9,56BA,56BB,56BC,56BD,56C1         @SC91325 06998382
         HTBL  56BF,56C0,56BE,56C2,56C3,56C4,56C5,56C6         @SC91325 06998384
         HTBL  56C7,56C8,56CB,56CA,56CC,56CD,605D,56CF         @SC91325 06998386
         HTBL  56D0,56D1,56D2,56D3,56D4,56D5,56D6,56D7         @SC91325 06998388
         HTBL  56D8,56D9,56DA,56DB,56DD,56DE,56DF,56E0         @SC91325 06998390
         HTBL  56E1,56E2,56E3,56E4,56E5,56E6,56E7,56E9         @SC91325 06998392
         HTBL  56EA,56EB,56EC,56ED,62D1,56EE,56F0,56F1         @SC91325 06998394
         HTBL  56F2,56F3,56F4,56F5,56F6,54E3,56F8,56F9         @SC91325 06998396
         HTBL  56FA,56FB,56FC,5741,56FD,56FE,51AE,5742         @SC91325 06998398
         HTBL  5743,5745,5747,5748,5746,5749,574A,574B         @SC91325 06998400
         HTBL  5580,574D,5744,574C,574E,64EC,64ED,5751         @SC91325 06998402
         HTBL  5752,5753,5754,5755,5757,5392,5759,575A         @SC91325 06998404
         HTBL  575B,66DB,575C,575D,575E,575F,5760,5762         @SC91325 06998406
         HTBL  5764,5765,5766,5767,5768,5769,576A,576C         @SC91325 06998408
         HTBL  576D,576E,576F,5770,5771,5773,5772,5775         @SC91325 06998410
         HTBL  5774,5776,5777,5779,577A,577B,52C8,577E         @SC91325 06998412
         HTBL  577D,577F,5781,5782,5783,5784,5785,5786         @SC91325 06998414
         HTBL  5788,5789,578A,6688,578C,578D,578F,5790         @SC91325 06998416
         HTBL  5791,5792,5793,5794,5795,5796,5797,5798         @SC91325 06998418
         HTBL  5799,579A,579B,579C,579D,579E,579F,57A0         @SC91325 06998420
         HTBL  57A1,57A2,57A3,57A4,57A5,57A6,57A7,57A8         @SC91325 06998422
         HTBL  57AA,57AB,57AC,57AD,57AF,57B2,57B3,57B4         @SC91325 06998424
         HTBL  57B5,57B6,57B8,57B9,57BA,57BB,57BC,57BE         @SC91325 06998426
         HTBL  57B0,57B7,57BF,57C1,57C2,57C3,57C4,57C5         @SC91325 06998428
         HTBL  57C6,547C,57C7,57C8,57C9,57CA,57CB,57CC         @SC91325 06998430
         HTBL  57CD,57CE,57CF,57D0,57D1,57D2,57D3,57D4         @SC91325 06998432
         HTBL  57D5,57B1,57D6,57D7,57D8,57D9,57DA,57DB         @SC91325 06998434
         HTBL  57DC,57DD,57DF,57E0,57E1,57E2,52A2,57E3         @SC91325 06998436
         HTBL  57E4,57E5,57E6,57E7,57E8,57EA,57EB,57EC         @SC91325 06998438
         HTBL  57ED,57EE,57EF,57E9,57F0,57F1,57FB,547F         @SC91325 06998440
         HTBL  57F2,57F3,57F4,57F5,57F6,57F8,57F9,57FA         @SC91325 06998442
         HTBL  57F7,57FE,5841,5842,57FC,57FD,5843,5844         @SC91325 06998444
         HTBL  5845,5846,5848,5849,584A,584B,584C,5847         @SC91325 06998446
         HTBL  584D,584F,584E,5850,5851,5852,5266,5853         @SC91325 06998448
         HTBL  5854,5855,5856,51BD,5857,54E7,5859,585A         @SC91325 06998450
         HTBL  5858,585B,585C,51D1,585D,585E,585F,5861         @SC91325 06998452
         HTBL  5862,5398,5871,5864,5865,5866,5867,5868         @SC91325 06998454
         HTBL  5869,586B,586A,586D,53CD,586E,586F,5872         @SC91325 06998456
         HTBL  5874,5875,5878,5876,5879,587A,587B,53A7         @SC91325 06998458
         HTBL  5886,587C,587E,587D,5883,587F,5881,5880         @SC91325 06998460
         HTBL  5884,5885,588D,5887,5888,588E,5895,5552         @SC91325 06998462
         HTBL  5889,588B,588F,5890,5891,5892,5893,5894         @SC91325 06998464
         HTBL  5899,5896,5898,5897,589A,589B,589C,589D         @SC91325 06998466
         HTBL  589E,5275,589F,58A0,58A2,58A3,58A4,58A5         @SC91325 06998468
         HTBL  58A6,58A7,58A8,58A9,58AA,604E,58AB,58AC         @SC91325 06998470
         HTBL  518F,58AE,58AF,58B3,58B4,58B5,58B6,58B7         @SC91325 06998472
         HTBL  58B8,58B9,58BC,566D,5678,58BD,58BF,58C1         @SC91325 06998474
         HTBL  58C2,5184,58BA,58C3,58C4,58C5,58C6,58C7         @SC91325 06998476
         HTBL  58C8,58CA,58C9,58CB,58CC,58CD,58CE,58CF         @SC91325 06998478
         HTBL  58D0,58D1,58D2,58D3,58D4,58D6,58D7,58D8         @SC91325 06998480
         HTBL  58D9,58DA,58DB,58DC,58DD,58DE,58DF,58E0         @SC91325 06998482
         HTBL  58E1,58E2,58E3,58D5,58E4,58E5,58E6,58E7         @SC91325 06998484
         HTBL  58E8,58E9,58EA,58EB,5258,58EE,58EF,58F0         @SC91325 06998486
         HTBL  58F1,58F2,58F3,58F4,58ED,58F5,58F6,58F7         @SC91325 06998488
         HTBL  58F8,58F9,58FA,58FB,58FD,5244,5941,5945         @SC91325 06998490
         HTBL  51FC,5946,5943,5947,5948,5949,594B,594A         @SC91325 06998492
         HTBL  594C,594D,594E,594F,5950,5952,5953,5954         @SC91325 06998494
         HTBL  5955,515D,5956,5957,5958,5959,595A,5443         @SC91325 06998496
         HTBL  595B,595C,595D,564C,595E,595F,5960,525A         @SC91325 06998498
         HTBL  5961,58BB,5963,5964,5965,596A,5966,5969         @SC91325 06998500
         HTBL  5962,596B,596C,596D,596E,596F,5971,598C         @SC91325 06998502
         HTBL  5972,5973,5974,54F1,5981,5975,5976,5977         @SC91325 06998504
         HTBL  514D,5979,597A,597B,597C,597D,597E,5982         @SC91325 06998506
         HTBL  5983,5985,5986,5988,5989,598A,598B,598D         @SC91325 06998508
         HTBL  598E,5990,5991,4F84,598F,5992,5994,5996         @SC91325 06998510
         HTBL  5281,5998,5999,51DF,599A,599B,4A4B,599C         @SC91325 06998512
         HTBL  599D,599E,599F,59A0,59A1,59A2,54BE,59A3         @SC91325 06998514
         HTBL  59A4,59A5,59A7,59A8,59A9,5483,59AA,59AB         @SC91325 06998516
         HTBL  59A6,59AC,59AD,59AE,6850,59AF,59B0,59B1         @SC91325 06998518
         HTBL  59B2,59B3,59B4,59B5,536C,50E9,59B6,59B7         @SC91325 06998520
         HTBL  59B8,59B9,59BA,59BB,59BC,59BD,59BF,59C0         @SC91325 06998522
         HTBL  59BE,59C1,52D6,544B,59C2,59C3,59D6,59D5         @SC91325 06998524
         HTBL  59C4,59C5,59C6,59C8,59C9,59CC,59CD,59CE         @SC91325 06998526
         HTBL  59CF,59D0,59CA,59D1,59D2,59D3,59D4,59D7         @SC91325 06998528
         HTBL  529C,59D9,59DA,59DB,59DC,59DD,59DE,59DF         @SC91325 06998530
         HTBL  59E1,59E0,59E3,59E2,59E4,59E5,59E6,59E7         @SC91325 06998532
         HTBL  59E9,59EA,59EB,59EC,59ED,59EE,59F0,5276         @SC91325 06998534
         HTBL  59F2,59F3,5A43,59F4,59F5,59F6,59F7,59F8         @SC91325 06998536
         HTBL  59F9,59FA,59FB,59FC,59FD,59FE,5A41,5A42         @SC91325 06998538
         HTBL  5A45,5A46,5A47,5A48,5A49,5A4A,5A4B,5A4C         @SC91325 06998540
         HTBL  5A4D,5256,5A4E,5A4F,5A50,5A52,5544,554A         @SC91325 06998542
         HTBL  5A53,5A54,5A55,5A56,5A58,5A59,5A5A,5A5B         @SC91325 06998544
         HTBL  5A5C,5A5D,5A5E,5A60,5A61,53A3,59EF,5A62         @SC91325 06998546
         HTBL  5A63,5A64,5A66,5A78,5A69,5A6A,5A6B,5A6C         @SC91325 06998548
         HTBL  5A6D,5A6E,5A6F,5A70,5A71,5A72,5A73,5A74         @SC91325 06998550
         HTBL  5A75,5A77,5A7C,5A7A,5A7B,5A7D,51E3,5A7F         @SC91325 06998552
         HTBL  5A80,5A81,5A84,5A85,5A86,5A87,5A89,5A8A         @SC91325 06998554
         HTBL  5A8B,5A8C,5A8D,5A8E,5A8F,5A82,5A90,5A91         @SC91325 06998556
         HTBL  5A83,5A92,5A93,5A95,5A96,5A88,5A97,5A98         @SC91325 06998558
         HTBL  55CF,5A99,5A9A,5A9B,5A9C,5A9D,5A9E,5A9F         @SC91325 06998560
         HTBL  5AAA,5AA0,5AA1,5AA2,5AA3,5AA4,5AA5,5AA6         @SC91325 06998562
         HTBL  5AA7,5AA8,5AAB,5AAD,5AA9,5AAE,5AAC,5AAF         @SC91325 06998564
         HTBL  5AB0,5AB1,5AB2,5AB3,5AB4,5460,5AB6,5AB7         @SC91325 06998566
         HTBL  5AB8,5AB9,5ABA,5ABB,5ABC,5ABD,5ABE,5ABF         @SC91325 06998568
         HTBL  5AC0,5AC1,5AC2,5AC3,5AC4,5AC5,5AC6,5AC7         @SC91325 06998570
         HTBL  5AC8,5ACA,5AC9,5ACB,5ACC,5AD7,5ACD,5ACE         @SC91325 06998572
         HTBL  5ACF,5AD0,5AD1,5AD2,5AE6,5AD4,5B60,5AD5         @SC91325 06998574
         HTBL  5AD6,5345,5AD8,5AD9,5ADB,5ADC,5ADD,5ADE         @SC91325 06998576
         HTBL  5ADF,5AE0,5AE1,5AE2,5AE3,5AE4,5AE5,5AE7         @SC91325 06998578
         HTBL  5AE9,5AE8,5B48,5AEA,5AEB,5AEC,5AED,5AEE         @SC91325 06998580
         HTBL  5AEF,5AF0,5AF1,5AF2,5AF3,5AF6,5AF4,5AF5         @SC91325 06998582
         HTBL  5AF7,5AF8,5AF9,5AFA,5AFC,5AFD,5AFE,5B41         @SC91325 06998584
         HTBL  5B42,5B4C,5B43,5B44,5B45,5B46,5B47,5B71         @SC91325 06998586
         HTBL  5B49,5B4A,5B4B,5B4E,5B4F,5B51,5B4D,5B52         @SC91325 06998588
         HTBL  5B55,5B57,5B58,5B59,5B5A,5B5B,5B5C,5B5D         @SC91325 06998590
         HTBL  5B5E,5B5F,5B56,5B61,5B62,5B63,5B64,5778         @SC91325 06998592
         HTBL  5B65,5B66,5AD3,5B67,5B68,5B76,5B6A,5B69         @SC91325 06998594
         HTBL  5B6B,5B6C,5B6D,5B6E,5B6F,5B70,5B72,5B73         @SC91325 06998596
         HTBL  5B74,5B75,5B77,5B78,5B79,5B7A,5B7B,5B7C         @SC91325 06998598
         HTBL  5B7D,5B7F,5B82,5B80,5B81,51B1,5B83,5B84         @SC91325 06998600
         HTBL  5B85,5B86,5B87,5B88,5B89,5B8A,5B8B,5B8C         @SC91325 06998602
         HTBL  5B8D,5B8E,5B8F,5B90,5B91,5B92,5165,5B93         @SC91325 06998604
         HTBL  5B95,5B94,5B96,5B9A,528E,5B9B,5B9C,5BE0         @SC91325 06998606
         HTBL  5B9F,5193,5BA2,5BA3,51EA,5BA5,5BA6,5251         @SC91325 06998608
         HTBL  5BA9,5BAD,5BAA,50A0,51B2,4FCE,5BAC,5BB0         @SC91325 06998610
         HTBL  5BB1,5BB2,4FAB,4ED1,5BB3,5BB5,5BB7,5BBA         @SC91325 06998612
         HTBL  5243,5BBC,5BBD,5BBE,5BB9,5BBF,5BC0,5BC1         @SC91325 06998614
         HTBL  51CC,5B9E,5BC2,5BC3,5BC4,5BC5,5BC6,54FD         @SC91325 06998616
         HTBL  5BCA,5BCB,5BCD,5BCE,5BCF,5BD0,5BD1,5BD2         @SC91325 06998618
         HTBL  534F,5BD4,5BD3,5BD5,5BD6,5480,5BD7,5291         @SC91325 06998620
         HTBL  5BD9,5BDA,5BDC,5BDD,54DF,5BDE,54F2,5BDF         @SC91325 06998622
         HTBL  5BE1,5BE2,5BDB,5BE4,5BE5,5BE6,5BE7,54C9         @SC91325 06998624
         HTBL  5BE8,5BE9,5BEB,54F3,5BED,5BEE,5BEF,5BF2         @SC91325 06998626
         HTBL  5BF1,5BF4,5BEA,5046,5BF5,5BF6,52DE,5BF8         @SC91325 06998628
         HTBL  5BF7,5BFA,5BFB,5361,52E2,5BFD,5BFC,5C41         @SC91325 06998630
         HTBL  5C42,5C43,5C45,5C46,5C47,4E92,53BC,5C48         @SC91325 06998632
         HTBL  5C49,5C4A,5C4B,5C4C,52C6,5C4D,5C4E,5BFE         @SC91325 06998634
         HTBL  5C44,5C4F,5C50,5C51,5C52,5C61,5C53,5C54         @SC91325 06998636
         HTBL  5C55,5C56,5C57,5C58,5C59,5C69,5C5A,5C5C         @SC91325 06998638
         HTBL  54C2,5C5D,53FA,5494,5C5E,5C5B,5C65,5C62         @SC91325 06998640
         HTBL  5370,5C64,5C63,5C60,5C67,5C68,54E2,5C6A         @SC91325 06998642
         HTBL  54A2,5C6B,5C74,53EF,52ED,5C6D,5C6F,5C70         @SC91325 06998644
         HTBL  5C71,527C,5C72,5C73,5C75,5C6C,5C76,514A         @SC91325 06998646
         HTBL  548C,5C77,5C7A,5C7B,5C7C,5C7D,5C7E,5C7F         @SC91325 06998648
         HTBL  5C81,5C82,5C83,538D,5C88,5476,5C84,5C85         @SC91325 06998650
         HTBL  5C86,53B2,5C87,5C89,5C8A,5C8B,5C8C,5CC1         @SC91325 06998652
         HTBL  5C8D,5C8E,5C8F,53BB,5C80,5C91,5C92,5C93         @SC91325 06998654
         HTBL  5C94,5C95,5C97,5CB7,5C98,5C99,5C9C,5C9D         @SC91325 06998656
         HTBL  5CA8,5C9F,5CA0,5CA1,5CA2,5CA3,5CA4,5CA5         @SC91325 06998658
         HTBL  5CA7,5C96,5CAA,5CAB,5C9E,5CAC,5CAD,5CAE         @SC91325 06998660
         HTBL  5CB0,5CBE,5CB3,528B,5CB4,5CB5,5CB6,5CB1         @SC91325 06998662
         HTBL  5CB8,5CBA,5362,5CB2,5CBB,5CBF,52EE,5CC0         @SC91325 06998664
         HTBL  5CBD,5CC2,5CC3,5CC4,6786,5CC5,5CC6,5CC7         @SC91325 06998666
         HTBL  5CC9,5CC8,5CCA,5CCB,5CCC,5CCD,5CCE,5CCF         @SC91325 06998668
         HTBL  5CD0,5CD1,5CD2,5CD3,5CD4,5CD5,5CD6,5CD7         @SC91325 06998670
         HTBL  5CD8,5CD9,5CDA,5CDB,5CDC,5CDD,5CDE,5CDF         @SC91325 06998672
         HTBL  5CE0,5CE1,5CE3,5CE2,5CE4,5CE5,5CE6,5CE7         @SC91325 06998674
         HTBL  5CE8,5CE9,5CEB,5CEC,5CED,5CEE,5CEF,6851         @SC91325 06998676
         HTBL  5CF0,5CF1,5CF2,5CF3,5CF4,5CF5,5CF7,5CF8         @SC91325 06998678
         HTBL  5CFA,52B4,5CFB,5CFC,5D41,5D42,5D43,5D44         @SC91325 06998680
         HTBL  5D45,5D46,5D47,5D48,5D49,5D4A,54D7,5D4B         @SC91325 06998682
         HTBL  55C6,5D4C,5D4F,5D4D,5D50,5D51,5D52,5D53         @SC91325 06998684
         HTBL  5D54,5D55,5D56,5D57,6370,5D59,5D5A,5D5B         @SC91325 06998686
         HTBL  50BC,52B6,52AC,5D5C,5D5D,5D5E,5D5F,5D61         @SC91325 06998688
         HTBL  5D63,5D64,5D65,5D66,5D67,5D68,5D69,5D6A         @SC91325 06998690
         HTBL  5D6C,5164,5D6D,5D6F,5D71,5D70,5D73,5D75         @SC91325 06998692
         HTBL  5D76,5D77,5D78,5D79,5D7B,5D7C,5D7D,5D7E         @SC91325 06998694
         HTBL  5D81,5D82,5D83,5D84,5D85,5D86,5D6E,5D87         @SC91325 06998696
         HTBL  5D88,5D89,5D8B,5D8C,5D8D,5D8F,5D90,5D91         @SC91325 06998698
         HTBL  5D92,5D94,5D96,5D97,5D98,5DB4,5D99,5D9A         @SC91325 06998700
         HTBL  5D9B,5D9C,5D9D,52A9,5D9E,524A,5D9F,5DA0         @SC91325 06998702
         HTBL  5DA1,5DA2,5DA3,5DA4,5DA5,5376,5DA7,5DA8         @SC91325 06998704
         HTBL  5DA9,5575,5DAA,5DAB,5DAC,5DAD,5DAE,5DAF         @SC91325 06998706
         HTBL  5DB0,5DB1,5DB2,5DB3,5DB5,5DB6,5DB7,5DB8         @SC91325 06998708
         HTBL  5DB9,5DBA,55A0,5DBB,5DBC,5DBD,5DE2,5DBE         @SC91325 06998710
         HTBL  5DC0,5DC2,5DC3,5DC5,5DC6,5DCF,5DC7,5DC8         @SC91325 06998712
         HTBL  5DC9,5DCB,4E4B,5DCC,5DC4,5DCE,5DD0,5DD1         @SC91325 06998714
         HTBL  5DD2,5DD4,5DD3,5055,5DD6,5DCD,5DD9,5DDA         @SC91325 06998716
         HTBL  5DDB,5DDC,5DDD,5DDE,5187,5DDF,5DE0,5DBF         @SC91325 06998718
         HTBL  52B0,5DE4,5DE1,5DE5,5DE6,5DE7,5DE8,5DE9         @SC91325 06998720
         HTBL  5DEB,4FEE,5DEC,5DF7,5DEE,5DEF,52CD,5DF0         @SC91325 06998722
         HTBL  5DF1,5DF2,538C,5DF3,5DF4,5DF8,5DF9,5DFA         @SC91325 06998724
         HTBL  5357,4F68,5E45,5DFE,5E41,5E42,5E43,5E44         @SC91325 06998726
         HTBL  5E46,5E57,5E47,5E48,54BB,5E4A,5E52,5E4C         @SC91325 06998728
         HTBL  5E4D,5E4E,5E50,5E51,5E53,5E55,5E56,5E4F         @SC91325 06998730
         HTBL  5E54,5E58,5E59,5E5B,5E5C,5E5D,537C,5E5E         @SC91325 06998732
         HTBL  5E5F,5E60,5E61,5E62,5E63,5E64,5E65,5E66         @SC91325 06998734
         HTBL  5E67,5E68,5E69,5E6A,5E6B,5E6E,5E6C,5E6D         @SC91325 06998736
         HTBL  5E6F,5E70,5E71,5E72,5E79,5E74,5E76,5E77         @SC91325 06998738
         HTBL  5E78,5E7A,5E7B,5E7C,5E7D,5E7E,5E7F,5E80         @SC91325 06998740
         HTBL  56A1,5E81,5E82,5E83,5E84,5E85,5E87,5E89         @SC91325 06998742
         HTBL  5E88,5E8B,5E8C,5E8E,5E8D,5E90,5E8F,5E91         @SC91325 06998744
         HTBL  5E92,5E93,5E95,5E96,5E97,51CB,5E98,5E9A         @SC91325 06998746
         HTBL  5E9B,5E9C,5E9D,5EA0,5EA3,5EA5,5EC2,5EA9         @SC91325 06998748
         HTBL  5EBE,5EAC,5EA6,5EAF,5EB0,5EB1,5EB2,5EB3         @SC91325 06998750
         HTBL  5EB4,5EB5,5EB6,5EB7,5EB8,5EB9,5EBA,5EBB         @SC91325 06998752
         HTBL  5EBF,504D,5EC1,5EC3,5EC4,5EC5,5EC6,5EA4         @SC91325 06998754
         HTBL  5EC7,5EC8,5EC9,5ECA,5ECB,5ECD,5ECC,5ECE         @SC91325 06998756
         HTBL  5ED0,5ECF,5ED2,5ED3,5ED4,5ED6,5ED7,5ED5         @SC91325 06998758
         HTBL  53E6,5ED8,5ED9,5EDA,5EDB,5EDC,5EDD,5EDE         @SC91325 06998760
         HTBL  5EDF,5EE0,5EE2,5EE1,5EE3,52FD,5EE4,5EE5         @SC91325 06998762
         HTBL  5EE6,5EE9,5EEA,5EEB,5EED,5EEE,5EE8,5EEF         @SC91325 06998764
         HTBL  5EF0,5EEC,5EF1,5EF2,5EF3,5EF4,5EF5,5EF6         @SC91325 06998766
         HTBL  5EF7,5EF8,5EF9,5EFA,5EFB,5EFC,5EFD,5EFE         @SC91325 06998768
         HTBL  5F41,5F42,5F43,5F44,5F45,5F46,5F47,5F48         @SC91325 06998770
         HTBL  5F49,5F4A,5F4B,5F4C,5F4D,5F4E,524F,5F4F         @SC91325 06998772
         HTBL  5F50,5F51,5F52,5F53,5F54,5F55,5F56,5F57         @SC91325 06998774
         HTBL  5F58,5F59,5F5A,5F5C,5F5D,5F5B,5F5E,5F5F         @SC91325 06998776
         HTBL  5F60,5F61,5F63,5F62,5F64,5F65,5F66,5F67         @SC91325 06998778
         HTBL  539A,5F68,5F6A,5F6B,5F6C,5F6D,5299,5396         @SC91325 06998780
         HTBL  4E81,5F6E,5F6F,5F74,5F75,5F76,5F77,5F78         @SC91325 06998782
         HTBL  5F79,5F7B,5F7C,5F7D,5F7E,5F7F,5F80,53F7         @SC91325 06998784
         HTBL  5F81,5F82,5F83,5F84,5F85,5F86,5F88,5F87         @SC91325 06998786
         HTBL  51CA,5F89,5F8A,5F8B,5F8C,5F8D,5F8F,5F90         @SC91325 06998788
         HTBL  5F91,5F92,5F93,5F94,5F95,5F96,5F97,5F98         @SC91325 06998790
         HTBL  5F99,5F9A,5F9B,5F9C,5F9D,5F9E,5F9F,5FA0         @SC91325 06998792
         HTBL  5FA1,5FA2,5FA3,5FA4,5FA5,5350,5FA6,5FA7         @SC91325 06998794
         HTBL  5FA8,5FA9,5FAB,5FAC,5FAD,5FAF,5FB0,50DF         @SC91325 06998796
         HTBL  5FB1,5FB5,5FB4,5FB7,5FB9,5FB8,5FBA,5FBB         @SC91325 06998798
         HTBL  5FBC,5FBD,5FBE,5FBF,5FC0,5FC1,5FC2,5FC3         @SC91325 06998800
         HTBL  5FC4,5FC5,5FC6,5FC7,5FC8,5FC9,5FCA,5FCB         @SC91325 06998802
         HTBL  5FCC,4DF0,5FCD,5FCE,5FCF,5FD0,5FD3,5FD4         @SC91325 06998804
         HTBL  5365,5FD6,5FD7,5FD8,555C,52D8,5FDA,5FDB         @SC91325 06998806
         HTBL  5FDE,4FD7,51F5,5FE0,54F5,5FE1,536A,5FE2         @SC91325 06998808
         HTBL  5FE3,5FE4,5FE5,5FE6,54B5,5FE7,5FE8,5FE9         @SC91325 06998810
         HTBL  5FEA,5FEB,5366,5FEC,50E7,5FED,5FF0,5FEE         @SC91325 06998812
         HTBL  5FEF,5FF1,5FF2,5FF3,5FF5,5FF4,5FF6,5FF7         @SC91325 06998814
         HTBL  5FF8,5FF9,5FFA,5FFB,6041,5FFC,5FFD,5FFE         @SC91325 06998816
         HTBL  6042,6046,6043,6044,6048,6049,6047,6045         @SC91325 06998818
         HTBL  604A,604B,604C,604D,6050,6051,6052,6053         @SC91325 06998820
         HTBL  6054,6055,6056,6057,605B,605C,605E,605F         @SC91325 06998822
         HTBL  6061,6062,6063,53E7,6065,6066,6067,6068         @SC91325 06998824
         HTBL  6064,6069,606F,54D5,606A,6060,606B,606C         @SC91325 06998826
         HTBL  606E,5484,6070,5048,6071,6072,534E,6073         @SC91325 06998828
         HTBL  6074,6075,6076,6077,6078,6079,55A4,607A         @SC91325 06998830
         HTBL  607B,606D,607C,607E,51E8,607F,607D,6080         @SC91325 06998832
         HTBL  6081,6083,6084,4F53,6088,6085,6087,5444         @SC91325 06998834
         HTBL  6089,608B,608A,608C,6086,517C,608D,608E         @SC91325 06998836
         HTBL  608F,6090,6091,6092,6093,6094,6095,6097         @SC91325 06998838
         HTBL  6098,4F99,51F2,6096,609A,609B,609C,52AA         @SC91325 06998840
         HTBL  6099,609D,609E,609F,60A0,60A1,60A2,60A6         @SC91325 06998842
         HTBL  60A3,60A4,60A5,60A7,60A8,60A9,60AA,60AB         @SC91325 06998844
         HTBL  60AC,60AE,51BC,60AF,60B0,60B3,60B1,60B4         @SC91325 06998846
         HTBL  60B2,6788,60B5,60B6,60B7,60B8,52C2,60B9         @SC91325 06998848
         HTBL  60BA,60BB,60BC,60BD,60BE,60BF,60C0,60C1         @SC91325 06998850
         HTBL  60C2,60C3,60C5,60C7,60C8,60C9,5268,60CA         @SC91325 06998852
         HTBL  60CB,60CC,60CD,60CE,60CF,60D0,5374,54ED         @SC91325 06998854
         HTBL  54EB,54D3,60D1,60D2,60D3,60D5,60D6,60D7         @SC91325 06998856
         HTBL  60F3,60D8,60D9,60E8,60DB,60DC,60DD,60DF         @SC91325 06998858
         HTBL  60E0,60E2,60E3,60E4,60E6,60E7,60E9,60EA         @SC91325 06998860
         HTBL  55A8,60EB,60EC,60F2,60ED,60EE,60E5,5BCC         @SC91325 06998862
         HTBL  60F0,60F1,60F5,60F4,60F6,60F7,60F8,60F9         @SC91325 06998864
         HTBL  60EF,6142,60FA,60FB,60FC,60FE,6141,6143         @SC91325 06998866
         HTBL  6144,6145,6146,6147,614B,60DE,6148,6149         @SC91325 06998868
         HTBL  614A,5278,614C,614E,614F,5273,6150,6151         @SC91325 06998870
         HTBL  6152,614D,6153,539C,6154,6155,6156,6158         @SC91325 06998872
         HTBL  54CB,6159,516E,615A,615B,615C,615D,615E         @SC91325 06998874
         HTBL  615F,6160,6162,6161,6163,6164,6165,6166         @SC91325 06998876
         HTBL  6168,6167,6169,616A,616B,616C,616D,616F         @SC91325 06998878
         HTBL  6170,6172,6173,6171,6174,6175,6176,6178         @SC91325 06998880
         HTBL  6179,617A,617B,54F9,617C,617D,617E,617F         @SC91325 06998882
         HTBL  6180,66DA,53DC,6181,6182,6183,54E4,6184         @SC91325 06998884
         HTBL  6185,6186,6187,6188,6189,618A,618B,618C         @SC91325 06998886
         HTBL  618D,5479,618E,618F,6190,6191,6192,6193         @SC91325 06998888
         HTBL  6194,6195,6196,6197,6198,53B6,6199,5292         @SC91325 06998890
         HTBL  619A,619B,619C,619D,619E,619F,61A0,61A1         @SC91325 06998892
         HTBL  61A2,61A3,61A4,5288,61A5,61A6,61A7,61A8         @SC91325 06998894
         HTBL  4C96,61A9,61AA,61AB,6673,61AC,61AD,61AE         @SC91325 06998896
         HTBL  61AF,61B0,61B1,61B2,61B3,61B5,61B6,61B7         @SC91325 06998898
         HTBL  61B8,61B9,61BA,61BB,61BC,61BD,61C1,61BE         @SC91325 06998900
         HTBL  61B4,61BF,61C2,61C4,61C0,61C6,61C3,61C7         @SC91325 06998902
         HTBL  61C8,61C9,61CA,61CB,61CC,61CD,61CF,61CE         @SC91325 06998904
         HTBL  61C5,61D0,61D1,61D2,5173,61D3,61D4,61D5         @SC91325 06998906
         HTBL  61D6,61D7,61D8,5358,62BA,61D9,61DA,61DC         @SC91325 06998908
         HTBL  61DD,61DE,61E0,61E1,61E2,61E3,54AE,61E5         @SC91325 06998910
         HTBL  61E4,61E6,61E7,61E8,61E9,61EA,61EB,61DF         @SC91325 06998912
         HTBL  61EC,61ED,53C5,61EE,61EF,61F0,61F1,61F2         @SC91325 06998914
         HTBL  61F3,61F4,61F5,61F6,61F7,61F9,61FA,61FB         @SC91325 06998916
         HTBL  6244,6260,61FC,61FD,61FE,6241,6242,6243         @SC91325 06998918
         HTBL  6245,6246,6247,6249,624A,547B,624B,624C         @SC91325 06998920
         HTBL  624D,624E,624F,6250,6251,53F6,6252,6262         @SC91325 06998922
         HTBL  6253,6254,6255,6256,6257,6258,6259,5486         @SC91325 06998924
         HTBL  625C,625D,625E,625F,625A,6261,6263,6264         @SC91325 06998926
         HTBL  6265,6266,54E9,6268,626A,626B,626C,626D         @SC91325 06998928
         HTBL  626E,6269,626F,6270,6271,6272,54D8,6273         @SC91325 06998930
         HTBL  6275,6284,629D,6276,516C,6277,6279,629F         @SC91325 06998932
         HTBL  627A,627B,627C,6290,627F,6280,6281,6282         @SC91325 06998934
         HTBL  4B75,6283,627D,6285,6286,6278,6287,6288         @SC91325 06998936
         HTBL  6289,6294,628B,628C,628D,628E,628F,6291         @SC91325 06998938
         HTBL  6292,6293,54A8,6295,6296,6297,6298,6299         @SC91325 06998940
         HTBL  629A,629B,629C,518B,62A0,62A2,62A3,62A4         @SC91325 06998942
         HTBL  62A5,62A6,62A7,62A9,62AA,62AB,62AC,62AD         @SC91325 06998944
         HTBL  62AE,62AF,62B0,62B1,62B2,62B3,62B4,62B5         @SC91325 06998946
         HTBL  62B6,62B7,62B8,62BC,62BD,62BE,62BF,62C0         @SC91325 06998948
         HTBL  62C1,62C2,62C3,62C4,62C5,62C6,62C7,62C8         @SC91325 06998950
         HTBL  62C9,53ED,4EDA,62CA,62CB,62CC,62CD,62CF         @SC91325 06998952
         HTBL  62D0,52FB,62D2,62D3,62D4,62D5,62D6,62D7         @SC91325 06998954
         HTBL  62D9,62D8,62DA,62DB,62DC,62DD,62DE,62DF         @SC91325 06998956
         HTBL  62E0,62E1,62E3,62E4,62E5,62E6,62E7,62E8         @SC91325 06998958
         HTBL  62E9,4F74,62EA,62EB,62EC,62ED,62EE,62EF         @SC91325 06998960
         HTBL  62F0,62F1,62F2,62F3,62F4,62F5,62F6,526D         @SC91325 06998962
         HTBL  62F7,62F8,62F9,62FA,6346,62FB,62FC,62FD         @SC91325 06998964
         HTBL  62FE,6341,6342,6343,6347,6348,6349,634A         @SC91325 06998966
         HTBL  6345,634B,634C,634E,6344,634F,6350,6351         @SC91325 06998968
         HTBL  6352,6353,6354,6355,6356,6357,54F4,634D         @SC91325 06998970
         HTBL  6359,635A,635B,635C,635F,6361,6362,6363         @SC91325 06998972
         HTBL  6364,635D,6358,6365,6360,6366,6367,6368         @SC91325 06998974
         HTBL  636A,636B,636C,6369,636D,636F,636E,6371         @SC91325 06998976
         HTBL  6372,6373,6374,6375,6376,6377,637C,6378         @SC91325 06998978
         HTBL  6379,6385,637A,637B,637D,637E,637F,6380         @SC91325 06998980
         HTBL  6381,6382,6383,54C5,6384,6386,6387,6388         @SC91325 06998982
         HTBL  6389,638A,638B,638C,638D,638E,638F,5349         @SC91325 06998984
         HTBL  6391,6392,6393,6394,6397,6398,639F,6399         @SC91325 06998986
         HTBL  639A,6395,639B,639C,506B,639D,639E,63A0         @SC91325 06998988
         HTBL  63A2,6396,63A3,63A4,63A5,63A7,63A8,63A6         @SC91325 06998990
         HTBL  63A9,63AA,63AB,63AC,63AD,63AE,63AF,63B0         @SC91325 06998992
         HTBL  63B1,63B2,63B3,63B4,63B5,63B6,63B7,63B8         @SC91325 06998994
         HTBL  63BA,63B9,63BB,63BC,5360,63BD,63BE,63BF         @SC91325 06998996
         HTBL  63C0,63C1,63C2,63C3,63C4,63C6,63C7,63C8         @SC91325 06998998
         HTBL  63C9,63CA,63CC,63CD,63CE,63CF,63D0,63D1         @SC91325 06999000
         HTBL  63D2,63D3,63D5,63D6,63D7,63D8,63D9,63DA         @SC91325 06999002
         HTBL  63DB,63DC,63DD,63DE,50B2,63E2,63E3,63E4         @SC91325 06999004
         HTBL  63E0,63E5,63E6,63E7,63E8,63E9,63EA,63EB         @SC91325 06999006
         HTBL  63F0,63F1,63F2,63F3,63F4,63F5,63EC,63F6         @SC91325 06999008
         HTBL  63F7,63F8,63F9,63FA,63FC,63FD,63FE,6441         @SC91325 06999010
         HTBL  5381,63FB,6442,6443,6444,6446,6447,6448         @SC91325 06999012
         HTBL  6449,644B,644C,644D,644E,644A,644F,6451         @SC91325 06999014
         HTBL  6452,6453,6455,6456,6457,6454,6458,6459         @SC91325 06999016
         HTBL  645A,645B,645C,645D,645E,645F,6460,6461         @SC91325 06999018
         HTBL  6462,6463,6464,6466,6467,6468,6469,646A         @SC91325 06999020
         HTBL  646B,646D,6465,646C,646E,646F,6470,6472         @SC91325 06999022
         HTBL  6473,6474,6471,6476,6477,6475,6478,647A         @SC91325 06999024
         HTBL  647B,647E,647F,6480,535A,5574,6482,6481         @SC91325 06999026
         HTBL  6483,6484,6486,686E,6487,6479,6488,6489         @SC91325 06999028
         HTBL  648A,648B,648C,51C9,648F,51DE,6490,6491         @SC91325 06999030
         HTBL  6492,6493,6494,6495,6496,6497,6498,6499         @SC91325 06999032
         HTBL  649A,649B,649C,649D,649E,64A0,649F,64A1         @SC91325 06999034
         HTBL  64A2,64A3,64A4,64A5,64A6,64A7,64A8,64A9         @SC91325 06999036
         HTBL  64AA,64AB,64AC,64AD,64AE,64AF,64B0,64B1         @SC91325 06999038
         HTBL  50FC,64B3,64B2,64B4,64B5,64B7,64B8,64B6         @SC91325 06999040
         HTBL  64B9,64BA,64BB,64BC,64BD,64BE,64BF,64C0         @SC91325 06999042
         HTBL  64C2,64C1,5044,537A,64C5,64C3,64C4,64C6         @SC91325 06999044
         HTBL  64C7,64C8,64CA,64CB,64CC,64CD,64CE,64CF         @SC91325 06999046
         HTBL  64D0,64D2,64D3,64D4,64D7,64D5,64D6,64D8         @SC91325 06999048
         HTBL  515B,64D1,64D9,64DA,64DB,64DC,64DD,64DE         @SC91325 06999050
         HTBL  64DF,64E2,64E0,64E1,64E3,64E4,64E5,64E6         @SC91325 06999052
         HTBL  64E7,64E8,64E9,64EA,64EB,64EE,64EF,64F0         @SC91325 06999054
         HTBL  64F2,64F3,64F4,4E9E,64F5,64F6,64F7,64F8         @SC91325 06999056
         HTBL  64F9,54A9,64FB,64FC,64FE,6541,6542,6543         @SC91325 06999058
         HTBL  6544,6545,6546,5485,6547,64FA,6548,654A         @SC91325 06999060
         HTBL  654B,654C,64FD,654D,654E,654F,6550,6551         @SC91325 06999062
         HTBL  6552,6554,6555,6556,6557,6558,6559,537B         @SC91325 06999064
         HTBL  655B,50EA,655A,655C,51A8,655E,655F,6560         @SC91325 06999066
         HTBL  6561,6562,655D,6563,6565,6568,6569,656A         @SC91325 06999068
         HTBL  656C,656D,656E,656F,6570,6571,6572,6573         @SC91325 06999070
         HTBL  6574,6575,6576,6577,6578,6579,657A,657B         @SC91325 06999072
         HTBL  657C,657D,657E,657F,6580,5252,6581,6582         @SC91325 06999074
         HTBL  6587,6588,6589,6584,51D0,658B,658E,6591         @SC91325 06999076
         HTBL  6592,6594,6596,6597,5269,5393,6599,659A         @SC91325 06999078
         HTBL  659C,659D,65A0,65B1,65A4,65A7,65A2,65AA         @SC91325 06999080
         HTBL  65AE,65AF,65B0,65A9,65B3,65BA,65BB,65B2         @SC91325 06999082
         HTBL  65C0,65C2,65C4,5283,65C7,65CA,65CB,65CD         @SC91325 06999084
         HTBL  65BE,65BF,65CF,52AD,65D1,65D2,65D3,65D4         @SC91325 06999086
         HTBL  65D7,536E,65D9,65DA,65D6,65DC,65DE,65DF         @SC91325 06999088
         HTBL  65E0,65E1,65E2,65E3,65E5,65DB,65E6,65E7         @SC91325 06999090
         HTBL  65E9,65EA,65EC,65ED,51CD,65EE,65EF,5156         @SC91325 06999092
         HTBL  65EB,65F1,65F2,65F3,65F5,65F7,65F9,65FA         @SC91325 06999094
         HTBL  65FB,65FC,6598,65FE,65FD,6641,6643,65F8         @SC91325 06999096
         HTBL  6644,6645,6646,6642,6647,6648,6649,664B         @SC91325 06999098
         HTBL  664C,664D,664E,664F,6650,6651,6652,6653         @SC91325 06999100
         HTBL  6654,6655,6656,6657,6658,6659,665A,665B         @SC91325 06999102
         HTBL  665C,665D,665E,665F,6660,6661,6662,6663         @SC91325 06999104
         HTBL  6664,6665,6666,6667,6669,6668,666A,666F         @SC91325 06999106
         HTBL  666B,5272,666C,666D,666E,6670,6671,6672         @SC91325 06999108
         HTBL  6675,6676,6677,667B,667A,667C,667D,667E         @SC91325 06999110
         HTBL  6680,6681,6682,6683,6684,6685,5477,525B         @SC91325 06999112
         HTBL  63A1,6687,668E,6686,6689,668A,668B,668C         @SC91325 06999114
         HTBL  668F,6690,6691,6692,6693,668D,6694,6695         @SC91325 06999116
         HTBL  6696,6698,669A,669B,669D,669C,669F,66A0         @SC91325 06999118
         HTBL  66A1,66A6,66A7,66A8,66A9,66AA,53D6,53B5         @SC91325 06999120
         HTBL  66AB,66AC,66AD,66AE,66AF,66B0,5277,66B1         @SC91325 06999122
         HTBL  66B2,66B3,66B4,66B5,66B6,66B7,66B8,66B9         @SC91325 06999124
         HTBL  66BA,66BB,66BC,66BD,66BE,66BF,686F,66C0         @SC91325 06999126
         HTBL  66C1,52FC,66C2,66C3,5456,66C4,66C5,66C6         @SC91325 06999128
         HTBL  66C7,66C8,51DC,66C9,66CA,66CD,66CE,66CF         @SC91325 06999130
         HTBL  66D0,66D1,66D2,66D3,66D4,66D5,66D6,66D7         @SC91325 06999132
         HTBL  66D8,66D9,66DC,66DE,66E0,54BC,66E2,66E3         @SC91325 06999134
         HTBL  66E4,66E7,66E1,66E8,66E9,66EA,66EB,66EC         @SC91325 06999136
         HTBL  66ED,66EE,66EF,66F0,66F1,66F2,66F3,66F4         @SC91325 06999138
         HTBL  52E8,66F5,66F6,66F7,66F8,66FA,66FB,66FC         @SC91325 06999140
         HTBL  66FD,66FE,6741,6742,6743,6744,6745,6746         @SC91325 06999142
         HTBL  6748,6749,674A,674B,674C,674D,674E,6747         @SC91325 06999144
         HTBL  674F,6750,6751,6753,6754,6752,6755,6756         @SC91325 06999146
         HTBL  6757,6758,675A,675B,675C,675D,675F,6760         @SC91325 06999148
         HTBL  675E,6762,6761,6763,6764,6765,6766,6767         @SC91325 06999150
         HTBL  676A,6768,6769,676D,676E,676F,6770,6771         @SC91325 06999152
         HTBL  6772,6773,6774,6775,6776,6777,6778,6779         @SC91325 06999154
         HTBL  677A,677B,677C,677D,677E,677F,6780,6781         @SC91325 06999156
         HTBL  6782,6783,6784,6785,6787,6789,678A,5389         @SC91325 06999158
         HTBL  678B,678C,678D,678E,6790,6792,6794,6795         @SC91325 06999160
         HTBL  6796,6797,6798,6799,679A,679C,679D,679E         @SC91325 06999162
         HTBL  67A0,67A1,67A2,67A3,67A4,67A5,67A6,67A7         @SC91325 06999164
         HTBL  67A8,67A9,67AA,67AC,67AB,5551,67AF,67B0         @SC91325 06999166
         HTBL  67B2,67B3,67B4,67B5,67B6,67B7,67B8,67AD         @SC91325 06999168
         HTBL  67B9,67AE,67BA,67BB,67BC,67BD,67BE,67BF         @SC91325 06999170
         HTBL  67C0,67C1,67C2,67C3,67C4,67C5,67C6,67C8         @SC91325 06999172
         HTBL  67C9,67CA,67CB,54FC,67C7,67CC,67CD,67CE         @SC91325 06999174
         HTBL  67CF,67D0,67D1,67D2,67D7,67D3,67D4,67D5         @SC91325 06999176
         HTBL  67D6,67D8,67D9,67DA,67DB,67DC,67E0,67DE         @SC91325 06999178
         HTBL  67DF,67DD,67E1,5342,67E3,67EA,67E5,67E6         @SC91325 06999180
         HTBL  67E7,67E8,67E9,67EB,67EC,67ED,67EE,67EF         @SC91325 06999182
         HTBL  67F0,67F1,67F2,67F3,67F5,67F6,67F7,67F8         @SC91325 06999184
         HTBL  67F9,67FA,67FB,67FC,67FD,6841,6842,6843         @SC91325 06999186
         HTBL  6844,6845,6846,6847,6848,51F9,6849,684A         @SC91325 06999188
         HTBL  684B,684C,53B4,684D,684E,684F,6852,6853         @SC91325 06999190
         HTBL  51A7,6854,6855,6857,6858,6859,685A,685B         @SC91325 06999192
         HTBL  685C,685D,685E,685F,6860,6861,6862,6863         @SC91325 06999194
         HTBL  6864,6865,6866,6867,6868,6869,686A,686B         @SC91325 06999196
         HTBL  686C,686D,6870,6871,6872,6873,6874,6875         @SC91325 06999198
         HTBL  6876,6877,6878,6879,687A,687B,687C,687D         @SC91325 06999200
         HTBL  687E,687F,6880,6881,6882,6883                   @SC91325 06999202
KJEUCZ   DS    0H                                              @SC91325 06999204
*                                                                       06999206
